3.5.3   24/05/2021  Corrected decode-bp default for NOD recipes via esorex (PIPE-7965)
                    Phase 3 products for telluric standards now have PRO.CATG TELL_* (PIPE-9157)
                    T/C/BUNIT keys for IDP products now satisfy required standard (PIPE-8872)
                    Removed linearity actor from Reflex workflow (PIPE-8867)
                    Updates to pipeline manuals (PIPE-9434, PIPE-9248)
3.5.2   11/12/2020  Correct PROVn keywords for offset data, to allow QC read-in (PIPE-9314)
3.5.1   01/09/2020  SPEC_RES values for Phase 3 products updated to correct values (PIPE-9214)
        19/08/2020  Allow files without ESO DPR TYPE through xsh_lingain (PIPE-8659)
        14/07/2020  EXPTIME in IDPs should only contain time on actual target (PIPE-8857)
3.5.0   22/05/2020  Public Release 2020
3.4.0   07/02/2020  PSO Release
3.4.0b2 21/02/2020  PSO Release Candidate - fixing dark recipe default fpn params (PIPE-8641)
3.4.0b1 14/02/2020  PSO Release Candidate
3.3.9   26/06/2019  Fixed PIPE-7979: Changed FPN in PD
3.3.9   07/06/2019  Fixed PIPE-7979: reduced mask extensions
3.3.8   07/05/2019  Fixed PIPE-7979
3.3.5   18/11/2019  Update to python3
3.3.4   26/04/2019  Pop up no, Fix PIPE-7986
3.3.3   25/04/2019  Updated doc
3.3.2
         23/04/2019 Manual Fixed PIPE-8373
         23/04/2019 Demo, Fixed PIPE-8401
         23/04/2019 Workflow, Fixed PIPE-8400
         14/04/2019 xsh/xsh_detmon_lg.c Fixed PIPE-8344
3.3.1    09/04/2018 Updated version to start to prepare Public release
3.3.0    11/03/2018 Updated version for PSO release
3.3.0b2  22/02/2018 Updated version to candidate PSO release, removed SCI_IMG from reflex oca rules
3.3.0b1  07/02/2018 Updated version to candidate PSO release
3.2.4    04/02/2018 Fixed PIPE-8205, PIPE-8226, PIPE-8201
3.2.3    12/12/2018 changed values of XSH_SLIT_BIN_SIZE_BROAD_SLIT_NIR,XSH_SLIT_BIN_SIZE_AUTO_PIPE_NIR to 0.24 to fix PIPE-8175
3.2.2    02/11/2018 Updated release id to test improvements
3.2.0    06/07/2018 Reelease
3.1.9b3  03/07/2018 typo tutorial
3.1.9b2  02/07/2018 typo tutorial
3.1.9b1  02/07/2018 Update user manual and reflex tutorial with comments from Sabine
3.1.8    01/07/2018 Update doc for release
3.1.7    31/07/2018 Fix residual actions for pub release update (PIPE-7826,PIPE-7894,PIPE-7793,PIPE-7075,PIPE-6985)
3.1.6    17/07/2018 Fix PIPE-7935: NIR flux STD fails more and more
3.1.6    27/06/2018 Fix PIPE-7075
3.1.5    19/06/2018 rolled back (removed) pixel quality ingestion during resampling" xsh_rectify.c
3.1.4    14/06/2018 Injestion bad pixels during resampling
3.1.3    13/06/2018 Merged branch release_320 to head
3.1.2    05/06/2018 "fixed PIPE-7833,7182: clarifying sky extraction ranges and restoring old simmetric limits" xsh/xsh_subtract_sky_single.c
3.1.1    08/05/2018 Fixed computation efficiency (wrong sign atm exctinction) to address PIPE-7836
3.1.1    30/04/2018 Changed extraction slits as indicated by Sabine to fix PIPE-6779
3.1.0    12/04/2018 Public release
3.0.8    10/04/2018 Merged BP scaling project changes
3.0.7    05/04/2018 removed flagging as QFLAG_INCOMPLETE_DATA of bad pixels during simple pixel stacking (crh_multi), as asked by Sabine."
3.0.6    27/03/2018 Do not ingest bad pixels during frame resampling as it creates hairy effects on strong NIR tellurics
3.0.1    28/03/2018 Fix a bug found from Mubashir testing. In xsh_create_wavemap.c (xsh_wavemap_qc)
3.0.0    06/03/2018 Version for April 2018 Paranal release
3.0.0b4  05/03/2018 Version candidate April 2018 Paranal release, Fixed DFS-12378
3.0.0b3  14/02/2018 Version candidate April 2018 Paranal release, Problem reported by Mubashir:  "SKY_MAP_NIR should be declared with DO.CATG, together with the UVB and VIS files"
3.0.0b2  06/02/2018 Version candidate April 2018 Paranal release, fixes also PIPE-7443
3.0.0b1  15/01/2018 Version candidate April 2018 Paranal release
2.9.6    12/01/2018 Fixed PIPE-7307 xsh/xsh_dfs.c. Fixed PIPE-7599
2.9.5    21/12/2017 changed WAVECAL_RANGE_DEFAULT (followarclines-search-window-half-size) to 13 to have correct spectral resolution values" xsh/xsh_parameters.h
2.9.5    12/12/2017 Version including changes to fix PIPE-7170
2.9.4    13/11/2017 Version to test new esoreflex
2.9.3    27/06/2017 Fixed PIPE-7257 "fixed UMR that was creating seg fault on Mac-see PIPE-7257" xsh_rectify.c
2.9.2    23/06/2017 Fixed PIPE-7257 (problem reducing NIR offset data on Mac)
2.9.1    31/05/2017 Fixed PIPE-7250 (problem reducing NIR offset data)
2.9.1    09/05/2017 Fixed PIPE-7200 (problem with product Explorer)
2.9.0    19/04/2017 As 2.8.22 with updated doc for public release
2.8.22   07/04/2017 Preparing pub release like xshoo-2.8.20 (new nodCombine method) adding SKY_MAP_NIR as input of response and scired to prevent flagging of sky lines as CRHs
2.8.21   09/03/2017 Implemnted changes from SDP (PIPE-7096) related to BP flagging/propagation
2.8.20   24/02/2017 Candidate April2017 release
2.8.19   17/02/2017 Fixed PIPE-7035 (changed conventions: if both MRESP and RESP are provided in 
                    input, preference is given to RESP)" 
                    Reflex workflow cosmetics-PIPE-7057
                    Load pyfits properly-PIPE-7055
2.8.19   14/02/2017 Fixed typos configuration files
2.8.18   14/02/2017 Fixed typos xsh_response_slit_nod.c
2.8.17   13/02/2017 Fixed typos in xshoo.prefs found testing DFS-2017
2.8.16   13/02/2017 Fixed PIPE-7034 Master Response should not be input of xsh_respon_* recipes
2.8.15   13/02/2017 Fixed PIPE-6973 Reflex display MRESPONSE if provided in input
2.8.14   09/02/2017 Fixed PIPE-6974 Reflex 2nd demo data set: pseudo-absorbtion line in flux calibrated data
2.8.13   08/02/2017 Fixed PIPE-7001 Pipe fails on xsh_scired_slit_nod UVB data
2.8.12   06/02/2017 Fixed PIPE-6993 xsh/xsh_rectify.c
2.8.11   06/02/2017 Fixed PIPE-6978 (generation of RESPONSE MERGE 1D)
2.8.10   06/02/2017 Tagged version
2.8.10   30/01/2017 Changed nod frame combination (xsh_combine_nod.c) to properly handle bad pixel propagation and combine flux of all contributing frames (including fluxes of flagged pixels) in order to address PIPE-6784
2.8.9    11/01/2017 removed setting to 0 of flux when confidence < 1 in xsh_rectify.c
2.8.8    03/01/2017 Using common m4macro
2.8.8    03/01/2017 Fixed problem on PRO.CATG of on SCI_SLIT_SKY_ORD1D_UVB (1D ord by order frames)
2.8.7    22/12/2016 Fixed reflex problem due to cut of UVB flux calibrated spectrum
2.8.6    22/12/2016 Updated to 2.8.6 to fix PIPE-6130 fitsverify report errors on ORDER1D products
2.8.5    13/12/2016 Updated to 2.8.5 to fix PIPE-6904 wavelength alignment problem in UVB-arm response (and NIR and VIS arm)
2.8.4    26/09/2016 Updated to 2.8.4 to fix PIPE-6779 and PIPE-67797 (changing extraction limits for NOD method)
2.8.3    16/09/2016 Updated to 2.8.3 due to typos in user manual version
2.8.2    13/09/2016 Updated user manual and tagged release
2.8.1    13/09/2016 Updated user manual and tagged release
2.8.1    07/09/2016 Changed error model for MEDIAN assuming the model is error free (fit_err=0)
2.8.0    28/07/2016 Pub release
2.8.0b4  28/07/2016 Added Include of gsl_version.h to finally fix problem compilation mac with gsl2.x
2.8.0b3  27/07/2016 Fixed dufferently problem compilation mac with gsl2.x
2.8.0b2  27/07/2016 Fixed problem compilation mac with gsl2.x
2.8.0b1  26/07/2016 Version for public release
       26/07/2016 Tagging version 2.7.10
       25/07/2016 Fixed PIPE-6725 (Computation QC FLUX MAX on FLAT_IFU_NIR sometimes wrong)
       25/07/2016 Enforce sky_par->niter to be max 3 is sky-method is BSPLINE. Fixed typos in user manual
       24/07/2016 Fixed problems with poly mode (except with stare & BSPLINE)
       24/07/2016 Reduced memory leaks
2.7.10 21/07/2016 Fixed some robustness problems stare BSPLINE, reduced mem leaks, provide IFU_CFG_TAB_arm, update doc
2.7.9  16/07/2016 Fixed several bugs (from Sabine) on workflow when executed with proper flat strategy
2.7.8  14/07/2016 Put back reflex checks for empty sof (no sky, no obj) as it was to prevent problems on scired
2.7.7  14/07/2016 Created version ingesting bad pixels during resampling and using confidence 1
2.7.6  13/07/2016 Created version not ingesting bad pixels during resampling
2.7.5  12/07/2016 Adopted sky sampling data as sky project, reflex fix PIPE-6711,PIPE-6630
2.7.4  06/07/2016 Changing sky region definition for Sabine
2.7.3  04/07/2016 Merged with sky branch SDP project
2.7.2  22/06/2016 Version to test next pub rel (some changes reflex workflow)PIPE-6510,PIPE-6443
2.7.1  31/03/2016 Updated reflex tutorial and pipeline user manual for reflex top page
2.7.1  29/03/2016 Fixed typo oca rules on flexcomp VIS case (BINY for input master bias)
2.7.1  14/03/2016 Fix problems with GSL2.0 gue to changed API for April 2016 public release 
2.7.0  15/02/2016 April 2016 release (with cleaned documentation)
2.7.0b2  10/02/2016 Candidate release for April 2016 release (removed xsh_wkf.oca from xshooc)
2.7.0b1  14/01/2016 Candidate release for April 2016 release
2.6.15 14/01/2016 Fixed values in QUAL extension in IFU
2.6.14 12/01/2016 Increasing ID to have dedicated version to test sky project
2.6.13 11/01/2016 IFU: Fixed typo affecting fix of (PIPE-6298, 6321)
2.6.12 04/01/2016 IFU: change way to resample (and merge) data: use info on confidence parameter. (PIPE-6298, 6321) Also fix WCS cube (PIPE-6299)
2.6.11 08/12/2015 (tagged on 04/01/2016) "fixed PIPE-6339 (XSHOOTER-IFU reduction: stuck at ProductRenamer) by changing offset data reduction" xsh_wkf.oca
2.6.10 03/12/2015  "fixed PIPE-6346, value of cdelt1 in err and qual ext for IDPs" xsh/xsh_data_spectrum.c
2.6.9  04/11/2015  Updated id
2.6.8  14/09/2015  Changes to fix DFS-11239
2.6.7  10/09/2015 
       changed default of ProductExplorerMode from Enabled to Triggered xshooter.xml.in

2.6.6  07/09/2015 
       "updated to fix typo on reflex (FitsRouter) PIPE-6167"
2.6.5  05/08/2015 
       Release
2.6.5b4  04/08/2015 
       Fixed fitsrouter StringParameter usage
       fixed problems with mapping and sky only frames reduced as stare (PIPE-6126, PIPE-6095)
2.6.5b3  03/08/2015 
       Updated oca rules to address PIPE-5375
       Corrected APERTURE value in IDP products to fix PIPE-6077
2.6.5b2  17/07/2015 
       Updated to reflex 2.8 beta5
       code refactoring
       clarify flux and response calibration in user manual`
2.6.5  02/07/2015 
       associate MRESPONSE to inputs scired xsh_wkf.oca xsh_wkf_stare.oca


2.6.4  23/06/2015 
       Made some changes on IFU stare to uniform initial data reduction to SLIT stare (PIPE-4337)
       Made some changes on IFU offset to uniform initial data reduction to SLIT offset (PIPE-5910)
       Fixed PIPE-4898 (Possible error with QC parameter QC.CRRATE in xshooter science products
            added also QC NCRH TOT and QC NPIXSTAT TOT and QC FPIXSAT TOT).6.3  12/06/2015 Updated wkf to 2.8b4
2.6.3  12/06/2015 Updated wkf to 2.8b4
2.6.2  22/05/2015 Updated wkf to 2.8
2.6.21 06/06/2016  Fixed some problems with passing SKY_MAP_NIR to stare (reflex)
2.6.20 12/05/2016  Fixed some problems with flagging line outliers
                   Fixed problems with running response data
                   Fixed reflex problems
2.6.18 20/03/2016  Fixed some problems with S-splicing sky subtraction over object
2.6.17 25/02/2016  Fixed some problems with S-splicing  and use absolute value of data in error formula
2.6.16 15/02/2016  First version including S-splicing (fit_spline7 & fit_spline6)
2.6.14 12/01/2016  Updated ID to be able to test reflex
2.6.4  23/06/2015 
       Made some changes on IFU stare to uniform initial data reduction to SLIT stare (PIPE-4337)
       Made some changes on IFU offset to uniform initial data reduction to SLIT offset (PIPE-5910)
       Fixed PIPE-4898 (Possible error with QC parameter QC.CRRATE in xshooter science products
            added also QC NCRH TOT and QC NPIXSTAT TOT and QC FPIXSAT TOT).6.3  12/06/2015 Updated wkf to 2.8b4
2.6.3  12/06/2015 Updated wkf to 2.8b4
2.6.2  22/05/2015 Updated wkf to 2.8
2.6.1:  5/5/2015
   simplified python script for parameter setting/help
2.6.0-1: all the following went into the release
   fixed PIPE-5840 adding a note in reflex tutorial
   Added note about possible artefacts in the raw data that were due to a strong distortion of the PSF. Spatial aliasing caused additional false signatures when the data were rebinned during wavelength calibration.
2.6.0
   PSO release
2.5.8
   Fixed problems portability jenkins on test-xsh_create_masterbias, test-xsh_create_masterdark
2.5.7
   Fixed linearity computation (and problems unit tests)
   added in decode-bp parameter help most frequent codes (PIPE-5678) 
2.5.6
   Fixed PIPE-5605 (allow empty inputs in reflex workflow)
   "safer definition of temporary files in case of no sky background subtraction (as temporary frames slitmap_frame,wavemap_frame were not created)" recipes/xsh_respon_slit_stare.c
2.5.5
    "fixed bug in using optimised model cfg after AFC correction in NIR (PIPE-5608)" xsh_flexcor.c
    fixed PIPE-5439 (use of proper formula to correct vacuum-air telluric model spectra wave dependency)
    Fixed PIPE-3930 about use of standard error/quality info in fits header
2.5.4 
    To solve a Paranal problem changed OCA rules to classify also AFC in slit mode
    To solve PSO robustness problem "in case specres_stdev is nan re-set specres_stdev to -999 to allow saving of product" xsh_follow_arclines.c

    "changed hsearch from 500 to 200 to improve robustness (PIPE-5369)" xsh_utils_response.c

    Fixed oca rule problem (from Paranal) due to missing check on ORDER_TAB_EDGES input on JH filed case
    Added dependency from HDRL (useful for lingain and CRH)
    Fixed PIPE-5176 (TLAPSE wrong value in case of single input frame)
2.5.3 
    Added flux merged 2d products to reflex_end_products (Andrea Mehner request)
    Fix PIPE-3930, 4145, 5242
    Fixed 2RB generation (Paranal)  problem
2.5.2
    Fix problem displaying IDP products when no flux calibrated spectrum is generated
    Fix problem reducing JH data
2.5.1
    Fix problem in propagating CRHs to final extracted frame (PIPE-5279)
    Fix problem of not subtracting inter-order background in stare mode (PIPE-5282)
2.5.0
    Updated release id
2.4.8
    Fixed problems display if running in stare only with sky frames both in ifu and slit modes
    Fixed problem display interactive windows due to reported warnings
2.4.7
    Added IDP support 
    Fixed bugs on debian (PIPE-5253)
    Fixed path to relevant files in xshooter.xml.in
    Fixed parameter list in IFU reflex wkf
    Added reduction of tell std for IFU reflex wkf
2.4.6
    Fixed problems with reflex reduction of FLUX STD data in IFU mode
    added BINX,Y on BIAS,DARK select-execute rules, ass SIG.FRAME ==1 in FLEX_IFU rules
2.4.5
    Added some missing raw types in oca rules to make work std telluric reduction in IFU mode
    Improved clarity of IFU wkf
2.4.4
    Updated workflow to add interactivity in IFU
2.4.3
    Updated workflow to fix some problems on 1st data set of demo data set
    Updated PSO OCA rules to generate proper bias, dark RBs in case in the template fall all possible read-outs 
    Updated OCA rules to include RESP_FIT_POINTS_CAT_VIS,RESP_FIT_POINTS_CAT_NIR and MRESPONSE_MERGE1D_ARM where appropriate (PIPE-5167)
    Fixed bug in IFU-UVB data reduction due to improper format of comment key during QC computation
2.4.2
    Added preliminary support of IFU interactive wkf with display of only central IFU plane
    Fixed a problem with NRI due to wrong naming conventions
2.4.1
    Added basic support for IFU data reduction
2.4.0
     Removed has_key in python used in reflex workflow
     "fixed PIPE-5096,5097 (proper WCS in wave and slit maps, and proper size of order in both maps)" xsh_respon_slit_nod.c
     Fixed PIPE-5094 (failures in SNR computation due to features of extraction procedure)
     Update tutorial, manual
     Clarify IFU cube dimension and fix two typos in IFU poly input in user manual
     "set w_step_fct default to 1 (from 10). This increases of a factor 10 cube size on Z axis and double computation time" xsh_utils_ifu.c

 2.3.12
       Merged fix for PIPE-5094 (failures in SNR computation due to features of extraction procedure)
       Update tutorial, manual
       Clarify IFU cube dimension and fix two typos in IFU poly input in user manual
       "set w_step_fct default to 1 (from 10). This increases of a factor 10 cube size on Z axis and double computation time" xsh_utils_ifu.c
 2.3.10
       Fixed generation of LAMRMS and SPEC_ERR with nominal values for old data sets that do
       not contain the "ESO QC MODEL ANNEAL RESY_RMS" keyword.
       Fixed problem response/fluxcal 2x2 (PIPE-4923, PIPE-4485)
 2.3.9
       Fixed generation of OBID1 keyword.
       Fixed problem extension screw up in order by order extracted 2D/1D frames due if dichroich cut is on
       Added nlines found/clean for fib 4 on 2dmap products for QC/IDP
 2.3.8
       Fixed handling of JH data sets.
       IDP release fixing NIR-JH problems
 2.3.7
       Added in paranal oca rules entries to reduce IFUs using virtual products from DO
 2.3.6
       Cleaning
 2.3.5
       Fixing handling of GAIN and DETRON for NIR. These values are now hardcoded in the IDP output.
       Spectrum cut now applied to all science recipes.
       QC parameters copied from both non-flux calibrated and calibrated spectra to IDP output spectrum.
       Fixed problems with UVB dichroic cut
       xsh_scired_slit_nod.c
       xsh_scired_slit_offset.c
       xsh_scired_slit_stare.c
 2.3.4
       Updated xsh_dfs.c to fix repeated COMMENT problem in pipe products
       Updated xsh_data_spectrum.c, xsh_utils_image.c to fix IDP problem with UVB dichroich-cut spectra
 2.3.3
       Updated to reflex 2.6
       Added optional generation of 1D spectra in Science Data Product (SDP) format for IDPs (Implements feature PIPE-4921).
       Added SCIENCE.SPECTRUM in oca rules (both PSO and reflex ones) for IDPs
       Removed REFLEX.TARGET=T for STD,FLUX
       Added flux monitoring of IFU products
       Add possibility to remove dichroich dip
 2.3.2
       Added special pre-compiler option to not create name clash on complex data type definition both in lapack and CPL (removed also corresponding trick in the lapack installation)
 2.3.1
       In workflow renamed DataSelectionMethod-->SelectionDatasetMethod, RAWDATA_DIR-->RAW_DATA_DIR
       fixed typo BUNIT (A-->Angstrom)
       Removed different implementations/API depending from CPL_VERSION_CODE
 2.3.0 updated release to final for release
       Adjusted fonts reflex titles in case of 5 items (response stare, offset)
 2.2.5
 Fixed problem scaling spectrum plot when added bad pixels info or
 overplotting tables in case of different versions of mathplotlib
 2.2.4
 Added support of AGC in bias and dark recipe
 Restrict product to display in interactive windows to the ones coming from the same recipe that calls the python script
 Fixed PIPE-4726 (problem reducing nodding, offset and stare NIR data due to wrong error computation for DIT>1024s)
 Upgrade to reflex 2.5
 Added 1D extracted sky frame to products of offset and stare recipes for Austrian-In-Kind skycorr
 2.2.3
"changed threshold_max and bad pixel code for NIR data as specified by QC/SDP (PIPE-4542, PIPE-4510)" xsh_badpixelmap.c
 Fixex PIPE-4547 (systematic error)
 2.2.2
 Fixed PIPE-4477: Reflex: Interactive window for Response actor (still missing display of response sampling points)
 2.2.1
 For QC added support of AGC dark data reduction (only if bias level is set by
 master bias)
 Fixed problem with VIS data by decreasing wrange from 0.001 to 0.0005 in
 xsh_align_model_to_spectrum
 2.2.0
 Reduced warnings from cpl_frameset_get_frame
 2.2.0
 Cleaned memory leaks. 
 Fixed bugs in xsh_mdark FPN computation
 Added RON computation in xsh_mdark
 Remove test_fit_bspline from unit tests
 2.1.10
 Fixed some bug on RON and FPN computation on master dark (PIPE-3754)
 Fixed some bug on flat association in wavecal (PIPE-4002)
 Fixed mem lean in UVB flat recipe
 2.1.9
 Fixing several cosmetics from Daniel on docs
 2.1.8
          Updated reflex tutorial and demo data set
          Use HIGH abs regions to remove response fit points if they fall in
          Updated HIGH_ABS_REGIONS for UVB,VIS,NIR
          Fix some mem leak
 2.1.7
          Updated wrange from 0.6 to 1.0 nm for VIS and from 1.0 to 5.0 nm for NIR n spline-fit (Sabine request)
          "dropped second smoothing and change 1st from 15 pix full size to 11 pix full size. Use windows of 5nm for NIR spline-fit" xsh_compute_response.c
 2.1.6
                 "changed max of sky-median-hsize from 60 to 2000" xsh_parameters.c
                 "allows lmax=6.894 (as indicated by Sabine)"  xsh_utils_response.c
                 "changed default of sky-median-hsize from 7 to 20 and sky-slit-edges-mask from 1.5 to 0.5 as asked by Daniel" xsh_respon_slit_stare.c
                 "changed default of sky-median-hsize from 7 to 20 and sky-slit-edges-mask from 1.5 to 0.5 as asked by Daniel" xsh_scired_slit_stare.c
                 "changed parameter defaults localize-method from GAUSSIAN to MANUAL and localize-slit-hheight from 0.5 to 2.0 as asked by Daniel" xsh_respon_slit_nod.c xsh_scired_slit_nod.c

                 "correct FITS header of respon,scired recipe products in case of several input frames" xsh_dfs.c
                 "changed xsh_pfits_combine_headers API" xsh_pfits.h
                 "correct FITS header of respon,scired recipe products in case of several input frames" xsh_pfits.c
                 "fixed a problem with linear interpolation" xsh_utils.c
                 "changed xsh_correl_spectra API to be able to control if correlation need spectra normalization" xsh_utils_response.h
                 "several bug fixes to make work on VIS (and NIR) telluric correction" xsh_utils_response.c
                 "cleanup output" xsh_compute_response.c

 2.1.5
 Changes to support response spline fit with inputs from catalog (response recipes, xsh_compute_response.c xsh_utils_response.c)
 Changes to support VIS telluric correction
 2.1.4
 Cleaned python GUI titles, tooltips, help
 Fixed typos processing data set display
 Fixed user manual typos
 2.1.3
 Fixed QC-PIPE-4417
 New parameters name conventions (PIPE-4160)
 2.1.2
 Fixed problem from Sabin when telluric is applied (on merged1d)
 Updated python display to match Daniel requirenments
 Additional cosmetics on workflow
 2.1.1
 Fixed Invalid read of size on xsh_mdark due not to check for boundaries
 Updated ref STD star catalogs
 Updated ref atm ext catalogs
 Fixed bug in response computation when telluric correction is applied
 Added flagging of BP in python actors
 2.1.0
 Fixed telluric correction
 Changed default telluric correction to TRUE (only in NIR)
 Updated std star catalogs
 2.0.12
 Make spline interpolation of continuum level in ratio during telluric correction
 Updated OCA rules to support JH from QC
 2.0.11
 Changed NirTellFitRegions from "{2022.0, 2048.0},{2085.0, 2100.0}" to
 "{2030.0, 2046.0},{2080.0, 2100.0}"
 Fixed typo in setting of telluric line list  NirTellFitRegions (we sample at 2430.0 instead of 2330.0)
 2.0.10
 Added spline fit of telluric sampling regions
 2.0.9
 Updated
 xsh_high_abs_window_nir.fits with new ranges for NIR telluric regions to be
 masked

 Fixed a number of bugs in telluric correction (to evaluate the best model)

 Prepared additional reference std star models with input from Sabine: 
 GD153 and LTT7987 down to 270nm

 2.0.8
                 "some changes to try out cross correlation in RV computation" xsh_compute_response.c
                 "rename detectorder-edges-search-window-half-size-->detectorder-edges-search-win-hsize" xsh_parameters.c
                 "less verbose cross correlation" xsh_utils.c
                 "added xsh_correl_spectra" xsh_utils_response.h
                 "added to CVS" xsh_utils_vector.h xsh_utils_vector.c
                 "added xsh_utils_vector.c,h" Makefile.am

 2.0.7 
 Fixed gaussian fit to correlation max as part of telluric correction
 2.0.6 
 Fixed a problem with convolution of model with slit profile
 2.0.5 
 Improved telluric and RV correction
 2.0.4 
 Fixed CRRATE QC param in mdark
 2.0.3 
 Fixed problems on FITS keywords acrrying on resampling accuracy on science frames
 Improved telluric correction shift computation
 2.0.2 
 Generate SKY_TAB_MULT_ARM as end product for reflex in stare recipes
 Fix problems with NIR JH reflex data reduction
 2.0.1 
 Fixed python display problems in case of SKY frame reduction as stare
 Updated OCA rules to fix several typos and uniform to QC
 Added extra columns to response product
 2.0.0 
 Final changes for release: manual, tutorial, a fix of reduction as stare.
 1.5.36
 Fix seg fault on sdptest for offset recipes (check raw frame is proper)
 Changed wave guess default for radial velocity computation
 Update user manual and tutorial (pictres)
 Fixed warnings oca rules due to check on 56100 for MJD-OBS of certain ref inputs
 1.5.35
 Addded combinenod-method to offset recipes python GUI
 Fixed problem generating end products if input data are sky and reduced as stare
 Updated oca rules to remove master response and set constraint on MJD-OBS for HIGH_ABS_WIN
 Added MJD-OBS to high abs win
 Some update of user manual
 1.5.34
 Fixed man page of recipes.
 Fixed mem leaks
 Fixed oca rules typos
 Fixed jenkins errors
 Extended to 256 size of strings to hold file names
 Updated user manual
 Updated/cleaned workflow
 1.5.33
 Additional changes from Daniel to improve extraction with interpolation
 1.5.32
 Changed default crhsingle-sigmalim in reflex wkf
 "changed max allowed value for crhsingle-sigmalim" xsh_parameters.c
 "dropped QC prefix from LAMRMS/NLIN,SPATRMS and fixed typo LAMLIN->LAMNLIN" xsh_qc_definition.h
 "dropped QC prefix from LAMRMS/NLIN,SPATRMS and fixed typo LAMLIN->LAMNLIN" xsh_utils_scired_slit.c

 Fixed response computation problems in VIS
 Fixed compiler warnings
 Changed defaults inter-order background from 11,11 to 9,9
 1.5.33
 Additional changes from Daniel to improve extraction with interpolation
 1.5.32
 Changed default crhsingle-sigmalim in reflex wkf
 "changed max allowed value for crhsingle-sigmalim" xsh_parameters.c
 "dropped QC prefix from LAMRMS/NLIN,SPATRMS and fixed typo LAMLIN->LAMNLIN" xsh_qc_definition.h
 "dropped QC prefix from LAMRMS/NLIN,SPATRMS and fixed typo LAMLIN->LAMNLIN" xsh_utils_scired_slit.c

 Fixed response computation problems in VIS
 Fixed compiler warnings
 Changed defaults inter-order background from 11,11 to 9,9
 1.5.31
 Added oca rules to reduce reflex data as stare
 Fixed portability problems to Mac
 Fixed Jenkins-cppcheck errors
 Fixed some bugs of python
 Fixed CRH position
 Fixed portability problems over Ubuntu
 1.5.30
  Fix problems on response wkf from Sabine (DFS12098)
  Fix oca rules problems with NIR-JH (DFS12468)
  Fix quality problems with respon-nod (DFS454)
  Work-around to fix portability problems on certain platform due to high order of poly method (DFS12436)
  "correct xsh_scired_slit_nod_fast() API to allow sky line correction param"xsh_utils_scired_slit.h
  "correct xsh_scired_slit_nod_fast() API to allow sky line correction param" xsh_utils_scired_slit.h
  "correct xsh_scired_slit_nod_fast() API to allow sky line correction param"xsh_utils_scired_slit.c
  "correct xsh_scired_slit_nod_fast() API to allow sky line correction param" xsh_utils_scired_slit.c
  "added correct-sky-by-median param to alow sky lines correction" xsh_respon_slit_nod.c
  "added correct-sky-by-median param to alow sky lines correction" xsh_scired_slit_nod.c

 1.5.29
 Fixed bug in flux conservation in xsh_respon_slit_nod
 Cleaned temporary products from xsh_flexcomp
 Clarified error messages (from parameters robustness checks)
  "fixed jenkins error" test-xsh_extract_clean_sym.c
  "fixed jenkins error" xsh_paf_save.c
  "fix DFS12467" xsh_rectify.c
  "now rectify-radius is a parameter with allowed range:2-100" xsh_parameters.c
  "changed checks on INSTRUME value of static reference calibrations" xsh_wkf.oca
  "several updates asked by wolfram" Xshooter.xml.in
  Fixed response recipe hanging
  Fixed UMR UMW leaks

 1.5.28
 Added INSTRUME to TELL_MOD_CAT_ARM frame
 Fixed some problems on oca rules for paranal release that where rrelated to reflex upgrade changes
 Removed CRH rejection after preliminar sky subtraction in stare (as used to be done in the past)
 Changed workflow and oca rules to have different flat strategy on flux std (use same flat as scired)

 "reduced compiler warnings" xsh_respon_slit_offset.c
 "reduced compiler warnings" xsh_scired_slit_offset.c
 "reduced compiler warnings" xsh_compute_linearity.c
 "reduced compiler warnings" xsh_utils_image.c
 "reduced compiler warnings" xsh_utils.c
 "reduced compiler warnings" xsh_utils_table.c
 "reduced compiler warnings" xsh_utils_scired_slit.c
 "reduced compiler warnings" xsh_utils_response.c
 "reduced compiler warnings" xsh_utils_ifu.c
 "reduced compiler warnings" xsh_subtract.c
 "reduced compiler warnings" xsh_rectify.c
 "reduced compiler warnings" xsh_parameters.c
 "reduced compiler warnings" xsh_localize_obj.c
 "reduced compiler warnings" xsh_follow_arclines.c
 "reduced compiler warnings" xsh_flat_merge.c
 "reduced compiler warnings" xsh_create_master.c
 "reduced compiler warnings" xsh_create_order_table.c
 "reduced compiler warnings" xsh_create_wavemap.c
 "reduced compiler warnings" xsh_data_dispersol.c
 "reduced compiler warnings" xsh_data_pre.c
 "reduced compiler warnings" xsh_data_resid_tab.c
 "reduced compiler warnings" xsh_data_wavemap.c
 "reduced compiler warnings" xsh_detect_order.c
 "reduced compiler warnings" xsh_dfs.c
 "reduced compiler warnings" xsh_baryvel.c
 "reduced compiler warnings" xsh_combine_nod.c
 "reduced compiler warnings" xsh_compute_slice_dist.c
 "reduced compiler warnings" xsh_data_order_resid_tab.c
 "reduced compiler warnings" xsh_format.c
 "reduced compiler warnings" xsh_opt_extract.c
 "reduced compiler warnings" xsh_data_image_3d.c
 "reduced compiler warnings" xsh_utils_efficiency.c
    

	"moved xsh_prepare() and xsh_frameset_uniform_bin()"  xsh_respon_slit_nod.c
              "moved xsh_prepare() and xsh_frameset_uniform_bin()"  xsh_respon_slit_nod.c
              "moved xsh_prepare() and xsh_frameset_uniform_bin()"  xsh_respon_slit_offset.c
              "moved xsh_prepare() and xsh_frameset_uniform_bin()"  xsh_respon_slit_stare.c
              "fixed bug on pre-overscan-corr param retrieval" xsh_scired_slit_offset.c
              "added xsh_pre_subsample()" xsh_data_pre.h
              "added xsh_pre_subsample()" xsh_data_pre.c
              "removed xsh_correct_frameset_raws_bin,xsh_correct_frameset_calib_bin and added xsh_frameset_uniform_bin" xsh_dfs.h
              "added functionality to correct frames binning in case raw and flat frame have different binning" xsh_dfs.c
              "added xsh_plist_div_by_fct()" xsh_pfits.h
              
              "added xsh_key_scan_div_by_fct() xsh_key_bin_mult_by_fct()" xsh_pfits.c
              "taken out automatic correction for different frame binning as part of xsh_begin and moved it to response recipes" xsh_utils.c
              "removed xsh_plist_div_by_fct() xsh_key_bin_mult_by_fct() xsh_key_scan_div_by_fct()" xsh_utils_image.c

                 "removed extract-method param" xsh_respon_slit_offset.c
                 "removed extract-method param" xsh_scired_slit_offset.c
                 "removed extract-method param" xsh_parameters.c
                 "allow input frame rebinning only in case of response" xsh_utils.c
                 "removed (abs) CRH rejection in nodding" xsh_utils_scired_slit.c

                 "dropped param do-flatfield and changed do_flatfield to 1" xsh_respon_slit_offset.c
                 "dropped param do-flatfield and changed do_flatfield to 1" xsh_scired_slit_offset.c
                 "fixed a problem of xsh_frameset_crh_single in case of no CRH rejection is applied" xsh_utils_scired_slit.c
                 "removed extract-method parameter from offset recipe" xsh_object_interactive_common.py 
                 "added xsh_correct_frameset_raws_bin()" xsh_dfs.h
                 "added xsh_correct_frameset_raws_bin()" xsh_dfs.c
                 "rebin raw or calibs differently according to condition of binning" xsh_utils.c
                 "removed do-flatfield" xsh_respon_slit_nod.c
                 "fixed problem with default of do_flatfield param and moved CRH rejection before inter-order bkg subtraction" xsh_respon_slit_stare.c
                 "removed do-flatfield" xsh_scired_slit_nod.c
                 "fixed problem with default of do_flatfield param and moved CRH rejection before inter-order bkg subtraction" xsh_scired_slit_stare.c

 1.5.27
  "cleanted temporary products" xsh_compute_response.c
  "cleanted temporary products" xsh_detect_continuum.c
  "cleanted temporary products" xsh_utils.c
  "reduced mem leaks"  xsh_utils_response.c
  "removed compiler warnings" xsh_respon_slit_stare.c
  "fixed problem with reducing data of UVB 1st set reflex-demo" xsh_scired_slit_offset.c
  "removed tmp product" xsh_drl_check.c
  "more complex check on UVB arm and binning for cleaning grid structure" xsh_subtract.c 
  "change filename not to have residual temporary files"  xsh_utils_scired_slit.c

   "fixed compiler warnings" xsh_cfg_recover.c
   "fixed compiler warnings" xsh_flexcomp.c
   "fixed compiler warnings" xsh_scired_slit_offset.c
   "fixed compiler warnings" xsh_mbias.c
   "fixed compiler warnings" xsh_predict.c
   "fixed compiler warnings" xsh_respon_slit_nod.c
   "fixed compiler warnings" xsh_respon_slit_offset.c
   "fixed compiler warnings" xsh_scired_ifu_offset.c
   "fixed compiler warnings" xsh_scired_slit_nod.c
   "fixed compiler warnings" xsh_util_ifu_offset.c
   "fixed compiler warnings" xsh_scired_ifu_stare.c
   "fixed compiler warnings" xsh_scired_slit_stare.c
   "fixed compiler warnings" xsh_utils_scired_slit.c
   "fixed compiler warnings" xsh_utils_scired_slit.c
   "fixed compiler warnings" xsh_utils_response.h
   "fixed compiler warnings" xsh_utils_response.c
   "fixed compiler warnings" xsh_subtract.c
   "fixed compiler warnings" xsh_compute_response.c
   "fixed compiler warnings" xsh_data_grid.c
   "fixed compiler warnings" xsh_extract.c
   "fixed compiler warnings" xsh_localize_obj.c
   "fixed compiler warnings" xsh_parameters.c
   "use only weight method as only optional merging option" xsh_merge_ord.c

  "removed statement that was generating infinite loop" xsh_scired_slit_stare.c
  "removed crval2, cdelt2 from new extraction algorithm API" xsh_drl.h
  "removed crval2, cdelt2 from new extraction algorithm API" xsh_extract.c
  "added wcs to err and qual extensions of frames in PRE format" xsh_data_pre.c
  "added wcs to errs and qual extentions of extracted products" xsh_data_rec.c
  "added wcs to errs and qual extentions of spectrum product" xsh_data_spectrum.c
  "changed xsh_extract_clean_slice() API" test-xsh_extract_clean_sym.c

                 Added parameter to control telluric correction and activated telluric correction during response computation
                 "moved crh flagging right after frame preparation" xsh_scired_slit_nod.c
                 "added QFLAG_INTERPOL_FLUX falg" xsh_badpixelmap.h
                 "rewritten clean extraction with interpolation algorithm from Wolfram" xsh_extract.c
                 "removed ipol_bp param" xsh_parameters.h
                 "removed ipol_bp param, and added check on extract_mask_size param" xsh_parameters.c
                 "added missing case to unit tests" test-xsh_extract_clean_sym.c

     "removed unnecessary duplicates" xsh_respon_slit_nod.c
     "changed order of operation to properly correct for CRH and combine frames" xsh_respon_slit_offset.c
     "changed order of operation to properly correct for CRH and combine frames" xsh_scired_slit_offset.c
     "fixed bug" xsh_scired_slit_nod.c
     "cleaned code" xsh_respon_slit_stare.c
     "proper order of operations" xsh_scired_slit_stare.c
     "added xsh_frameset_mflat_divide() xsh_frameset_crh_single()" xsh_utils_scired_slit.h
     "added xsh_frameset_mflat_divide() xsh_frameset_crh_single()" xsh_utils_scired_slit.c
     "changed default REGDEBUG_FULL to 0" xsh_remove_crh_single.c 
     "less verbose" xsh_utils_efficiency.c

     "removed bkg params from nodding" xsh_parameters.c
     "changed api xsh_slit_stare_get_params to drom not needed opt_extract_par" xsh_utils_scired_slit.h
     "changed api xsh_slit_stare_get_params to drom not needed opt_extract_par, dropped trace-obj par" xsh_utils_scired_slit.c
     "cleaned tmp products" xsh_utils_image.c
     "cleaned tmp products" xsh_subtract.c
     "cleaned tmp products" xsh_create_master.c
     "dropped background params" xsh_respon_slit_nod.c xsh_scired_slit_nod.c 
     "added generation slit and wavemaps" xsh_respon_slit_offset.c xsh_scired_slit_offset.c
     "dropped params trace-obj, conserve-flux" xsh_respon_slit_stare.c xsh_scired_slit_stare.c

 1.5.26
                 "removed inter-order bkg subtraction" xsh_respon_slit_offset.c
                 "removed inter-order bkg subtraction" xsh_scired_slit_offset.c
                 "removed inter-order bkg subtraction in offset recipes" xsh_parameters.c
                 "removed inter-order bkg subtraction in offset recipes" xsh_utils_scired_slit.h
                 "removed inter-order bkg subtraction in offset recipes" xsh_utils_scired_slit.c

 Fixed problem in removing proper frame from nod frame list if list contain an
 even No of frames.
 Clean duplicated arc line list in reflex delivery
 Optimal extraction parameters kappa,niter,order can now be varied
 Changed defaults of resampling spatial,wave to "broad" slit case
 "changed due to xsh_remove_crh_multi API changes" xsh_mdark.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_respon_slit_nod.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_respon_slit_offset.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_scired_ifu_offset.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_scired_slit_stare.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_scired_slit_nod.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_scired_slit_offset.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_util_ifu_offset.c
 "changed due to xsh_remove_crh_multi API changes and dropping crh params" xsh_util_ifu_stare.c
 "changed xsh_remove_crh_multi API" xsh_drl.h
 "changed (science) frame combination" xsh_drl_check.c
 "dropped crh-clip and combinenod params" xsh_parameters.c
 "added comment to clarify code" xsh_rectify.c
 "changes in crh-multi to use stak and not crh-single params" xsh_remove_crh_multi.c
 "changed due to xsh_remove_crh_multi API changes" xsh_utils_scired_slit.h
 "changed due to xsh_remove_crh_multi API changes" xsh_utils_scired_slit.c
 "removed 1887.8 data point" xsh_efficiency_response.c

 1.5.25
 changed physical model to include opening up of 2 parameters
 Dropped background obsolete params from all recipes and workflow
 refined poly-degx/y/kappa background params
 1.5.24
 "added xsh_function1d_xcorrelate" xsh_utils.h
 "added xsh_function1d_xcorrelate" xsh_utils.c
 "moved xsh_function1d_xcorrelate to xsh_utils.c" xsh_compute_response.c
 "moved xsh_function1d_xcorrelate to xsh_utils.c" test-xsh_correl_gaussians.c
 "moved xsh_function1d_xcorrelate to xsh_utils.c" test-xsh_xcorrel_gaussians.c
 "added to CVS" test-xsh_telluric_cor.c
 "added test_xsh_telluric_cor" Makefile.am 
 Dropped parameters from 2dmap and predict interactive windows.
 changed defaults xsh_2dmap for dispersol-deg-x
 adjusted again interorder bkg for D2 flat
 changed setup to be able to ipip release
 updated list of model CFG using QC input
 changed oca rules to use latest CFG earlier than acquired data

1.5.23
           Removed some parameters from interactive windows for mflat
           decreased min-sn of UVB-QTH to 20
           trimmered interactive bkg regions
           Set default min-sn in 2dmap to 5
1.5.22
           Chabnged default param xsh_2dmap and xsh_flexcomp
           Refined inter-order background
           CChanged lazy mode in python interactive windows
1.5.21
           Update to Reflex2.2
           Dropped param detectorder-arclines-deg-y from flexcomp and 2dmap and param compute-disp-tab from flexcomp
1.5.20
           Added parameter extract-interpolate-bp, extract-interpolate-bp-mask-hsize to control "clean" extraction
           and made changes in extraction to be able to trigger old and new-clean extraction. Changed recipes to
           be able to test this.
1.5.19          
           Optimised order and ncoeffs param for response B-spline
           call xsh_extract_clean to test it
           Changed interpolation windows (also calib data)
           Fixed typos in xsh_response_slit_stare actor
           Added call to xsh_log_invocation for debugging purposes
           Fixed a bug in display of response in case no response is generated but a master is present
           Fixed a typo in oca rules to process offset as stare
           "put back version 1.57 from xsh-1_5_18 to have working NIR results on predict" xsh_detect_arclines.c
               Switch off  cpl_fit_image_gaussian in line detection.
               Activated B-spline fit of response
1.5.18          
               Allow wider range (up to 500) of min-sn for maflat. Increased default from 25 (NIR) and 35 (UVB/VIS) to 60.
               Input HIGH_ABS_WIN_ARM in rwesponse recipes.
1.5.17          
                Switches on new reflex testing
                new inter-order backgground based on masks
               "changes to drop merge param" xsh_absorp.c
               "changes to drop merge param" xsh_geom_ifu.c
               "changes to drop merge param" xsh_respon_slit_nod.c
               "changes to drop merge param" xsh_respon_slit_offset.c
               "changes to drop merge param" xsh_respon_slit_stare.c
               "changes to drop merge param" xsh_scired_ifu_offset.c
               "changes to drop merge param" xsh_scired_ifu_stare.c
               "changes to drop merge param" xsh_scired_slit_nod.c
               "changes to drop merge param" xsh_scired_slit_offset.c
               "changes to drop merge,compute-map params" xsh_scired_slit_stare.c
               "changes to drop merge param" xsh_util_apply_response.c
               "changes to drop merge param" xsh_util_ifu_offset.c
               "changes to drop merge param" xsh_drl.h
               "changes to drop merge param" xsh_merge_ord.c
               "changes to drop crh-clip param from response-stare" xsh_parameters.c
               "changes to drop merge param" xsh_utils_scired_slit.h
               "changes to drop merge param" xsh_utils_scired_slit.c

1.5.16
                 "cleaned compiler warnings" xsh_mflat.c
                 "cleaned compiler warnings" xsh_util_ifu_offset.c
                 "cleaned compiler warnings" xsh_create_master.c
                 "cleaned compiler warnings" xsh_data_wavemap.c
                 "cleaned compiler warnings" xsh_detect_arclines.c
                 "cleaned compiler warnings" xsh_detect_order.c
                 "cleaned compiler warnings" xsh_flat_merge.c
                 "cleaned compiler warnings" xsh_paf_save.c
                 "cleaned compiler warnings" xsh_parameters.c
                 "cleaned compiler warnings" xsh_rectify.c
                 "cleaned compiler warnings" xsh_subtract.c
                 "cleaned compiler warnings" xsh_utils_image.c
                 "cleaned compiler warnings" xsh_parameters.h xsh_utils.c
                 "changes call to xsh_subtract_background to reflect API changes" test-xsh_subtract_background.c
                 "added xsh_flat_merge_qth_d2_tabs()" xsh_drl.h
                 "added xsh_flat_merge_qth_d2_tabs()" xsh_flat_merge.c
                 "call grid=xsh_crea_grid_from_samples for QC" xsh_subtract.c
                 "call xsh_flat_merge_qth_d2 for QC, changed call to xsh_subtarct_background to reflect function API changes" xsh_mflat.c
                 "call xsh_compute_response for QC" xsh_respon_slit_offset.c xsh_respon_slit_stare.c xsh_respon_slit_nod.c

                 "implement mask based inter-order bkg subtraction" xsh_subtract.c
                 "do not declare bad pixels in the image data extension for image resampling because we simply re-map from one space to anothe" xsh_rectify.c

1.5.15
                 "bacground method is only TRUE/FALSE" xsh_scired_slit_stare.c
                 "removed poly mode setting in back method" xsh_util_ifu_offset.c
                 "fixed PRO.CATG of 'ON' product" xsh_wavecal.c
                 "added XSH_QC_NPIXRANGE,XSH_QC_FPIXRANGE,xsh_pfits_set_n_range_pix(),xsh_pfits_set_frac_range_pix()" xsh_pfits.h xsh_pfits.c
                 "added xsh_badpixelmap_count_range_pixels()" xsh_badpixelmap.h xsh_badpixelmap.c
                 "changed inter-order bck method from char* to int" xsh_parameters.h
                 "changes dealing with inter-order background method changes from char* to boolean" xsh_parameters.c
                 "added check on range pixels for VIS" xsh_data_pre.c 

                 "save tables as CPL_FRAME_TYPE_TABLE" xsh_dfs.c
                 "fixed problem in tilt table FLAG column content" xsh_data_linetilt.c
                 "remove xsh_parameters_subtract_sky_single_get_ron() xsh_parameters_subtract_sky_single_get_gain()" xsh_parameters.h
                 "remove ron and gain bspline params" xsh_parameters.c
                 "remove ron and gain bspline params" xsh_subtract_sky_single.c

                 "cleaned unnecessary comment" xsh_respon_slit_stare.c
                 "in case of UVB data orderpos frame can come from 2 lamps: we remove the not used lamp frame from the set to save speed" xsh_dfs.c
                 "small speed-up" xsh_rectify.c
                 "several speed-ups" xsh_subtract_sky_single.c

                 "changes to make proper blemish detection and have both grids used to compute inter-order background on D2 and QTH flat" xsh_mflat.c
                 "cleaning output products of mflat recipe" xsh_create_master.c
                 "added fit and res elements in grid structure" xsh_data_grid.h
                 "save fit and res elements of grid structure to table" xsh_data_grid.c
                 "speed-ups" xsh_flat_merge.c
                 "provide info on fit poly background and residual to sampling point in grid table" xsh_subtract.c
                 "replace xsh_image_mflat_detect_hotcold by xsh_image_mflat_detect_blemishes" xsh_utils_image.h
                 "replace xsh_image_mflat_detect_hotcold by xsh_image_mflat_detect_blemishes" xsh_utils_image.c

                 "better documented maps genearation" xsh_model_kernel.c
                 "removed clipping of lines that have less than 7 pinholes detections, for 2dmap case" xsh_detect_arclines.c

1.5.14
                 Fix residual problems interactive wkf and python
                 "added to CVS" test-xsh_correct_vacuum_to_air.c
                 "changes to reflect background aalgorithm changes, in particular drop of parameters" test-xsh_subtract_background.c
                 "fixed error in formula to pass from vacuum to air" test-xsh_correct_vacuum_to_air.c
                 "drop max_frac_grid smooth_x smooth_y min_frac_grid background subtraction params" xsh_parameters.h
                 "drop max_frac_grid smooth_x smooth_y min_frac_grid background subtraction params" xsh_parameters.c
                 "cleaned warnings" xsh_compute_response.c
                 "cleaned warnings" xsh_create_master.c
                 "removed function duplicates" xsh_data_pre.h
                 "rewritten xsh_pre_data_window_median_flux_pa" xsh_data_pre.c
                 "rewritten inter-order background subtraction" xsh_subtract.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_geom_ifu.c
                 "fixed compiler warning" xsh_mdark.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_mflat.c
                 "fixed compiler warning" xsh_orderpos.c
                 "fixed compiler warning" xsh_respon_slit_nod.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_respon_slit_offset.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_respon_slit_stare.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_scired_ifu_offset.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_scired_ifu_stare.c
                 "fixed compiler warning" xsh_scired_slit_nod.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_scired_slit_offset.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_scired_slit_stare.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_util_ifu_offset.c
                 "drop smooth_x, smooth_y params from interorder background subtraction method" xsh_util_ifu_stare.c
                 "dropped background params" xsh_calib_interactive_common.py

1.5.13
                 "added MJD-OBS" ThAr_uvb_2012PBR.fits
                 "added MJD-OBS" penray_nir_custom_air_ext_2012PBR.fits
                 "change default of wave map generation to TRUE" xsh_2dmap.c
                 "remove decode-bp param setting from every calib-recipe, remove plots of residuals in mflat, added detectarclines-wavesol-deg-lambda/order params to xsh_2dmap" xsh_calib_interactive_common.py

                  Removed MFLAT_SUB_BACK_mode_arm from xsh_mflat
                  More verbose info on xsh_orderpos (usage of D2/QTH frame)
                  Fixing labels and params in orderpos/mflat interactive windows
                 "cleaned output" xsh_compute_response.c
                 "fixed bugs in order edges detection: DFS12010,DFS12011,DFS12012" xsh_detect_order.c
                 "fixed a seg fault problem possibly happening if the STD star target name is not contained in the input reference STD catalog list" xsh_utils_efficiency.c

                 "change check on mdark exposure uniformity using DET WIN1 UIT1 ansd DET DIT instead of exptime" xsh_mdark.c
                 "changed param defaults for detectcontinuum-clip-res-max, detectcontinuum-search-window-half-size,detectcontinuum-running-window-half-size,detectcontinuum-ordertab-step-y" xsh_orderpos.c
                 "cleaned code" xsh_create_master.c
                 "spedd-up" xsh_detect_continuum.c
                 "changed default detectcontinuum-clip-res-max from -1 to 0.5" xsh_parameters.c
                 "added XSH_DET_WIN1_UIT1,xsh_pfits_get_det_win1_uit1()" xsh_pfits.h 
                 "added xsh_pfits_get_det_win1_uit1()" xsh_pfits.c 
                 "speed-up xsh_monitor_flux()" xsh_utils.c

1.5.12
                 Uniformed decode-bp levels to 2144337919 in recipes and wkf
                 Cleaned orderpos interactive workflow labels
                 Allow input BP map to work with flexcomp (both recipe and wkf)
                 Updated OCA rules to provide input BP map in flexcomp,response,scired
                 Updated UVB and VIS bad pixel maps
                 Flag threshold pixels in any recipe when frame are prepared.
                 Proper master flat combination
                 "added xsh_create_master_flat2()" xsh_drl.h
                 "complete changes to have response as product of new algorithm for response computation" xsh_compute_response.c
                 " changes to have master flat generated by UVES-like algorithm for master flat frame creation" xsh_create_master.c
                 "cleaned output" xsh_data_star_flux.c
                 "added xsh_spline_hermite()" xsh_utils.h
                 "fixed typo on tmp flat bias corrected frame names and activated new algorithm for flat creation for testing" xsh_mflat.c

                 "added xsh_min_int()" xsh_utils.h
                 "added xsh_min_int()" xsh_utils.c
                 "some additions to have UVES-like master creation (not yet tested)" xsh_create_master.c
                 "proper sequence to subtract master bias and master dark from flat frames" xsh_mflat.c

1.5.11
                 Updated wkf
                 Improved xsh_mflat using proper bias and dark subtraction sequence.
                 Clarify response and science input in case the relevant master frames are AFC corrected or not.

                 Updated OCA rules wkf in order to have MASTER_DARK as optional input of flat and stare recipes.
                 Fixed a number of errors in workflow to channed QTH flats in orderpos.
                 Fixed a number of errors in workflow and OCA rules to process JH data.
                 "added xsh_star_flux_list_filter_lowpass, xsh_star_flux_list_divide, xsh_star_flux_list_duplicate" xsh_data_star_flux.h
                 "added xsh_star_flux_list_filter_lowpass, xsh_star_flux_list_divide, xsh_star_flux_list_duplicate" xsh_data_star_flux.c
                 "added windows for UVB arm" xsh_efficiency_response.c
                 "added xsh_interpolate_high_abs_regions2 and find_lambda_idx_max,find_lambda_idx_min to fix problems revealed in VIS arm with windowing for new response implementation (due to same step size of ref and obs std spectra)" xsh_compute_response.c
                 "added to CVS" test-xsh_correl_gaussians.c
                 "added test-xsh_correl_gaussians.c" Makefile.am

                 Some reflex OCA rules uniformation to QC ones
                 implemented new function to compute response
                 "added automatic rescaling of FLUX by its median before actual fit in order to make fit more robust (working in ranges centered to zero)" xsh_utils.c
                 "For new response computation function use linear interpolation in place of Hermite spline as it seems more robust for some STD star spectra" xsh_compute_response.c
                 "remove low cut at 308nm to better work with new response" xsh_data_star_flux.c

1.5.10           Speed up from Daniel                                
1.5.9            Fixed problems generation clean line list (DFS11895)
1.5.8
                 Changed default param predict: fit-win-hsize=6, search-wind-hsize=3, min-sin=5
                 Decreased no param in xsh_predict. Cleaned predict interactive wkf
1.5.7
                 "removed clean arclines product" xsh_2dmap.c
                 "added more clear comments" xsh_mflat.c
                 "added more clear comments" xsh_orderpos.c
                 "TO BE CHECKED: removed double call to detect arclines, changed way to remove flagged columns from resid tab before using it in annealing" xsh_predict.c
                 "TO BE CHECKED: removed double call to detect arclines, changed way to remove flagged columns from resid tab before using it in annealing" xsh_predict.c
                 "cleaner and faster xsh_3_energy()" xsh_model_metric.c
                 "added some messaging to debug line cleaning" xsh_create_order_table.c 
                 "fixed bug in xsh_frame_table_resid_merge(), added xsh_resid_tab_create_not_flagged" xsh_data_resid_tab.c
                 "added xsh_resid_tab_create_not_flagged()" xsh_data_resid_tab.c
                 "added xsh_resid_tab_create_not_flagged()" xsh_data_resid_tab.h
                 "TO BE CHECKED: clean xsh_detect_arclines_dan()" xsh_detect_arclines.c

1.5.6
                Fixed problem of 1.5.5 (that was not working)
                Decreased param no in predict/2dmap
                Some speed-up annealing from Daniel
1.5.5
                Removed parameter niter from frame kappa sigma stacking
                Fixed bug in scaling master dark by exposure time (if UVB/VIS)
                Faster peack line detection
1.5.4         
                 Rewritten/verified master bias generation including BP flagging
                 Rewritten/verified master dark generation including BP flagging
                 Change default bias propagation option in workflow
1.5.3         
                 Prepared xsh_lingain to set saturation limit in an arm dependent way (not yet used)
                 Changed wkf to allow not to propagate master bias
                 Removed DRS tab entris from oca rules
                 Cleaned xsh_mbias
                 "changed xsh_collapse_errs interface: mask not needed" xsh_utils_image.h
                 "corrected, simplified and cleaned xsh_create_master_bias2()" xsh_create_master.c
                 "cleaned code" xsh_create_master.c
                 "changed interface xsh_collapse_errs as we do not need an input BP map. Also corrected the implementation" xsh_utils_image.c
                 "changed calls to xsh_collapse_errs due to API change. Made sure bad pixels are first injested in corresponding images before applying statistics" xsh_remove_crh_multi.c 

1.5.2            
               Removed non linear pixels from UVB/VIS maps
               Aligned table column display value with cursor reported values (still offset present to values on axes)
               Removed some BP maps duplicates. Renamed BP maps to remove read-out info (we assume they are common)
               Fixed bug in xsh_mflat in case input master bias is not provided
1.5.1            
                 "change defualt pre-overscan-corr from 0 to 1 for all recipes"  xsh_parameters.c
                "added check on call to xsh_badpixelmap_fill_bp_pattern_holes" xsh_mdark.c
                "added xsh_irplib_imagelist_get_clean_mean_levels to be callable from other modules" xsh_irplib_mkmaster.h
                "Rename irplib_imagelist_get_clean_mean_levels --> xsh_irplib_imagelist_get_clean_mean_levels and make it non static" xsh_irplib_mkmaster.c
                "changed interface xsh_badpixelmap_flag_saturated_pixels to be able also to count saturated bixels and take into account prescan level" xsh_badpixelmap.h
                "changed interface xsh_badpixelmap_flag_saturated_pixels to be able also to count saturated bixels and take into account prescan level. Simplified" xsh_badpixelmap.c
                "simplified, corrected some function doc, proper threshold pixel flagging" xsh_data_pre.c
                "increase release id" configure.ac
                "fixed problems with interactive window display for flat UVB results" xsh_calib_interactive_common.py
                Fixed some problems with setting parameters in interactive windows of xsh_mflat 
                Fixed typo of default decon_bp value in formatcheck interactive window.


1.5.0             Public release (without extra workflow previously added for Reflex detailed chhecks on calibs actors).
1.4.11            
                  Added interactive workflow on calibs for Dan   
                  Clarified data reduction of lingain data
                  uniformed detmon tags for lingain data
                  Fixed gain_corr computation (as in detmon)
                  Added interactive windows in wkf for testing
                  Fixed problem 3rd extention edge table in UVB
1.4.10            Added new oca rules to process offset as stare. Removed reflex2 suffix from oca rules for wkf.
1.4.9             Updated python scripts to support JH NIR data reduction
                  Simplified 2dmap actor
                  Cosmetics on wkf
                  Fixed statick errors from cppcheck
1.4.8             Fixed DFS10225 (wavelength and spatial accuracy)
                  Fixed statick errors from cppcheck
                  Fixed errors from valgrind and computation slit_up,low,cen on AFC frames (conversion from disp solution to slitmap)
                  Fixed mem leaks
1.4.7             Fixed mdark FITS header DFS11708
                  Freeze before Moving CVS location from project25 to project4
                  Added parameter to control flagging of negative and threshold pixels.
                  Have dedicated function to generate decode_bp parameter
1.4.6             Fixed OCA rule problem with JH-NIR data reduction.
                  Proper thresh/negative pixel flagging and PRE frames qualifier combination.
                  Allow to reduce a single raw dark frame with xsh_mdark
                  Fixed error computation in case one uses overscan and does not                  input the master bias
                  Fixed input config for scired-nod/offset (added input mbias)
                  removed nteractive work-flows  clutter due to many params
                  "changed API xsh_pfits_get_qc_nhpix xsh_pfits_set_qc_nhpix, added xsh_pfits_set_qc_noisepix" xsh_pfits_qc.h xsh_pfits_qc.c
                  "added xsh_badpixelmap_fill_bp_pattern_holes" xsh_badpixelmap.h xsh_badpixelmap.c
                  "changes call to xsh_pfits_set_qc_nhpix to reflect API chage" xsh_compute_noise_map.c
                  "default decode_bp in mdark is now 2147483647" xsh_parameters.c
                  "added call to xsh_badpixelmap_fill_bp_pattern_holes and replace xsh_add_product_pre by xsh_add_product_image" xsh_mdark.c

1.4.5             Cleaned wkf manuals and tutorial for release
1.4.4             Cleaned tmp products, added RecipeParameterMode param to wkf, fixed wave scaling on response py plots
1.4.3             Fixed response Y scaling, added some description on wkf, changed xsh_flexcomp wkf params defaults.
1.4.2             Changed dir structure for man (to support reflex tutorial)
1.4.1             Fixed some param defaults for crh_clipping params, added overscan param to ifu offset
                  Removed xsh_absorp
                  Uniformed py scripts to example
                  Removed wavecal actor
1.4.0             Additional cleaning of wkf, removed wavecal actor, reduced warnings from resampling step
1.3.38            Fixed display problem when telluric-nod std are reduced
                  Dixed CUBE FITS header for CASA and added ERRS, QUAL to merged cube product.
1.3.37            Fixed bug OCA rules in checking for bin setting of order tab edges for flux slit off uvb/vis
1.3.36            Added support JH band                     
1.3.35            Update to Alpha5 . Fixed bug in linearity.                     
1.3.34            Changed resampling of error extension. Added extra keys for CASA
                  Changed python script to make wark disable-interactive wkf
1.3.33            Fixed error is sky-subtract=FALSE in response & scired stare recipes
1.3.32            Updated Wkf to implement SDP comments and split py interactive windows in several recipe dependent modules. Updated to reflex-a4
1.3.31            Changes to support JH filter, fixed bug computation CRRATE, changed minRet to 0 for BP_MAP_RP_ARM
1.3.30            Fixed problem with xsh_predict
1.3.29            Changed load of BP map to use the common function in wavecal.
                  Reflex2 support
1.3.28            Changed response using spline fit instead of linear one
                  More robust response and efficiency computation with old atm extinction table
1.3.27            Put back drs params to user interface
1.3.26            Improved workflow interactive window for reflex.
1.3.25
                  Added product DARK_QC_ARM for QC
                  Fixed FPN computation on dark frames
                  Allow user to set poly bkg parameters
                  Updated mdark doc
                  Speed-up CRH rejection, sky subtraction
                  simplified param defaults checking
                  Changed science interactive windows to display sky images
                  Fix some problems on IFU-DRL routines related to parameter setting.
1.3.24
                  New classes for reflex wkf interactive windows including display functionalities
                  "moved several qc related parameter setting to DRS setup table, cleaned recipe" xsh_mdark.c
                 "moved several qc related parameter setting to DRS setup table, cleaned recipe" xsh_mdark.c
                 "added checks to xsh_monitor_flux calls" xsh_mflat.c
                 "set proper PRO.CATG to ON frame, in case of NIR" xsh_orderpos.c
                 "set proper PRO.CATG to ON prame and SUB_BIAS frame" xsh_scired_slit_stare.c
                 "simplified, moved several functionality to xsh_utils_image" xsh_util_ima_oversample.c xsh_util_ima_subsample.c
                 "added xsh_frame_image_mult_by_fct, xsh_frame_image_div_by_fct" xsh_utils_image.h
                 "added xsh_frame_image_mult_by_fct, xsh_frame_image_div_by_fct, and called functions" xsh_utils_image.c
                 "added xsh_recipe_params_drs_check" xsh_parameters.h xsh_parameters.c
                 "cleaned output" xsh_irplib_mkmaster.c
                 "added check on input dark EXPTIME consistency. Exit if not the same (0.001s accuracy)" xsh_create_master.c 
                 "change interface to xsh_create_master_dark2" xsh_drl.h

1.2.23
                Fixed problem coadding noisy pixels in xsh_mdark
                 Fixed problem using decode_bp
                 Fixed problem coadding biases (flagging bad pixels)
                 added interactive wkf
                 "added xsh_compute_efficiency()" xsh_utils_scired_slit.h xsh_utils_scired_slit.c
                 "use xsh_compute_efficiency()" xsh_respon_slit_nod.c xsh_respon_slit_offset.c xsh_respon_slit_stare.c

                 "small change to speed up loop" xsh_badpixelmap.c
                 "Renamed mode 2 option to 0, after removing 0 option" xsh_utils_image.c
                 "changed mode 2 to 0 for error computation" xsh_remove_crh_multi.c
                 "removed injestion of 3rd ima extension in master bp map when loaded" xsh_drl_check.c
                 "added xsh_dfs_check_binning()" xsh_dfs.h xsh_dfs.c
                 "replace mode 2 by mode 0 in error computation" xsh_create_master.c
                 "added decode_bp in pre frame subtraction operation, for qualifier generation" xsh_data_pre.c
                 "clarified decode_bp help" xsh_parameters.c
                 "fixed tag and filename of ON dark frame" xsh_mdark.c
                 "added xsh_cpl_size.h" Makefile.am 
                 "added to CVS" xsh_cpl_size.h
                 "changed QFLAG_MISSING_DATA from 2e20 to 2e29 as requested by reflex" xsh_badpixelmap.h
                 "flag bap pix in statistics according to decode_bp" xsh_badpixelmap.c
                 "changed interface of xsh_image_flag_bp()" xsh_create_master.c
                 "changed interface of xsh_image_flag_bp()" xsh_data_pre.c
                 "changs to remove compiler warnings to CPL6" xsh_dump.c
                 "remove NPIXSAT,FPIXSAT from output BP map" xsh_lingain.c
                 "fixed output file name of on frame product"  xsh_scired_slit_s
                 "trigger detlin recipe on detmon data" sinfo.oca
                 "changes for detmon to work" uves.properties
                 "trigger detmon recipe on linearity data" uves.oca
                 "added possoble problem with 2dmap" xsh_known_problems.tex
                 "added XSH_BUNIT, xsh_get_bunit(), xsh_set_buint()" xsh_pfits.h
                 "xsh_get_bunit(), xsh_set_buint()" xsh_pfits.c
                 "found/fixed bug on response bin correction" xsh_compute_response.c
                 "added BUNIT to extracted spectrum" xsh_data_rec.c
                 "added FLUX to data and errors on fluxx calibrated spectra" xsh_utils.c

1.3.21
                 "added XSH_IFU_MAP_SKY" xsh_dfs.h
                "added functions to build ifu map (jason)" xsh_utils_ifu.c
                 "added functions to build ifu map (jason)" xsh_utils_ifu.c
                 "added functions to build ifu map (jason)" xsh_utils_ifu.h
                 "added xsh_frame_image_save2ext,xsh_frame_image_add_double" xsh_utils_image.h xsh_utils_image.c

                 "added ifu map (Jason)" xsh_util_ifu_stare.c xsh_util_ifu_stare.c
                 "added ifu map (Jason)" xsh_util_ifu_stare.c xsh_util_ifu_offset.c

1.3.20           additional changes relalated to decode_bp:
                 "changes to use decode_bp" xsh_2dmap.c xsh_cfg_recover.c xsh_flexcomp.c xsh_mbias.c xsh_mdark.c xsh_mflat.c xsh_orderpos.c xsh_predict.c xsh_respon_slit_nod.c xsh_respon_slit_offset.c xsh_respon_slit_stare.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c xsh_util_ifu_offset.c xsh_util_ifu_stare.c xsh_wavecal.c 
 1103  cvs ci -m "changes to use decode_bp" xsh_combine_nod.c xsh_compute_linearity.c xsh_compute_linearity.h xsh_detect_order.c xsh_drl.h xsh_drl_check.c xsh_drl_check.h xsh_localize_obj.c xsh_merge_ord.c xsh_opt_extract.c xsh_rectify.c xsh_remove_crh_multi.c xsh_subtract.c xsh_subtract_sky_nod.c xsh_subtract_sky_offset.c xsh_subtract_sky_single.c xsh_utils.c xsh_utils.h xsh_utils_scired_slit.c xsh_utils_scired_slit.h 
                 "changes to use decode_bp" xsh_create_master.c xsh_data_pre.c xsh_data_pre.h
                 "changes to use decode_bp" test-xsh_combine_nod.c test-xsh_compute_noise_map.c test-xsh_create_master_bias.c test-xsh_create_master_dark.c test-xsh_data_cube.c test-xsh_detect_order.c test-xsh_geom_ifu.c test-xsh_localize_ifu.c test-xsh_localize_obj.c test-xsh_merge_ord.c test-xsh_opt_extract.c test-xsh_rectify.c test-xsh_remove_crh_multiple.c test-xsh_subtract_bias.c test-xsh_subtract_dark.c test-xsh_subtract_sky_nod.c test-xsh_subtract_sky_single.c

1.3.19
                 "changed call to xsh_compute_noise_map to reflect API change to allow to decode bad pixels" xsh_mdark.c
                 "changed call to xsh_compute_noise_map to reflect API change to allow to decode bad pixels" xsh_wavecal.c
                 "add parameter decode_bp to allow bad pixel decoding" xsh_badpixelmap.h
                 "add parameter decode_bp to allow bad pixel decoding" xsh_badpixelmap.c
                 "add parameter decode_bp to allow bad pixel decoding" xsh_compute_linearity.c
                 "add parameter decode_bp to allow bad pixel decoding" xsh_compute_noise_map.c
                 "somer changes to clean and speed up code" xsh_create_master.c
                 "somer changes to clean and speed up code" xsh_data_pre.c
                 "added decode_bp param to allow bad bixel decoding" xsh_drl.h
                 "added decode_bp param to allow bad bixel decoding" xsh_follow_arclines.c

                 "added decode-bp" xsh_parameters.
                 "changed call to xsh_detect_arclines due to function API change in order to control generation of tmp products" xsh_flexcomp.c xsh_2dmap.c xsh_predict.c
                 "changed API of xsh_create_dispersol_physmod to control generation of tmp products and removed xsh_follow_arclines function declaration as it is now a static function" xsh_drl.h
                 "changed API of xsh_create_dispersol_physmod to control creation of tmp products, added #include <xsh_data_instrument.h>" xsh_create_wavemap.c
                 "changed API of xsh_shift_tab_save to control temporary producs generation" xsh_data_shift_tab.h
                 "changed API of xsh_shift_tab_save to control temporary producs generation" xsh_data_shift_tab.c
                 "changed API of xsh_detect_arclines to control temporary producs generation" xsh_detect_arclines.c
                 "made changes to control generation of temporary products" xsh_follow_arclines.c
                 "changed API xsh_afcthetab_create to control generation of temporary products" xsh_flexcor.c

                 "Reflex analisis decided to remove generation of MASTER_BP_MAP_ARM" xsh_lingain.c
                 "updated master bias QUAL extention with combined BP map in case input BP map is provided" xsh_mbias.c
                 "updated master dark QUAL extention with combined BP map in case input BP map is provided. Changed PRO.CATG of DARK_ARM to DARK_ON_ARM" xsh_mdark.c
                 "updated master dark QUAL extention with combined BP map in case input BP map is provided." xsh_mflat.c
                 "added xsh_frame_qual_update()" xsh_badpixelmap.h xsh_badpixelmap.c
                 "fixed bug on output frame PRO.CATG" xsh_dfs.c

1.3.18
                 "do not set as temporary the subtracted frame not to have problems with scired_stare on a sky frame" xsh_data_pre.c
                 "changes to be able to control generation of tmp products" xsh_2dmap.c
                 "changes to be able to control generation of tmp products" xsh_cfg_recover.c
                 "changes to be able to control generation of tmp products" xsh_flexcomp.c
                 "changes to be able to control generation of tmp products" xsh_mdark.c
                 "changes to be able to control generation of tmp products, updated man page" xsh_mflat.c
                 "changes to be able to control generation of tmp products" xsh_orderpos.c
                 "changes to be able to control generation of tmp products, updated man page" xsh_predict.c
                 "changes to be able to control generation of tmp products" xsh_respon_slit_stare.c
                 "changes to be able to control generation of tmp products" xsh_scired_slit_stare.c
                 "changes to be able to control generation of tmp products" xsh_util_ifu_offset.c
                 "changes to be able to control generation of tmp products" xsh_util_ifu_stare.c
                 "changes to be able to control generation of tmp products" xsh_util_physmod.c
                 "changes to be able to control generation of tmp products" xsh_wavecal.c
                 "Declared master temporary product" xsh_badpixelmap.c
                 "changes to be able to control generation of tmp products" xsh_create_master.c
                 "changes to be able to control generation of tmp products" xsh_create_wavemap.c
                 "declared ORDER_TAB_CENTR_QTH_UVB,ORDER_TAB_CENTR_D2_UVB tmp products" xsh_data_order.c
                 "changes to be able to control generation of tmp products" xsh_data_pre.c
                 "changes to be able to control generation of tmp products" xsh_drl_check.c
                 "changes to be able to control generation of tmp products" xsh_drl.h
                 "changes to be able to control generation of tmp products" xsh_drl_check.c
                 "changes to be able to control generation of tmp products" xsh_drl_check.h
                 "changes to be able to control generation of tmp products" xsh_model_kernel.c
                 "changes to be able to control generation of tmp products" xsh_model_kernel.h
                 "changes to be able to control generation of tmp products" xsh_remove_crh_multi.c
                 "blemish mask is now a temporrary product" xsh_utils_image.c
                 "changes to be able to control generation of tmp products"  xsh_subtract.c
                  "changes to be able to control generation of tmp products" xsh_utils_scired_slit.c
                 "changes to reflect lib function API changes (to control generation of tmp products)" 

                 "DRS tag is now extra input" xsh_mflat.c
                 "added support for input XSH_BP_MAP tag" xsh_dfs.h
                 "input detectorder-qc-mode param from drs_tab if provided" xsh_parameters.h
                 "input detectorder-qc-mode param from drs_tab if provided" xsh_parameters.c
                 "allow load of BP map from 3rd extension" xsh_drl_check.c
1.3.17

                 "removed master BP map product" xsh_mbias.c
                 "changed on line help" xsh_mdark.c
                 "added xsh_image_flag_bp()" xsh_badpixelmap.h xsh_badpixelmap.c
                 "use xsh_image_flag_bp to flag bad pixel before computing statistics" xsh_create_master.c
                 "use xsh_image_flag_bp to flag bad pixel before computing statistics" xsh_data_pre.c
                 "add xsh_frame_head_extract_qc()" xsh_dfs.h xsh_dfs.c
                 "change xsh_create_master_dark2 API" xsh_drl.h
                 "change possible input BP maps from different recipes" xsh_drl_check.c

                 "clarified some error messages" xsh_flexcomp.c
                 "activated new master dark algorithm" xsh_mdark.c
                 "several corrections to new master dark algorithm (UVES-like)"  xsh_create_master.c
                 "added xsh_create_master_dark2" xsh_drl.h
                 "added XSH_QC_AFC_X/YSHIFT and comments" xsh_pfits_qc.h
                 "added XSH_QC_AFC_X/YSHIFT and comments" xsh_flexcor.c
                 "remove from statistics any line with flag > 0" xsh_follow_arclines.c
                 "fix cpl type related problem on low level function to compute ksigma" xsh_irplib_mkmaster.c
                 "reshuffled code to static function to better structure and understand flow" xsh_mdark.c
                 "added xsh_irplib_mkmaster_dark_fill_imagelist()" xsh_irplib_mkmaster.h xsh_irplib_mkmaster.c
                 "added xsh_create_master_dark2()" xsh_create_master.c
1.3.16

                 "updated to reflect changed algorithms for frame stacking" test-xsh_create_master_bias.c test-xsh_create_master_dark.c
                 "rename xsh_create_master_bias->xsh_compute_qc_on_master_bias" xsh_create_master.c xsh_drl.h
                 "rename xsh_create_master_bias->xsh_compute_qc_on_master_bias" xsh_mbias.c
                 "implemented XOR bitwise" xsh_badpixelmap.c
                 "removed some tmp PRE files" xsh_create_master.c
                 "remove files product in pre format if declared as temporary" xsh_data_pre.c
                 "removed some tmp PRE files" xsh_divide.c
                 "removed some tmp PRE files" xsh_flat_merge.c
                 "removed some tmp debug files" xsh_utils_image.c
                 "removed some tmp PRE files" xsh_subtract.c
                 "removed some tmp PRE files, set mode for error computation as Daniel wants" xsh_remove_crh_multi.c
                 "removed some tmp PRE files" xsh_remove_crh_single.c

                 "added mode param to xsh_collapse_errs() in order to have different computation for median and mean modes" xsh_utils_image.h xsh_utils_image.c
                 "added comment to say that we need a bitwise OR to combine bad pixels" xsh_badpixelmap.c
                 "added mode param to call xsh_collapse_errs()" xsh_create_master.c
                 "removed test param" xsh_parameters.c
                 "added mode param to call xsh_collapse_errs()" xsh_remove_crh_multi.c

                 "added to CVS" DRS_VIS.fits DRS_NIR.fits DRS_UVB.fits
                 "allows param input from DRS tarb" xsh_mbias.c xsh_mdark.c
                 "change API xsh_parameters_create_from_drs_table()" xsh_paramet
                 "allows param input from DRS tarb" xsh_create_master.c
                 "save some more products for debug" xsh_utils_image.c

                "changes to be able to input QC param from DRS tab (bias)" xsh_create_master.c xsh_create_master.c 
                "removed check on ron and fpn params as those are rtemoved from recipe" xsh_parameters.c
                "changes to be able to input QC param from DRS tab (bias)" xsh_mbias.c

1.3.15
                 "removed recipe-dependent param check" xsh_2dmap.c
                 "added stack params" xsh_absorp.c xsh_mbias.c xsh_mdark.c xsh_mflat.c  
                 "removed recipe-dependent param check" xsh_flexcomp.c
                 "added stack params" xsh_geom_ifu.c
                 "removed recipe-dependent param check" xsh_orderpos.c xsh_predict.c xsh_wavecal.c
                 "added stack params" xsh_respon_slit_nod.c xsh_respon_slit_offset.c xsh_scired_ifu_offset.c xsh_scired_slit_offset.c xsh_util_ifu_offset.c 
                 "added stack params" xsh_scired_slit_nod.c
                 "added stack params" xsh_scired_ifu_stare.c
                 "added stack params" xsh_scired_slit_stare.c
                 "added stack params" xsh_util_ifu_stare.c
                 "added drs par for bias creation" xsh_create_master.c
                 "added drs par for bias creation, stack param for CRH removal" xsh_drl.h
                 "added DRS tab for bias and generic one" xsh_dfs.h
                 "added stack par to call to xsh_check_remove_crh_multiple" xsh_drl_check.c
                 "added stack par to call to xsh_check_remove_crh_multiple" xsh_drl_check.h
                 "added stack par to call to xsh_nod_group_by_reloff" xsh_utils_scired_slit.h xsh_utils_scired_slit.c
                 "uses stack_par in xsh_remove_crh_multi" xsh_remove_crh_multi.c
                 "define and check stack params" xsh_parameters.c

                 "changeds to reflct addition of stack_params" test-xsh_compute_noise_map.c test-xsh_create_master_bias.c test-xsh_create_master_dark.c test-xsh_remove_crh_multiple.c

1.3.14
                 Unified parameter checking
                 Merged to XSH-Consortium work on branch
                 Unified ord by ord flux,errs,qual science ifu products
                 Added missing extensions on ord by ord stare products
                 Fixed WCS in IFU cubes
                 "fixed some quality problems in using smooth flat merging" xsh_flat_merge.c
                 "fixed some quality problems in using smooth flat merging" xsh_flat_merge.c
                 "fixed seg fault" xsh_irplib_mkmaster.c
                 "added ron computation parameters checks" xsh_parameters.c
                 "rename xsh_params_ron_determination_check xsh_params_compute_ron_check" xsh_parameters.h
                 "set to 5,5 parameters KS_HIGH KS_LOW" xsh_remove_crh_multi.c
                 "force flux evaluation in flat levels comparison to same x,y point" xsh_utils_image.c
                 "force flux evaluation in flat levels comparison to same x,y point" xsh_utils_image.c

                 "implemented method for merging smoothly flats" xsh_flat_merge.c
                 "added xsh_combine_flats()" xsh_utils_image.h xsh_utils_image.c

                 "some cleaning" xsh_mbias.c
                 "some cleaning" xsh_mdark.c
                 "removed DP and SP as products" xsh_mflat.c
                 "more robust reduction for CRH clip" xsh_remove_crh_multi.c

                 "removed CRH input params and changed way to compute master bias in mean method" xsh_mbias.c
                 "added xsh_irplib_mkmaster.h xsh_irplib_mkmaster.c" Makefile.am
                 "added xsh_create_master_bias2() from xsh_remove_creh_multi()" xsh_create_master.c
                 "changed xsh_create_master_bias2 API" xsh_drl.h
                 "fixed compiler warnings" xsh_parameters.c
                 "some function refactoring and moved xsh_create_master_bias2 to xsh_create_master"  xsh_remove_crh_multi.c
                 "added xsh_collapse_errs()" xsh_utils_image.h xsh_utils_image.c

1.3.13           
                 Added xsh_util_bpmap2rp
                 fixed bug in croxing NL NIR bad pixels
                 If overscan correction < 1e-6 we exit with error.
                 Now it is possible to flux calibrate spectra using optimal extraction.
1.3.12           
                 Automatic recover (to param defaults) of parameters with improper value
                 More clear message in case of wrong input param settings.
                 Fixed DFS10428: xsh_wavecal: qc.wavecal.diffystd uses also flagged lines
1.3.11           Fixed 10574 Illegal keywords in XSH products
1.3.10           Updated reflex wkf using AFC corrected results
1.3.9
                 "now we make pixel code coaddition" xsh_badpixelmap.c
                 "now a master bp map is always generated, either copy of non lin pix map or with coadded input bad (static) pixels" xsh_lingain.c
                 "more accurate messaging for bad pix map generation" xsh_mbias.c
                 "now recipe generates a master bp map also if there is no input bp map" xsh_mdark.c
                 "generalized function to coadd bad pixels" xsh_drl_check.c

                 "if the user provides a master response curve this is used to flux calibrate the data" \
                 "if the user provides a master response curve this is used to flux calibrate the data" xsh_respon_slit_nod.c xsh_respon_slit_offset.c xsh_respon_stare.c
                 "added QC_WAVECAL_NLININT_C QC_WAVECAL_INTAVG QC_WAVECAL_INTAVG_C" xsh_pfits_qc.h
                 "change API function retrieves the nod recipe input" xsh_utils_scired_slit.c
                 "change API function retrieves the nod recipe input" xsh_utils_scired_slit.h
                 "uses QC_WAVECAL_INTAVG,QC_WAVECAL_INTAVG_C,QC_WAVECAL_NLININT,QC_WAVECAL_NLININT_C" xsh_utils_table.c


                 "product BP map has now recipe dependent PRO.CATG" xsh_lingain.c
                 "product BP map has now recipe dependent PRO.CATG" xsh_mbias.c
                 "product BP map has now recipe dependent PRO.CATG" xsh_mdark.c
                 "product BP map has now recipe dependent PRO.CATG" xsh_mflat.c
                 "renamed xsh_create_master_bpmap->xsh_create_master_dark_bpmap, uses defines for PRO.CATG value" xsh_create_master.c
                 "renamed xsh_create_master_bpmap->xsh_create_master_dark_bpmap" xsh_drl.h
                 "renamed xsh_create_master_bpmap->xsh_create_master_dark_bpmap" xsh_qc_definition.h
                 "passes rec_id to xsh_check_load_master_bpmap() function" xsh_drl_check.h xsh_drl_check.c
                 "uses explicit BP map kind (flat) in xsh_badpixelmap_crea_master_from_bpmap()"
                 "uses explicit BP map kind (flat) in xsh_badpixelmap_crea_master_from_bpmap()" xsh_badpixelmap.c

1.3.8            xsh_mbias.c now bias recipe generates a BP map also if no input BP map is provided
1.3.7
                  xsh_compute_response.c fixed 3 bugs in bad pix correction 
                       during response computation that could lead to negative 
                        response and/or nan/inf results

                  Fixed problems stare data reduction in case no master bias is provided (and pscan param is set to 1)
1.3.6
                  Further bug fixes to make more robust efficiency computation
1.3.5
                  xsh_utils_table.c "fixed bug computing line intensity on UVB,VIS arm"
                  xsh_utils_efficiency.c more robust computation of statistics on eff table
1.3.4
                 "last changes for IFU" Xshooter.xml Xshooter_wkf_no_mjd_obs.oca
                 "changed call to xsh_add_product_bpmap()" xsh_linear.c xsh_lingain.c xsh_mdark.c 
                 "changed call to xsh_add_product_bpmap()" xsh_mflat.c
                 "changed call to xsh_add_product_bpmap()" xsh_linear.c xsh_lingain.c xsh_mdark.c 
                 "changed implementation xsh_add_product_bpmap" xsh_dfs.c
                 "added check in efficiency computation to prevent generation of nan (but why they are appearing?)" xsh_utils_efficiency.c

1.3.3
                 Improve Reflex wkf
                 "fixed problem with detectarclines-search-window-half-size" xsh_parameters.c
                 "default detectcontinuum-clip-res-max to -1, to support Reflex wkf (internally if <=0 the value is re-set to proper value as original defaults)"  xsh_parameters.c
                 "changes default of detectcontinuum-clip-res-max and detectcontinuum-clip-frac to -1 to be able to run Reflex with proper arm-dependent values (internally if <0 the param value is re-set to proper value, arm dependent, to the same values as initially was)" xsh_orderpos.c

                 "now detectarclines-min-sn is defaulted to -1 and in that case properly set according to the arm" xsh_predict.c 
                 "now detectarclines-min-sn, and detectarclines-fit-window-hsize are defaulted to -1 and in that case properly set according to the arm" xsh_2dmap.c 
                 "now detectarclines-min-sn, and detectarclines-fit-window-hsize are defaulted to -1" xsh_parameters.c
                 "changes to use not AFC corrected model cfg and order tab in scired offsrt and nod" Xshooter_wkf_no_mjd_obs.oca

                 "added INSTRUME key"
                 "added support for XSH_LINEARITY_ARM_ON,XSH_LINEARITY_ARM_OFF  ARM=UVB,VIS,NIR" xsh_dfs.h
                 "replaced XSH_LINEARITY_ARM by XSH_LINEARITY_ARM_ON and XSH_BIAS_ARM by XSH_LINEARITY_ARM_OFF for ARM=UVB,VIS to better support different arms in Reflex workflow" xsh_lingain.c
                 "replacd BIAS_ARM by LINEARITY_ARM_OFF tag and LINEARITY_ARM by LINEARITY_ARM_ON for ARM=UVB,VIS and allowed Reflex reduction chain in case of no input linearity frames by allowing min_ret=0 in XSH_BP_MAP_NL_WKF input of science recipes" Xshooter_wkf_no_mjd_obs.oca
                 "additional changes" Dummy8.xml 

                 "fixed bug on PRO.CATG of TRACE frame product (DFS10359)"  xsh_utils_ifu.c
                 "initialized throwname to throwlist.asc not to have problems with Reflex actor instantiation" xsh_scired_slit_nod.c xsh_scired_slit_offset.c
                 "added ATMOS_EXT in Fitsrouter" 
                 "updated" Xshooter.xml
                 "fixed run time error on scired" Xshooter.xml
                 "removed MASSOC entries" Xshooter_wkf_no_mjd_obs.oca
                 "removed RASSOC entries" Xshooter_wkf_no_mjd_obs.oca
                 "small changes" 
                 "latest improvements" Xshooter.xml
                 "added to CVS" dummy26.xml
                 "update" dummy26.xml
                 "added to CVS" Dummy1.xml Dummy2.xml Dummy3.xml Dummy4.xml Dummy5.xml Dummy6.xml Dummy7.xml Dummy8.xml dummi26.xml
                 "changed xsh_build_ifu_cube API" xsh_utils_ifu.h
                 "add cpl_table* result=NULL;" xsh_utils_image.c 
                 "added support for XSH_IFU_CFG_COR_*" xsh_dfs.h
                 "add poly fit to traces" xsh_utils_ifu.c
                 "extend allowed name size to 256 to prevent seg fault in case of long file names"  xsh_lingain.c
                 "changed API xsh_build_ifu_cube" xsh_util_ifu_offset.c xsh_util_ifu_stare.c

1.3.2
                 "added XSH_QC_TRACE_FIT_Ci,XSH_QC_TRACE_FIT_DIFF_Ci,XSH_QC_TRACE_FIT_DIFF_POS" xsh_pfits_qc.h
                 "commented out unnecessary QC on each single trace" xsh_utils_ifu.c
                 "more QC on IFU traces" xsh_utils_image.c

1.3.1
                 "distinguish different elements in case of NIR data reduction for INTMON" xsh_utils_table.c
                 "activated arc line intensity monitoring if ARC_LINE_INTMON_ARM input table is provided" xsh_predict.c
                 "activated arc line intensity monitoring if ARC_LINE_INTMON_ARM input table is provided" xsh_2dmap.c 
                 "fixed a number of errors (wrong input table column name) related to arc line intensity monitoring" xsh_utils_table.c
                 "further improvements" dummy19.xml
                 "removed MASSOC (not digested by reflex) and replace XSH_MOD_CFG_TAB_ARM by XSH_MOD_CFG_OPT_AFC_ARM in response/scired inputs" Xshooter_wkf_no_mjd_obs.oca

1.3.0
                 Fix some of the compiler warnings and memory leaks.
1.2.15
                 "now response 1D frame is always computed, with check on result" xsh_respon_stare.c
                 "added qc check on response result" xsh_respon_slit_nod.c
                 "now response 1D frame is always computed, with check on result" xsh_respon_slit_offset.c

                 "added 3 points from LA-Silla table (xsh_atmoexan_uvb.fits) to fix cut problem below ~340nm" xsh_paranal_extinct_vis.fits
                 "added 3 points from LA-Silla table (xsh_atmoexan_uvb.fits) to fix cut problem below ~340nm" xsh_paranal_extinct_nir.fits

                 "generate some product in IFU mode only if debug level is at least medium" xsh_detect_order.c
                 "removed temporary image of bias difference (used for QC)" xsh_utils_image.c
                 "standardized tempirary product file name (to have less products at the end)" xsh_create_master.c
                 "standardized temporary product (to have less products)" xsh_mdark.c


                 
1.2.14
                 "changes to allow line intensity monitoring as asked by QC" 
                 "changes to allow line intensity monitoring as asked by QC" xsh_2dmap.c
                 "added xsh_wavecal_qclog_intmon() to monitor arc frame line intensity" xsh_utils_table.h
                 "added xsh_wavecal_qclog_intmon() to monitor arc frame line intensity" xsh_utils_table.c
                 "Promoted temporary to final product (optimal extraction)" xsh_data_rec.c
                 "added columns useful to compute arc line intensity" xsh_data_resid_tab.c
                 "added columns useful to compute arc line intensity" xsh_data_resid_tab.h
                 "changes to allow line intensity monitoring as asked by QC" xsh_detect_arclines.c
                 "added definition of XSH_ARC_LINE_LIST_INTMON" xsh_dfs.h

                 "added setting of frame tag to frame in case of no interorder bkg subtraction" xsh_scired_slit_stare.c
                 "if no master BP map is provided in input a new is generated out of DP and HP" xsh_mflat.c
                 "if no master BP map is provided in input a new is generated out of DP and HP" xsh_mflat.c
                 "added xsh_badpixelmap_crea_master_from_bpmap()" xsh_badpixelmap.c
                 "added xsh_badpixelmap_crea_master_from_bpmap()" xsh_badpixelmap.h
                 "some files that where declared temporary products are not anymore such" xsh_mdark.c
                 "some files that where declared temporary products are not anymore such" xsh_badpixelmap.c
                 "some files that where declared temporary products are not anymore such" xsh_compute_linearity.c
                 "some files that where declared temporary products are not anymore such" xsh_create_wavemap.c
                 "some files that where declared temporary products are not anymore such" xsh_create_wavemap.c
                 "some files that where declared temporary products are not anymore such" xsh_compute_noise_map.c
                 "some files that where declared temporary products are not anymore such" xsh_create_order_table.c
                 "some files that where declared temporary products are not anymore such" xsh_data_arclist.c
                 "some files that where declared temporary products are not anymore such" xsh_data_order_resid_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_pre.c
                 "some files that where declared temporary products are not anymore such" xsh_data_pre_3d.c
                 "some files that where declared temporary products are not anymore such" xsh_data_resid_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_shift_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_star_flux.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_arclines.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_continuum.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_order.c
                 "in case of no bkg subtraction we name the not interorder bkg subtracted frame properly" xsh_scired_slit_stare.c

                "extinction column is expected now to be named 'EXTINCTION'"                  xsh_compute_response.c xsh_data_atmos_ext.h xsh_utils.c 
                 xsh_utils_efficiency.c xsh_util_efficiency.c 
                 xsh_util_efficiency2d.c

                 Fixed small bug n PIPEFILE products xsh_mdark
                 Fixed bug in eff computation if using Nando's atm ext tab

                 "added setting of frame tag to frame in case of no interorder bkg subtraction" xsh_scired_slit_stare.c
                 "if no master BP map is provided in input a new is generated out of DP and HP" xsh_mflat.c
                 "if no master BP map is provided in input a new is generated out of DP and HP" xsh_mflat.c
                 "added xsh_badpixelmap_crea_master_from_bpmap()" xsh_badpixelmap.c
                 "added xsh_badpixelmap_crea_master_from_bpmap()" xsh_badpixelmap.h
                 "some files that where declared temporary products are not anymore such" xsh_mdark.c
                 "some files that where declared temporary products are not anymore such" xsh_badpixelmap.c
                 "some files that where declared temporary products are not anymore such" xsh_compute_linearity.c
                 "some files that where declared temporary products are not anymore such" xsh_create_wavemap.c
                 "some files that where declared temporary products are not anymore such" xsh_create_wavemap.c
                 "some files that where declared temporary products are not anymore such" xsh_compute_noise_map.c
                 "some files that where declared temporary products are not anymore such" xsh_create_order_table.c
                 "some files that where declared temporary products are not anymore such" xsh_data_arclist.c
                 "some files that where declared temporary products are not anymore such" xsh_data_order_resid_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_pre.c
                 "some files that where declared temporary products are not anymore such" xsh_data_pre_3d.c
                 "some files that where declared temporary products are not anymore such" xsh_data_resid_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_shift_tab.c
                 "some files that where declared temporary products are not anymore such" xsh_data_star_flux.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_arclines.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_continuum.c
                 "some files that where declared temporary products are not anymore such" xsh_detect_order.c
                 "in case of no bkg subtraction we name the not interorder bkg subtracted frame properly" xsh_scired_slit_stare.c

                "extinction column is expected now to be named 'EXTINCTION'"                  xsh_compute_response.c xsh_data_atmos_ext.h xsh_utils.c 
                 xsh_utils_efficiency.c xsh_util_efficiency.c 
                 xsh_util_efficiency2d.c

                 Fixed small bug n PIPEFILE products xsh_mdark
                 Fixed bug in eff computation if using Nando's atm ext tab
1.2.13
                 Fixed seg fault xsh_mflat due to updated way to save product (master bp map)
                 Merged xsh-1_2_4-devel brunch to head
1.2.12
                 Changed xsh_add_product_* saving function to simplify/unify/generalize them
                 Fixed problem in case of AFC frames when creating DISP tab PRO.CATG (xsh_data_wavemap.c)
1.2.11
                 "fixed typo in automatic switch to sobel tracing method for IFU mode"  xsh_mflat.c
                 "changed to RESPONSE the column to be monitored for QC" xsh_respon_slit_offset.c
                 "changed to RESPONSE the column to be monitored for QC" xsh_respon_stare.c
                 "changed to RESPONSE the column to be monitored for QC" xsh_util_compute_response.c
                 "added columns OBS and REF, and renamed FLUX to RESPONSE, to response product as asked by QC" xsh_compute_response.c
                 "Take into account that now response values are in 'RESPONSE' and not anymore in 'FLUX' column" xsh_utils.c

                 Set xsh_mflat default param value for 
                  "detectorder-slice-trace-method" to 'sobel' in IFU mode.

                 "change interface xsh_dispersol_list_save() to allow to specify dispersion frame tag" xsh_data_dispersol.c xsh_data_dispersol.h
                 "make dispersion frame tag depend on AFC for xsh_flexure AFC corrected products" xsh_data_wavemap.c
                hanges due to change of function to compute disp tab in order to allow to specify the tag (if the frame has been corrected for flexures)"  xsh_flexcomp.c
                hanges due to change of function to compute disp tab in order to allow to specify the tag (if the frame has been corrected for flexures)"  xsh_flexcomp.c
                 "changes due to change of function to compute disp tab in order to allow to specify the tag (if the frame has been corrected for flexures)"  xsh_flexcomp.c

1.2.10
                 added support of XSH_MOD_CFG_OPT_AFC_ARM for xsh_respon_slit_nod/offset
1.2.9
                 "fix compiler warnings" xsh_mbias.c
                 "fix compiler warnings" xsh_mdark.c
                 "fix compiler warnings" xsh_mflat.c
                 "fix mem leaks and change interpolation step from 0.01 to 1 nm to fix response level" xsh_compute_response.c
                 "fixed compiler warning" xsh_flexcor.c
                 "added support of flexcor step in pro.catg list" xsh_model_kernel.c
                 "some clean of output" xsh_utils.c
                 "set to 1.e-5 efficiency lower limit" xsh_utils_efficiency.c

                "trigger xsh_response on flux std and xsh_scired on telluric std. Add check on EXPTIME/DIT on master darks if required input" xsh.oca
                 "fixed typo" xsh.oca
                 "changed input XSH_MOD_CFG_TAB_AFC-->XSH_MOD_CFG_OPT_AFC" xsh_flexcomp.c
                 "changed input XSH_MOD_CFG_TAB_AFC-->XSH_MOD_CFG_OPT_AFC" xsh_model_compute.c
                 "fixed compiler warning" xsh_mflat.c
                 "added possibility to set high-abs-windows from a table" xsh_respon_slit_nod.c xsh_respon_slit_offset.c xsh_respon_stare.c
                 "replaced input RESPONSE_ORDER1D by RESPONSE_MERGE1D" xsh_scired_slit_nod.c
                 "replaced input RESPONSE_ORDER1D by RESPONSE_MERGE1D" xsh_scired_slit_offset.c
                 "replaced input RESPONSE_ORDER1D by RESPONSE_MERGE1D" xsh_scired_slit_stare.c
                 "replaced input XSH_MOD_CFG_TAB_AFC by calib,XSH_MOD_CFG_OPT_AFC,
                 "replaced input XSH_MOD_CFG_TAB_AFC by calib,XSH_MOD_CFG_OPT_AFC" xsh_util_ifu_offset.c xsh_util_ifu_stare.c
                 "allow to input high-abs-windows from a input reference table" xsh_compute_response.c
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_dfs.h xsh_dfs.c
                 "replace output XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_flexcor.c
                 "replace output XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_model_io.c
                 "replaced XSH_RESPONSE_ORDER1D_SLIT by XSH_RESPONSE_MERGE1D_SLIT and added support of XSH_MOD_CFG_OPT_AFC" xsh_utils_scired_slit.c

1.2.8

Paul changes on xsh_flexcomp-NIR:
I refined this a bit by setting up a reduced set of parameters that get
annealed (scenario=9) that correspond to the parameters were identified in
the flexure analysis that I did. This means that there is not such a large
group of parameters getting (in some cases arbitrarily) adjusted, but the
residuals achieved are just as good.                 

                 Changed PRO.SCIENCE detmon products from T to F

                 Fixed problem PRO.CATG of master bad pixel map of xsh_mflat
                 In case no input master BP map is provided and is provided an
                 input BP_MAP_NL_ARM from detmon recipes.

                 Now all response recipes apply response computed on merged 
                 frame and not the one computed order by order to flux 
                 calibrate science products.
1.2.7
                 Flux calibration is computed using the response computed i
                 on the merged spectrum.
                 Paul improved the flexcomp for NIR:

It now does an anneal which is essentially the same as xsh_predict with the default scenario=3. Regarding prism temperatures, this uses the same logic as for the shift, i.e. parameter change is calculated under the assumption that the phys mod is evaluated at the temperature of the AFC. (In practise the NIR temperature is very stable anyway).

1.2.6
                 Added BP_MAP_NL_arm (raw format-from detmon cross-instruments 
                 recipe) as possible input of xsh_mbias, xsh_mdark xsh_mflat

                 "added xsh_bpmap_2pre()" xsh_drl.h
                 "added xsh_check_load_master_bpmap()" xsh_drl_check.h xsh_drl_check.c
                 "added XSH_BP_MAP_NL as supported possible input BP map tag for detmon_opt_lg" xsh_data_pre.c
                 "added xsh_bpmap_2pre()" xsh_bpmap_2pre
                 "added xsh_bpmap_2pre()" xsh_prepare.c
                 "Decreased of 2 bins the value of slit_ext_max in NOD extraction mode to decrease the noise in the spectrum and in the associated error" xsh_extract.c
                 "if the NL BP map is provided, it is checked if in PRE format or eventually realigned and then coadded to the master BP map" xsh_mbias.c xsh_mdark.c

                 Improved response computation smoothness
                 "update to latest detmon" xsh_detmon.c xsh_detmon.h xsh_detmon_lg.c xsh_detmon_lg.h
                 "fix compiler warnings" xsh_create_master.c
                 "refactor response computation" xsh_compute_response.c
                 "fix compiler errors" xsh_dfs.c
                 "fix compiler errors" xsh_utils.c


                 Updated lingain recipe to latest detmon version
                 "fixed a bug in mean flux computation occurruing when all 
                  sampling values are not valid. In this case we arbitrary 
                  set the mean to -999" xsh_utils_table.c

                 "changed interface of compute_efficiency_internal to count 
                  how many points are clipped out (<0 or >1)" 
                  xsh_utils_efficiency.h xsh_utils_efficiency.c

1.2.5:           Fixed problem in assigning offset to each nod pair properly taking into account of
                 position of reference object
1.2.4:
                 xsh_2dmap: changed default mode-compute-map to TRUE

                 DISP TAB is now optional input of xsh_wavecal, 
                 required to compute spectral format resolution

                 Added efficiency computation
                 Moved response/scired common functionality to xsh_utils_scired.c/h
                 Fixed efficiency computation
		 Removed PAF generation
                 Fixed xsh_lingain failure when ref BP map is 1st frame of sof


Changes from Andrea:
                 "updated doc: XSH_MOD_CFG_TAB_AFC_arm->XSH_MOD_CFG_OPT_AFC_arm" xsh_flexcomp.c
                 "input DISP tab must now be XSH_DISP_TAB_AFC to make sure the user uses an AFC corrected dispertion table" xsh_geom_ifu.c
                 "XSH_MOD_CFG_TAB_AFC_VIS-->XSH_MOD_CFG_OPT_AFC_VIS, but on a commented line" xsh_model_compute.c
                 "input model tab changed from XSH_MOD_CFG_TAB_ARM to XSH_MOD_CFG_OPT_AFC_ARM and the AFC corrected model cfg is the only allowed (force the user to correct for AFC when reducing IFU data)" xsh_scired_ifu_stare.c
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_util_ifu_offset.c
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC (update also man page)" xsh_util_ifu_stare.c 
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_dfs.h
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_dfs.c
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC for product after flexure compensation" xsh_flexcor.c
                 "replace XSH_MOD_CFG_TAB_AFC by XSH_MOD_CFG_OPT_AFC" xsh_model_io.c

1.2.3:
                 Fixed response computation bug affecting flux calibration in xsh_response_nod.c

                 "uses common functionality to compute response/flux calibrated spectrum, add all possible response-fluxaclibrated results to final products, with updated PRO.CATG" xsh_respon_slit_nod.c 
                 "uses common functionality to compute response/flux calibrated spectrum, add all possible response-fluxaclibrated results to final products, with updated PRO.CATG" xsh_respon_slit_offset.c
                 "uses common functionality to compute response/flux calibrated spectrum, add all possible response-fluxaclibrated results to final products, with updated PRO.CATG" xsh_respon_stare.c
                 "uses common functionality to compute response/flux calibrated spectrum, add all possible response-fluxaclibrated results to final products, with updated PRO.CATG" xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c xsh_util_compute_response.c xsh_util_efficiency1d.c
                 "added XSH_RESPONSE_ORDER1D_SLIT" xsh_dfs.h
                 "removed filename from compute_response functions as that can be set internally" xsh_drl.h
                 "removed filename from compute_response functions as that can be set internally. Distinguish RESPONSE_MERGE1D_SLIT_ARM from RESPONSE_ORDER1D_SLIT_ARM products" xsh_compute_response.c
                 "xsh_flux_calibrate() now returns also order-by-order flux calibrated product" xsh_utils_scired_slit.h xsh_utils_scired_slit.c


                 Reduced doxygen warnings

                 "demoted a message to xsh_msg_dbg_medium" xsh_extract.c
                 "demoted a message to xsh_msg_dbg_medium" xsh_rectify.c
                 "clarified and cleaned messaging, added a lower threshold 0 in efficiency results" xsh_utils_efficiency.c
                 "forcing flux conservation before spectra used in efficiency computation is rectified" xsh_respon_stare.c


 
                 "fixed several doxygen warnings" xsh_utils.c xsh_utils_efficiency.c xsh_utils_ifu.c xsh_utils_image.c
                 "increased XSH_STAR_FLUX_UVB_WAV_MIN from 305 to 308" xsh_data_star_flux.c
                 "decreased resample_step_nm from 5 to 1 to improve response quality" xsh_compute_response.c

                 "Compute response ordr-by-ord. Use xsh_flux_calibrate() to apply it"  xsh_respon_slit_offset.c
                 "Compute response ordr-by-ord. Use xsh_flux_calibrate() to apply it"  xsh_respon_stare.c
                 "Use xsh_flux_calibrate() to apply response"  xsh_respon_stare.c
                 "Use xsh_flux_calibrate() to apply response"  xsh_scired_slit_offset.c
                 "Use xsh_flux_calibrate() to apply response"  xsh_scired_slit_stare.c
                 "added utils to list of plug-ins" Makefile.am
                 "cleaned output" xsh_utils_table.c
                 "fixed bug computing average airmass" xsh_pfits.c
                 "cleaned output" xsh_data_rec.c
                 "changed XSH_STAR_FLUX_UVB_WAV_MIN from 309 to 305 to have robust data reduction in UVB for ord-by-ord response computation" xsh_data_star_flux.c
                 "Fixed bug on PRO.CATG checks" xsh_merge_ord.c
                 "fixed bug generation slit/wave maps" xsh_model_kernel.c
                 "fixed bug setting PRO.CATG" xsh_utils.c
                 "added xsh_flux_calibrate()" xsh_utils_scired_slit.h xsh_utils_scired_slit.c


                 "added xsh_dfs_extract_pro_frames()" xsh_dfs.c
                 "write debug_fit%d files only in demub medium level" xsh_subtract_sky_single.c
                 "we compute unbinned THE map to easier plots from QC garching" xsh_utils_scired_slit.c
                 "added support for XSH_NORM_ORDER2D XSH_NORM_ORDER1D" xsh_merge_ord.c
                 "resampling set to 5nm" xsh_compute_response.c



                 Changed unit convention in SKY_TAB_MULT_ARM product to easy QC                  (Garching) plots: units are now [pix]

                 "changed algorithm for dead/saturated pixel detection. Use version derived 
                  by UVES blemishes detection, that works, with hard-coded values of kappa=4 
                  and niter=3. This means that corresponding parameters have been removed" 
                  xsh_mflat.c

                 "activated xsh_frame_table_monitor_flux_qc() to test it" 
                 xsh_util_compute_response.c

                 "use xsh_util_multiply_by_response_ord and xsh_merge_ord to 
                  test order-by-order response computation" xsh_util_apply_response.c
 

                 "added xsh_pfits_get_airm_mean()" xsh_pfits.c xsh_pfits.h

                 "refactoring xsh_frame_table_monitor_flux_qc()" xsh_utils_table.c

                 "added xsh_image_mflat_detect_hotcold()" xsh_utils_image.h xsh_utils_image.c

                 "changed interface xsh_normalize_spectrum_image() to simplify implementation 
                  removing dependency from header of raw_header,correct_binning,instrument" 
                  xsh_utils.h xsh_utils.c

                 "xsh_slit_stare_get_calibs() does not require to get response and atmext" 
                  xsh_utils_scired_slit.h xsh_utils_scired_slit.c

                 "simplified xsh_get_std_obs_values()" xsh_utils_efficiency.c

                 "updated doxygen, removed a code that was anyway not included by precompiler 
                  (#if 0  .. #endif). Allows to use xsh_rec_list_load with ESO format 
                  order-by-order extracted/rectified frames" xsh_merge_ord.c

                 "added XSH_FLUX_* defines" xsh_dfs.h


                 "added xsh_compute_response_ord() for order-by-ord response computation" 
                  xsh_drl.h xsh_compute_response.c 
                 "added CRPIX2,CRVAL2,CDELT2 on ORDER1D product as it is an image, to 
                  allow order-by-order computation" xsh_data_rec.c 

                 "added xsh_spectrum_save_order() xsh_spectrum_load_order() for 
                  order-by-order response computation" xsh_data_spectrum.h xsh_data_spectrum.c

                 "added xsh_star_flux_list_save_order() for order-by-order response computation"
                  xsh_data_star_flux.h
  
                 "added xsh_star_flux_list_save_order() for order-by-order response computation"
                  xsh_data_star_flux.c

                 "changes to test order by order response computation" xsh_util_compute_response.c
                 "aded back xsh_util_compute_response.c" Makefile.am

                 "removed compiler warnings" xsh_lingain.c
                 "use functions from xsh_utils_scired_slit to compact and unify code to 
                  xsh_scired_slit_offset" xsh_respon_slit_offset.c

                 "fixed compiler warnings" xsh_utils_image.c
                 "binx/y should be searched only in NIR data" xsh_utils_scired_slit.c
                 "removed dependency from xsh_localize_obj_param" xsh_util_ifu_offset.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_detect_arclines.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_drl_check.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_flexcor.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_follow_arclines.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_rectify.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_utils_scired_slit.h xsh_utils_scired_slit.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_model_utils.h
                 "replace bool by int for portability as bool is not a standard C type" xsh_model_utils.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_2dmap.c xsh_cfg_recover.c xsh_geom_ifu.c xsh_linear.c xsh_lingain.c xsh_startup.c 
                 "fixed compiler warnings" xsh_respon_slit_nod.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_wavecal.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_util_physmod.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_util_ifu_stare.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_util_ifu_stare.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_util_ifu_offset.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_util_bpmap_coadd.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_scired_slit_stare.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_scired_slit_nod.c
                 "replace bool by int for portability as bool is not a standard C type" xsh_scired_ifu_stare.c
                 "using functions defined in xsh_utils_slit_stare to compact code and unify it to scired-slit-stare" xsh_respon_stare.c


                 Creating branch
                 Added xsh_model_maps_create()
                 Added test-xsh_model_maps_create.c
                 Added xsh_respon_slit_nod.c (not yet tested)

                 Fixed bug in filling matrix in LA-cosmic (indexes 
                 must start from 0)

                 added xsh_util_bpmap_nl_raw2pre recipe in case QC uses detmon
                 lingain to have conversion from RAW to PRE format
                 Refactoring common functionality in scired and response function, moving this to xsh_utils_scired_slit 
                 in order to unify code across response and scired recipes.
                 Removed dependency xsh_localize_params in xsh_util_ifu_offset
1.2.2:
                 Fixed error xsh_lingain if RP map is provided in input 
                 Fixed robustness line detection on ARC SLIT & IFU frames
                 Fixed typo in PIPEFILE names in case SKY frame appears 
                 before object in offset observations

                 Allow to have input wave and slit maps in 
                 xsh_scired_slit_staere and xsh_respon_slit_stare to save 
                 computation time.

                 Fixed error on variance propagation in IFU mode.
                 Fixed error switching off sky subtraction in xsh_scired_slit_stare
1.2.1:
                 Changes from Paul on physmod and flexcomp:
                 1. Further correction to 2x2 binning such that:
                 a) n_d=n/2 [n_d is floating point double binned co-ord, 
                    n is floating point un-binned co-ord]
                 b) bins are alligned such that double bin pixel N_d contains 
                    unbinned pixels N=2N_d-1 & N=2N_d
                 c) centre of double binned pixel N_d is now N_d-0.25
                    Unbinned mode is NOT affected.

                 2. In flexcomp the offset of AFC measured line positions 
                    relative to phys mod WITHOUT temperature adjustment 
                    (affects all prisms and UVB focus) is also calculated. 
                    By comparison with the offset relative to phys mod with 
                    temperature adjustment the mean effect of the temperature 
                    adjustment can be estimated and used to bring poly mode 
                    (which has no temperature adjustment) and phys mod mode 
                    order tables into agreement.

                 Fixed bug response computation in offset mode.
                 Swap order of orderdef UVB tags so that it is used only D2 
                 in case the user provides both of them.
                 Added Bary & Heli corrections  computations (during order 
                    rectification)
1.2.0:
                 Fixed problem on line detection in case of bad bad pix map
                 Updated reference FITS.
                 Fixed problem in computing  QC WAVECAL MATCHLINE in xsh_follow_arclines.c
                 Set model temperature as the one or slit-arc frame.
                 Fixed mem leaks
                 "fixed compiler warnings"
                 "fixed compiler warnings" xsh_utils.c xsh_model_kernel.c xsh_follow_arclines.c xsh_data_linetilt.c xsh_compute_slice_dist.c
                 "fixed compiler warnings" xsh_wavecal.c

1.1.7:
1.1.7:
1.1.7:
                 Fixed crush wavecal in case of missing input file and corrected man page. Added mode info on 'ON' product.
                 Replace XSH_MOD_CFG_ARM value by XSH_MOD_CFG_TAB_ARM. 
                 This affects xsh_util_physmod (allows to have a unique 
                 TAG for the starting model CFG both in xsh_predict and 
                 xsh_util_physmod so that one can use the same reference 
                 frame, for example in gasgano (that reads from the frame 
                 the PRO.CATG if set).
                 Allow only uniform value estimation for pre/overscan estimate.
                 changed input tag XSH_MOD_CFG-->XSH_MOD_CFG_TAB in xsh_util_physmod
                 Added support for XSH_STD_FLUX_OFFSET,XSH_STD_TELL_OFFSET in response recipes
                 "updated to new pipe, added response (stare,offset) and extra master and ref frame dependency" xsh.oca
                 "updated" configure.ac
                 "updated short man" xsh_respon_slit_offset.c
                 "updated short man" xsh_respon_stare.c
                 "moved order flux calibrated products" xsh_scired_slit_offset.c
                 "moved order flux calibrated products" xsh_scired_slit_stare.c
                 "removed xsh_util_apply_response, xsh_util_compute_response, xsh_util_efficiency1d" Makefile.am

                Fixed robustness xsh_respon_slit_stare in case STD star is not in catalog
                repleplaced PREFIX_SKY_ORD_1D_ARM->PREFIX_SKY_ORD1D_ARM
                repleplaced PREFIX_TMPSKY_SKY_ORD_1D_ARM->PREFIX_TMPSKY_SKY_ORD1D_ARM
                 "fixed crush saving flux calibrated spectra" xsh_respon_slit_offset.c
                 "fixed crush saving flux calibrated spectra" xsh_scired_slit_offset.c

1.1.6:
                Included gain correction in response computation in order to 
                be able to cross calibrate stars acquired with different gain 
                settings. That means the response is in electron units.

                "swap slit/lambda param default values (was wrong) and set properly parameter value in case it is overwritten to have proper FITS header param value"  xsh_geom_ifu.c xsh_respon_slit_offset.c xsh_respon_stare.c xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c xsh_util_ifu_offset.c xsh_util_ifu_stare.c


                 "shortened FLATFIELDED product file name & tag" xsh_geom_ifu.c
                 "shortened FLATFIELDED product file name & tag, updated man page, proper setting SKY products tag & filename" xsh_respon_slit_offset.c
                 "shortened FLUX calib products file names & tag, updated man page" xsh_respon_stare.c
                 "shortened FLATFIELDED products filename & tag" xsh_scired_ifu_offset.c
                 "shortened FLUX calib products file names & tag, updated man page" xsh_scired_slit_nod.c
                 "shortened FLATFIELDED product file name & tag, updated man page, proper setting SKY products tag & filename" xsh_scired_slit_offset.c
                 "shortened FLUX calib products file names & tag, updated man page" xsh_scired_slit_stare.c
                 "shortened FLATFIELDED filename and tag" xsh_util_ifu_offset.c
                 "shortened FLATFIELDED filename and tag" xsh_util_ifu_stare.c
                 "proper setting of flux calibrated and normalized frame file tags" xsh_util_apply_response.c
                 "added mode in file tag" xsh_compute_response.c
                 "changed interface xsh_util_multiply_by_response(), xsh_util_normalize_spectrum() to set proper file tag" xsh_utils.h xsh_utils.c
                 "include mode in efficiency product" xsh_utils_efficiency.c
                 "fixed typos in cube CRVAL/CRPIX keys" xsh_utils_image.c

Changining PRO.CATG to make them QC-Garching and DICB compliant:

           xsh_respon_slit_offset.c
           xsh_respon_stare.c
           xsh_scired_ifu_offset.c
           xsh_scired_ifu_stare.c
           xsh_scired_slit_nod.c
           xsh_scired_slit_offset.c
           xsh_scired_slit_stare.c
           xsh_util_efficiency1d.c
           xsh_util_ifu_offset.c
           xsh_util_ifu_stare.c
           xsh_data_spectrum.c
           xsh_detect_order.c
           xsh_dfs.h
           xsh_drl.h
           xsh_drl_check.c
           xsh_extract.c
           xsh_format.c
           xsh_localize_obj.c
           xsh_merge_ord.c
           xsh_opt_extract.c
           xsh_rectify.c
           xsh_subtract.c
           xsh_subtract_sky_single.c
           xsh_utils.c
           xsh_utils_efficiency.c
           xsh_utils_ifu.c
           xsh_utils_image.c
           test-xsh_combine_nod.c
           test-xsh_compute_response.c
           test-xsh_data_spectrum_merge_3d.c
           test-xsh_format.c
           test-xsh_lambda_err.c
           test-xsh_localize_obj.c
           test-xsh_opt_extract.c
           test-xsh_rectify.c
           tests.c

                 "added xsh_cube_set_wcs()" xsh_utils_ifu.h
                 "added function to deal with wcs in cubes" xsh_utils_ifu.c
                 "modified xsh_save_sky_model() to have err and qual extensions" xsh_subtract_sky_single.c
                 "added xsh_pfits_get_pixscale() xsh_pfits_get_posangle()" xsh_pfits.h xsh_pfits.c
                 "added instrument param to xsh_save_sky_model() interface" xsh_drl_check.h xsh_drl_check.c
                 "replace XSH_BP_MAP_NL_* by XSH_RAW_BP_MAP_NL_*" xsh_data_pre.c
                 "fixed DFS09346" xsh_detect_order.c
                 "added support for XSH_RAW_BP_MAP"  xsh_dfs.h
                 "changed xsh_save_sky_model()" xsh_drl.h
                 "now XSH_BP_MAP_NL and XSH_RAW_BP_MAP_NL are distinct" xsh_lingain.c




                 "Make recipe robust to the case that the STD star is not in the catalog" xsh_respon_slit_offset.c

                 Some re-ordering and cleaning of xsh_scired_slit_stare

                 Aligned xsh_response_slit_stare recipe to xsh_scired_slit_stare

                 "added overscan parameter, and changed call to xsh_prepare() that depends from it" xsh_mbias.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_mdark.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it. Now if mdark is not provided the frame over which lines are detected is bias subtracted and not the raw frame in PRE format. Changed consequently default of detectarclines-min-sn to 5 to ensure robustness" xsh_predict.c 
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_orderpos.c 
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_mflat.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_wavecal.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_2dmap.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_linear.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_cfg_recover.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_startup.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_util_ima_arith.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_flexcomp.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_util_ifu_stare.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_util_ifu_offset.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_geom_ifu.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_respon_stare.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_respon_slit_offset.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_compute_noise_map.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_create_master_bias.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_create_master_dark.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_detect_continuum.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_detect_line_pos.c
                 "removed obsolete warning" test-xsh_flux.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_flux_conservation.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_prepare.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_remove_crh_single.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_remove_crh_multiple.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_subtract_bias.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_subtract_dark.c
                 "changed call to xsh_prepare() to reflect function input parameter changes" test-xsh_subtract_sky_nod.c
                 "changed interface xsh_subtract_bias and xsh_subtract_bias_check to add overscan parameter dependency" xsh_drl.h
                 "added xsh_pre_subtract_scalar xsh_pre_add_scalar xsh_pre_divide_scalar, changed xsh_prepare API" xsh_data_pre.h
                 "added xsh_pre_subtract_scalar xsh_pre_add_scalar xsh_pre_divide_scalar, changed xsh_prepare API" xsh_data_pre.c
                 "changed xsh_subtract_bias_check API" xsh_drl_check.h
                 "changed xsh_subtract_bias_check API" xsh_drl_check.c
                 "changed warning to debug-medium message"  xsh_detect_order.c
                 "added xsh_parameters_pre_overscan()" xsh_parameters.h
                 "added xsh_parameters_pre_overscan()" xsh_parameters.c
                 "changed call to xsh_pre_create() to pass pre_overscan_corr" xsh_prepare.c
                 "changed xsh_subtract_bias implementation to deal with overscan corection" xsh_subtract.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_scired_ifu_offset.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_scired_ifu_stare.c
                 "added overscan parameter, and changed call to xsh_prepare() and xsh_subtract_bias() that depends from it" xsh_scired_slit_stare.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_scired_slit_nod.c
                 "added overscan parameter, and changed call to xsh_prepare()" xsh_scired_slit_offset.c
                 "faster data reduction with proper FITS header now applied to frames in RAW format" xsh_lingain.c

1.1.5:            Fix typo affecting flat IFU data reduction in sobel mode
                 "less verbose xsh_array_clip_mean()" xsh_utils.c
                 "less verbose line tilt determination" xsh_follow_arclines.c
1.1.4  
                 "changed interface xsh_normalize_spectrum and xsh_normalize_spectrum_image to pass instrument info and deal with NIR (that does not specify gain in FITS header: now we assume constant value of 2.12)" xsh_utils.h xsh_utils.c
                 "changed call to xsh_normalize_spectrum to reflect API function change" xsh_respon_stare.c xsh_scired_slit_stare.c xsh_util_apply_response.c
                 "added support for XSH_RESPONSE_OFFSET" xsh_dfs.h
                 "added 2D spectrum normalization (exptime,gain,atm-ext)" xsh_respon_stare.c
                 "added 2D spectrum normalization (exptime,gain,atm-ext), updated man page" xsh_scired_slit_nod.c
                 "added 2D spectrum normalization (exptime,gain,atm-ext), updated man page" xsh_scired_slit_offset.c
                 "added 2D spectrum normalization (exptime,gain,atm-ext), updated man page" xsh_scired_slit_stare.c

                 "added xsh_spectrum_interpolate() xsh_normalize_spectrum_image() xsh_normalize_spectrum()" xsh_utils.h
                 "added xsh_spectrum_interpolate() xsh_normalize_spectrum_image() xsh_normalize_spectrum()" xsh_utils.c
                 "Replace integration(resample) with interpolation" xsh_compute_response.c
                 "fix mem leaks, use XSH_ATMOS_EXT as additional input" xsh_util_apply_response.c
                 "apply normalization (only to 1D frame) to correct for exptime,(gain),atmext" xsh_respon_stare.c
                 "apply normalization (only to 1D frame) to correct for exptime,(gain),atmext" xsh_scired_slit_stare.c

                 "fixed typo in error vector2image mapping" xsh_utils.c
                 "rename xsh_respon_stare-->xsh_respon_slit_stare" xsh_respon_stare.c
                 "rename recipe xsh_respon_stare to xsh_respon_slit_stare" Makefile.am

                 "updated man-page to indicate RESPONSE optional input and its effects if present"  xsh_scired_slit_stare.c
                 "added response correction" xsh_scired_slit_nod.c
                 "added response correction" xsh_scired_slit_offset.c

                 "clean mem leaks" xsh_scired_slit_stare.c
                 "added to CVS" xsh_respon_slit_offset.c
                 "added to CVS" xsh_util_apply_response.c
                 "added to CVS"
                 "added to CVS" xsh_util_compute_response.c
                 "added xsh_respon_slit_offset xsh_util_apply_response xsh_util_compute_response " Makefile.am

                 "added flux calibrated spectrum, input atm ext tag is not ATMOS_EXT_ARM, that is required as STD_CATAL_ARM, efficiency and response are always computed if std is in catal, removed parameter compute-eff" xsh_respon_stare.c

          Andrea 27 Aug 2010
                 "added back 2D merged frame and added 1D merged flux calibrated frame" xsh_scired_slit_stare.c
                  "added compute_qc parameter to xsh_cube_qc_trace_window()" xsh_utils_image.h
                 "added compute_qc parameter to xsh_cube_qc_trace_window()" xsh_utils_image.h
                 "added compute_qc parameter to xsh_cube_qc_trace_window()" xsh_utils_image.c
                 "added ARM qualifier to ORDER_3D_QUAL IFU product, changed call to xsh_cube_qc_trace_window() to reflect function interface change" xsh_utils_ifu.c
                 "added xsh_vector_to_image()" xsh_utils.h
                 "added xsh_vector_to_image() and xsh_image_to_vector()" xsh_utils.c
                 "added xsh_image_to_vector()" xsh_utils.h
                 "fixed additional problems related to qc_mode=TRUE (asked by QC) and trace-method=sobel with crub IFU data loosing S/N on a UVB FLAT order frame that would otherwhise make the xsh_mflat recipe crush instead that terminate successfully as QC would like" xsh_detect_order.c

1.1.3  

                 Andrea 25 Aug 2010:
             "do not apply response to 1D science (one need to upgrade function to receive in input a table, not an image as now is assumed)" xsh_scired_slit_stare.c
                 "fixed problem with output filename/tag for FLUXCAL product" xsh_utils.c
                 "fixed bug on fluxcal_1D_frame computation" xsh_scired_slit_stare.c
                 "more robust efficiency table thresholding, via 2 iteration of kappa=5 sigma clip to median values and check versus threshold=inf" xsh_utils_efficiency.c
                 "Apply low cut at 310 nm in atmospheric extinction" xsh_utils.c
                 "added explicit message for response computation" xsh_compute_response.c
                 "clean, uses frm_std_cat to check if response need to be computed" xsh_respon_stare.c


                 Andrea 24 Aug 2010:
                 "added support for SKY_IFU and SKY_SLIT with STD star OFFSET observations" xsh.oca
                 "added to CVS" std_star_coord
                 "added parameter to control OBJ/SKY cube generation" xsh_util_ifu_stare.c
                 "added parameter to control OBJ/SKY cube generation, and generation of SKY cube" xsh_util_ifu_offset.c
                 "fixed mem leaks" xsh_util_efficiency1d.c
                 "added generation of fluxcal 1D/2D spectra if response frame is in input and fixed compiler warning" xsh_scired_slit_stare.c
                 "fixed compiler warning: why xsh_combine_nod_param is needed in offset recipe?" xsh_scired_slit_offset.c
                 "fixed compiler warnings" xsh_scired_slit_nod.c
                 "added support of XSH_STD_TELL_IFU_OFFSET, XSH_STD_FLUX_IFU_OFFSET," xsh_scired_ifu_offset.c
                 "use FLUX STD CAT instead that single FLUX STD spectrum. Fixed compiler warning" xsh_respon_stare.c 
                 "less verbose" xsh_utils_wrappers.c
                 "specify in out filename that IFU traces (if computed) refer to OBJ" xsh_utils_image.c
                 " changed interface function to build cube to indicate if the cube refers to obj or sky (different are the number of products to be generated in the two cases)" xsh_utils_ifu.h
                 " changed interface and implementation of function to build cube to indicate if the cube refers to obj or sky (different are the number of products to be generated in the two cases)" xsh_utils_ifu.c 
                 "several bug fixes related to efficiency computation" xsh_utils_efficiency.c
                 "declared public xsh_frame_sci_get_ra_dec() and xsh_parse_catalog_std_stars() and changed  STAR_MATCH_DEPSILON to 0.0166667 (60 arcsec)" xsh_utils_efficiency.h
                 "added xsh_spectrum_resample(), xsh_util_frameset_collapse_mean(), changed interface xsh_util_multiply_by_response()" xsh_utils.h
                 "added xsh_spectrum_resample(), xsh_util_frameset_collapse_mean(), changed interface xsh_util_multiply_by_response()" xsh_utils.c
                 "fixed typo in reported message, decreased function verbosity" xsh_subtract_sky_single.c
                 "fixed compiler warnings" xsh_rectify.c
                 "fixed compiler warnings" xsh_opt_extract.c
                 "fixed compiler warnings" xsh_model_kernel.c
                 "Cast std star columns always to FLOAT, use internal column names for robustness. Fixed a mem leak" xsh_data_star_flux.c
                 "added xsh_pre_multiply() to fix compiler warning" xsh_data_pre.h
                 "fixed compiler warnings" xsh_data_pre.c
                 "use standard naming convention for atmospheric extintion table: 'LA_SILLA' and not 'K'" xsh_data_atmos_ext.h
                 "changes to use a std star catalog instead of a single input spectrum" " xsh_compute_response.c
                 "changes to use a std star catalog instead of a single input spectrum"  xsh_compute_response.c
                 "fixed compiler warnings" xsh_combine_nod.c
                 "added WD0839-327_T09174_G7828, WD2007-303_T14454_G7860" std_star_coord



                 "compute number of detected edges for QC" xsh_data_order.c 
                 "in case of qc_mode skip order that are entirely below min S/N value, for QC" xsh_detect_order.c
                 "special case needed to treat exception possibly created in qc_mode=TRUE, to be able to end recipe successfuly and write corresponding QC param, used for QC" xsh_subtract.c
                 "added qc_mode parameter to detect edge structure (to support QC mode, more robust, data reduction)" xsh_parameters.h
                 "added qc_mode parameter to detect edge structure (to support QC mode, more robust, data reduction)" xsh_parameters.c
                 "added QC params to for IFU order tracing" xsh_pfits_qc.h
                 "added XSH_RESPONSE_SLIT" xsh_dfs.h
                 "added QC log for order tracing" xsh_utils_image.c
                 "added xsh_spline_hermite_table() and xsh_util_multiply_by_response()" xsh_utils.h
                 "added xsh_spline_hermite() xsh_spline_hermite_table() xsh_util_multiply_by_response() and work in progress: xsh_spectrum_get_val() xsh_spectrum_resample()" xsh_utils.c
                 "if response is computed is also applied (temporarily saved on fluxcal_2D_frame.fits" xsh_scired_slit_stare.c 

                
                flat edge detection: added possibility to skip orders whose 
                edges are not detectable in case detectorder-qc-mode=TRUE 
                as asked by QC. Added QC param QC ORD EDGE NDET to count
                how many edges have been detected.

                xsh_scired_slit_nod:
                reorganize frame by cumoff and reloff for case A1B1B2A2 (use relative offsets)
                possibility to combine frames via mean or median

                xsh_2dmap: changed detectarclines-fit-window-half-size default to 4 
                           (from 2) and in case of NIR to 3

                Add function xsh_parameter_get_default_flag to solve problems 
                with Gasgano and setting of parameters that had an ARM 
                dependent default (problem related to gasgano and 
                cpl_parameter_get_default_flag)
1.1.2  
                THE map predictions corrected for binning
                xsh_model_kernel.c, xsh_compute_model.c: changed X-SHOOTER to XSHOOTER (INSTRUME value)
                 Not set INSTRUME value in pipe products: that is inherited from 1st input frame
                 Added ARM specifier to WAVE and SLIT maps in nod recipe results

1.1.1  
                 xsh_2dmap: Changed default of --detectarclines-find-lines-center to gaussian
                 Residuals statistics of model to measured positions is
	         now performed before and after the annealing.
	         Extended prisms temperature range
	         Fixed a few typos in User Manual
1.1.0  
                 Added recipe name based prefix to IFU recipes products
1.0.0  25 May 2010 public release
0.9.9
Andrea 19 May 2010
                 Fixed valgrind errors on annealing
                 Fixed seg fault on anneal
Andrea 18-05i-10 Fixed mem leaks
Andrea           IFU recipes (xsh_scired_ifu* points now to xsh_util_ifu*)
                 DRS_MDARK_ARM is required input of xsh_mdark
                 Revised list of recipes offered
                 Cleaning IFU data reduction

Andrea 30-04-10 Added IFU stuff
0.9.8
Andrea 31-03-10 Changed way to compute DARKRMS: now we take into account of CRH and other BP 
                and make a robust kappa-sigma clip: 2 iterations using as reference the median 
                and 4 using as reference the mean

                Added DRS_MDARK_ARM input to xsh_mdark
                Regis committed first versions of optimal extraction in physmod

Andrea 30-03-10 Changed sat_threshold (used to compute NPIXSAT and FPIXSAT) to 0 for NIR data
Andrea 24-03-10
                 Several changes to:
                      update model temperature from relevant frame (code centralized in function)
                      Fix some QC related problem
                      Fix compiler warnings
                 Details:
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_cfg_recover.c 
                 "using xsh_model_temperature_update_frame( to update temperature in table frame. Commented out generation of maps and disp tab in physical model to prevent seg fault" xsh_flexcomp.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_geom_ifu.c
                 "changed default param detect_arclines_p->min_sn to 5.0 in UVB to align with robust value found by Sabine" xsh_predict.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_respon_stare.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_scired_slit_nod.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_startup.c
                 "use full list of order to generate qc flux" xsh_mflat.c
                 "commented out somje functions that are not used" xsh_create_master.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame" xsh_create_wavemap.c
                 "removed check on ny as agreed with Frederic" xsh_data_dispersol.c
                 "added cleanup: to remove compiler warning" xsh_data_instrument.c
                 "added XSH_ORDER_MIN_UVB_D2 XSH_ORDER_MAX_UVB_D2 XSH_ORDER_MIN_UVB_QTH XSH_ORDER_MAX_UVB_QTH to be used to generate proper table extension for QTH and D2 used later to determine QC FLUX MIN/MAX" xsh_data_instrument.h
                 "fixed bug in generation of extention table for UVB QTH/D2" xsh_data_order.c
                 "fixed compiper warning" xsh_data_rec.c
                 "using xsh_model_temperature_update_frame( to update temperature in table frame and xsh_model_temperature_update_structure to update model structure"  xsh_detect_arclines.c
                 "fixed compiler warning" xsh_detmon_lg.c
                 "commented out not used xsh_dfs_split_in_group to fix compiler warning" xsh_dfs.c
                 "changed xsh_flexcor API to pass afc_frame that is used tyo update model temperature" xsh_drl.h
                 "changed xsh_flexcor API to pass afc_frame that is used tyo update model temperature, and using xsh_model_temperature_update_frame to update temperature in frame (that later is loaded as structure=>so also in model structure)"  xsh_flexcor.c
                 "changed xsh_flexcor API to pass afc_frame that is used tyo update model temperature, and using xsh_model_temperature_update_frame to update temperature in frame (that later is loaded as structure=>so also in model structure)"  xsh_follow_arclines.c
                 "commented out not used static void mask_badpixels" xsh_localize_obj.c
                 "added xsh_model_temperature_update_structure xsh_model_temperature_update_frame" xsh_model_utils.h xsh_model_utils.c
                 "Added specified QTH/D2 in case of UVB flats" xsh_prepare.c
                 "changed xsh_flexcor API to pass afc_frame that is used tyo update model temperature, and using xsh_model_temperature_update_frame to update temperature in frame (that later is loaded as structure=>so also in model structure)" xsh_rectify.c
                 "commented out not used find_flux get_fitted_flux_at_lambda" xsh_subtract_sky_single.c
                 "commented out not used find_flux get_fitted_flux_at_lambda" xsh_utils.c
                 "added xsh_frame_image_qc_trace_window xsh_frame_image_ext_qc_trace_window to allow to determine quality of rectification" xsh_utils_image.h 
                 "added xsh_frame_image_qc_trace_window xsh_frame_image_ext_qc_trace_window to allow to determine quality of rectification" xsh_utils_image.c
                 "fixed several compiler warnings" xsh_model_kernel.c

0.9.7
Andrea 10-03-10
                 Fixed some QC
0.9.6
Andrea 16-02-10  
                 "uses cpl_ppm_match_points in place of xsh_ppm_match_points" xsh_cfg_recover.c
                 "fix compiler warning" xsh_lingain.c
                 "changed xsh_efficiency_compute API, added compute-map parameter" xsh_respon_stare.c
                 "make static an internal function" xsh_scired_ifu_stare.c
                 "fixed compil;er warnings" xsh_scired_slit_nod.c
                 "changed xsh_efficiency_compute API" xsh_util_efficiency1d.c
                 cvs ci"
                 "uses cpl_ppm_match_points in place of xsh_ppm_match_points" xsh_startup.c
                 "fixed compiler warnings" xsh_badpixelmap.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_badpixelmap.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_badpixelmap.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_create_master.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_compute_linearity.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_data_order.c
                 "fixed compiler warnings" xsh_data_slice_offset.c
                 "fixed compiler warnings" xsh_data_pre.c
                 "added full header to 1D extracted order-by-order frame" xsh_data_rec.c
                 "added full header to 1D extracted order-by-order frame" xsh_data_wavemap.c
                 "added full header to 1D extracted order-by-order frame" xsh_detect_continuum.c
                 "added full header to 1D extracted order-by-order frame"
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_detmon.c
                 "more protable if check" xsh_dfs.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_follow_arclines.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_localize_obj.c
                 "uses xsh_polynomial_fit_1d_create in place of cpl_polynomial_fit_1d_create" xsh_opt_extract.c
                 "fix compiler warning" xsh_opt_extract.c
                 "fix compiler warning" xsh_rectify.c
                 "reactivate cpl_polynomial * xsh_polynomial_fit_2d_create" xsh_utils_wrappers.c
                 "changed xsh_efficiency_compute API" xsh_utils_efficiency.h xsh_utils_efficiency.c
                 "removed xsh_ppm.h xsh_ppm.c" Makefile.am
                 "removed from CVS" xsh_ppm.h xsh_ppm.c
                 "more functions" test-xsh_ifu_trace_object.c

Andrea 02-02-10  Fixed problem xsh_geom_ifu (undefined function to monito params)
                 Increased pipe id.
0.9.5
Andrea 01-02-10  Commits to have common wave/slit bin defaults
Andrea 28-01-10
                 Added efficiency computation in xsh_response_stare
                 Fixed some memory leaks and valgrind errors
Andrea 27-01-10
                 Updated pipe ID
Andrea 26-01-10
                 "removed _$RBS_JOB_INSTANCE which is needed only in case one processes a RB using multiple parallel main jobs (like e.g. vcam" uves.properties
                 "increased max allowed computation time" shoot.properties
                 "changed parameter defaults for slit and wave binning: if the user does not specify them on command line the pipeline set different defaults according to the arm (as specified in corresponding table on the user manual, pag 122, section recipe-io as in scired recipe description" xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c

Andrea 25-01-10
                 "added S/N" xsh_data_spectrum1D.c
                 "removed warning related to unexpected size of 2D merged nod" xsh_merge_ord.c
                 "added setting of bezier_spline_order" xsh_parameters.c
                 "more messages (about bezier spline order) and fixed error in order of received parameters of fit_spline function" xsh_subtract_sky_single.c
                 "take into account of src bin size"  xsh_utils_efficiency.c
                 "take into account of bin size" xsh_utils_efficiency.h

Andrea 22-01-10
                 "fixed detectarclines-min-sn parameter setting" xsh_2dmap.c
                 "added Bezier Spline Order init value to single frame sky subtraction" xsh_respon_stare.c
                 "fixed compiler warning" xsh_scired_slit_nod.c
                 "added Bezier Spline Order init value to single frame sky subtraction" xsh_scired_slit_stare.c
                 "added bezier_spline_order to single frame sky subtraction structure" xsh_parameters.h
                 "added parameter sky-bspline-order" xsh_parameters.c
                 "added parameter bezier_spline_order to call to fit_spline to allow to pass user defined value" xsh_subtract_sky_single.c

Andrea 21-01-10
                "removed from CVS" uves_wkf.oca UVES.OCA
                 "moved code to corresponding library function" xsh_util_efficiency1d.c
                 "added extracted 1D/2D and merged 1D/2D spectra" xsh_respon_stare.c
                 "added xsh_efficiency_compute" xsh_utils_efficiency.h xsh_utils_efficiency.c

Andrea 20-01-10
                 "renamed CPIX_MAP->BP_MAP_CP HPIX_MAP->BP_MAP_HP" xsh_badpixelmap.c
                 "computation of saturated region/remnants on dark via extra params or DRS setup table" xsh_create_master.c
                 "changed interfave xsh_create_mdark" xsh_drl.h
                 "added xsh_parameters_create_from_drs_table" xsh_parameters.h xsh_parameters.c
                 "added XSH_DRS_MDARK*" xsh_dfs.h
                 "fixed compiler warning"xsh_dfs.c
                 "fixed compiler warning" xsh_dfs.c
                 "changed CPIX_MAP->BP_MAP_CP HPIX_MAP->BP_MAP_HP" xsh_mbias.c
                 "handling of XSH_DRS_MDARK" xsh_mdark.c

Andrea 11-01-10
                "added xsh_validate_model_cfg" xsh_dfs.c xsh_dfs.h
                 "added XSH_MODEL_CFG_START" xsh_pfits.h
                 "replace cpl_image_filter_linear with cpl_image_filter_linear to remove CPL cxompiler warnings" xsh_remove_crh_single.c
                 "xsh_image_filter_wrapper and xsh_image_filter_mode are wrappers of corresponding cpl functions for the supported modes. They prevent CPL compiler warning related to usage of obsolete functionality" xsh_utils_wrappers.c

                  "replaced call to cpl_image_filter_mask by call to cpl_image_filter" xsh_utils_wrappers.c
                 "added xsh_mdark_get_contam" xsh_create_master.c
                 "added computation of saturated pixel number and fraction of total pixels" xsh_data_pre.c
                 "fixed typo: XSH_MOD_COFG_TAB_AFC_NIR->XSH_MOD_CFG_TAB_AFC_NIR" xsh_dfs.h
                 "added xsh_pfits_set_nsat xsh_pfits_set_frac_sat xsh_pfits_set_contamination XSH_NPIXSAT XSH_FPIXSAT XSH_QC_CONTAM" xsh_pfits.h
                 "added xsh_pfits_set_nsat xsh_pfits_set_frac_sat xsh_pfits_set_contamination" xsh_pfits.c
                 "eplace cpl_image_filter_median by xsh_image_filter_median to reduce compiler warnings" xsh_remove_crh_single.c
                 "eplace cpl_image_filter_median by xsh_image_filter_median to reduce compiler warnings" xsh_spectrum.c

Andrea 30-12-09
                "changed call to xsh_flat_merge_qth_d2 to reflect function interface change (in order to generate merged bkg)" xsh_flat_merge_qth_d2
                 "changed call to xsh_flat_merge_qth_d2 to reflect function interface change (in order to generate merged bkg)" xsh_flat_merge_qth_d2.c
                 "changed call to xsh_flat_merge_qth_d2 to reflect function interface change (in order to generate merged bkg)" test-xsh_flat_merge.c
                 "added xsh_image_filter_median and xsh_image_filter_linear wrapper of corresponding cpl functions to remove in the future cpl warnings on deprecated cpl function calls" xsh_utils_wrappers.h xsh_utils_wrappers.c
                 "fixed compiler warnings" xsh_utils.h
                 "fixed compiler warnings" xsh_utils.c
                 "fixed compiler warnings" xsh_utils_image.c
                 "fixed compiler warnings" xsh_subtract_sky_single.c
                 "fixed compiler warnings" xsh_subtract.c
                 "fixed compiler warnings" xsh_spectrum.c
                 "fixed compiler warnings" xsh_remove_crh_single.c
                 "fixed compiler warnings" xsh_remove_crh_multi.c
                 "fixed compiler warnings" xsh_rectify.c
                 "fixed compiler warnings" xsh_ppm.c
                 "fixed compiler warnings" xsh_pfits.h
                 "fixed compiler warnings" xsh_opt_extract.c
                 "fixed compiler warnings" xsh_model_kernel.h
                 "fixed compiler warnings" xsh_merge_ord.c
                 "fixed compiler warnings" xsh_follow_arclines.c
                 "fixed compiler warnings" xsh_flexcor.c
                 "fixed compiler warnings" xsh_badpixelmap.h
                 "fixed compiler warnings" xsh_combine_nod.c
                 "fixed compiler warnings" xsh_compute_slice_dist.c
                 "refactored structx/y computation to separate 'UVES' from 'XSH' way to do it" xsh_create_master.c
                 "fixed compiler warnings" xsh_data_localization.h
                 "fixed compiler warnings" xsh_data_localization.c
                 "fixed compiler warnings" xsh_data_order.c
                 "pass filename as additional param to xsh_resid_order_2tab" xsh_data_order_resid_tab.c xsh_data_order_resid_tab.h
                 "fixed compiler warnings" xsh_data_pre.c
                 "fixed compiler warnings" xsh_data_rec.c
                 "fixed compiler warnings" xsh_data_rec.h
                 "fixed compiler warnings" xsh_data_slice_offset.c
                 "fixed compiler warnings" xsh_data_slice_offset.h
                 "fixed compiler warnings" xsh_data_spectrum.c
                 "fixed compiler warnings" xsh_data_spectrum.h
                 "compute mean instead of sum of flux over window to fix ticket from Sabine" xsh_data_spectrum1D.c
                 "fixed compiler warnings" xsh_detect_continuum.c
                 "fixed compiler warnings" xsh_extract.c
                 "fixed compiler warnings" xsh_detect_order.c
                 "change API xsh_flat_merge_qth_d2, some function params alignment"  xsh_drl.h
                 "add XSH_BP_MAP_RP, XSH_SKY_LINE_LIST, xsh_frameset_extract_offsety_matches xsh_frameset_extract_offsety_mismatches" xsh_dfs.h
                 "remove checks on CPL version 4.8.0 for product saving as now are obsolete" xsh_dfs.c
                 "change interface xsh_flat_merge_qth_d2 to compute merged bkg and fix typo in computing flux min/max" xsh_flat_merge.c
                 "fixed compiler warnings" xsh_localize_obj.c
                 "added xsh_create_dispersol_physmod to have flux conservation in physmod (de facto like poly to minimize code changes when this is applied, and ensure results consistency)" xsh_create_wavemap.c
                 "fixed some compiler warning and re-aligned function declaration" xsh_data_wavemap.c
                 "added xsh_model_utils.h xsh_model_utils.c" Makefile.am
                 "added generation of DISP_TAB also in physmod mode" xsh_2dmap.c
                 "fixed compiler warnings" xsh_cfg_recover.c
                 "fixed memory leaks" xsh_lingain.c
                 "use proper input BP map (master)" xsh_mbias.c
                oadd BP if appropriate" xsh_mflat.c
                 "coadd BP if appropriate" xsh_mflat.c
                 "fixed compiler warnings" xsh_scired_ifu_offset.c
                 "fixed compiler warnings" xsh_scired_ifu_stare.c
                 "fixed compiler warnings (removed unused piece of code)" xsh_scired_slit_nod.c
                 "fixed compiler warnings" xsh_scired_slit_offset.c
                 "use XSH_SKY_LINE_LIST if provided, for QC" xsh_scired_slit_stare.c
                 "moved xsh_util_physmod_model_THE_create to xsh_model_kernel to be able to call it from scired recipes (for QC)" xsh_util_physmod.c
                 "fixed compiler warnings" xsh_wavecal.c
  
0.9.4
Andrea -11-12-09: Updated ID set tag for new release
        Fixed some bugs on resolving power computation, 
        added QC to monitor flux on given wave ranges on scired, 
        updated recipe release ID
Andrea -27-11-09: Updated ID set tag for new release
0.9.3
Laurent-26-11-09:
	xsh/xsh_compute_response.c: Included the high absoprtion regions
	 where the response is NOT calculated, but is just a linear
	 interpolation between the edges of the region. Note that the
	 definition of the regions are hard coded in the source code.

0.9.2
Andrea-16-11-09
        Fixed problems scired_stare with physmodel in 2x2 data
Andrea-12-11-09
        BP_MAP_NL can be input of xsh_mdark
	Fixed problems on RESELMIN computation (xsh_wavecal)
	OCA rules to support physmodel mode
	
Laurent-11-11-09:
       "changed defaults of min_sn for UVB, VIS to 3,6 to get much more
       detected lines in 2dmap with only 10% worse residuals" 
Andrea-06-11-09
        Support gasgano
        
Laurent-04-11-09:
	xsh/xsh_compute_response.c: Fixed a bug in NIR (there is no
	 Keyword BINX/BINY in NIR).

Laurent-03-11-09:
	xsh/xsh_compute_response.c: Added multiply response by ratio
	star_binning over spectrum binning.
	
Andrea-02-11-09:
        Fixed xsh_wavecal robustness problem IFU-physmod mode
        Added RESID products in IFU-physmod mode
        Roll back poly inter-order bkg
        verified xsh_flexcomp on all arms all modes
	Updated XSH gasgano rul files to classify all SV data
	added products like SKY_arm for stare in offset recipe
0.9.1
Andrea-30-10-09:
	Added missing PRO.CATG to some sci products
	
Andrea-20-10-09:
        Suppressed 'SPECTRUM' from product PRO.CATG/filenames
Andrea-19-10-09:
        Several changes to implement scired 
        science product filenames and pro.catg requests from Sabine
Laurent-19-10-09:
	xsh/xsh_data_shift_table.c/h: Added functions to save and create
	shift table. 
	xsh/xsh_df.h: Added tag "XSH_SHIFT_TAB_SLIT"
	xsh/xsh_follow_arclines.c: Added creation of shift table. 
	 Modified API: shift table frame as output parameter
	xsh/xsh_drl.h: Changed proto xsh_follow_arclines
	xsh/xsh_parameters.c: Changed default of 'wavesol-compute' to
	 FALSE
	recipes/xsh_wavecal.c: Added product shift table. Adapted
	 to modified xsh_follow_arclines API.

Andrea-16-10-09:
        Pipefile in XSH_MOD_CFG_OPT_WAV_SLIT_arm
	Changed param defaults of xsh_flexcomp to improve recipe
	robustness on UVB/VIS
Laurent-15-10-09:
	xsh/tests/test-xsh_compute_response.c: new unitary test for
	 xsh_compute_response.
	xsh/tests/Makefile.am: Added test-xsh_compte_response
	xsh/xsh_compute_response.c: cleanup (suppressed obsolete
	 functions, made many msg dependant on debug-level >= MEDIUM)

Andrea-14-10-09:
        QC.FLUX.MIN/MAX for D2 and master flats are identical: fixed.
	xsh_mbias: compute structure in 2 areas divided at detector center
	
Andrea-13-10-09:
	xsh_flexcomp: line list must have PRO.CATG/tag different from full
	line list
	xsh_wavecal: save as product the model cfg modified by annealing
	

0.9.0
Andrea -01-10-09: Fixed seg fault stare NIR in physmodel mode due to different slitmap and PRe x sizes

Andrea -30-09-09: Fixed seg fault nod slit due to different wavemap and PRe x sizes
Andrea -29-09-09:
                "added messace to inform user if BP map is provided for frame preparation" xsh_data_pre.c
                 "changed XSH_ARC_LINE_LIST_CLEAN to XSH_ARC_LINE_LIST_ and XSH_MODEL_CONFIG XSH_MOD_CFG" xsh_detect_arclines.c
                 "changed XSH_ARC_LINE_LIST_CLEAN to XSH_ARC_LINE_LIST_ and XSH_MODEL_CONFIG XSH_MOD_CFG and XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_dfs.c
                 "changed XSH_ARC_LINE_LIST_CLEAN to XSH_ARC_LINE_LIST_ and XSH_MODEL_CONFIG XSH_MOD_CFG and XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_dfs.h
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_follow_arclines.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_follow_arclines.c
                 "changed XSH_ARC_LINE_LIST_CLEAN to XSH_ARC_LINE_LIST_ and XSH_MODEL_CONFIG XSH_MOD_CFG and XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_model_io.c
                 "changed XSH_ARC_LINE_LIST_CLEAN to XSH_ARC_LINE_LIST_ and XSH_MODEL_CONFIG XSH_MOD_CFG and XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_model_kernel.c
                 "changed ARC_LINE_LIST_CLEAN to ARC_LINE_LIST" xsh_qc_definition.h
                 "more informative messages when CRH is applied" xsh_remove_crh_multi.c
                 "changed XSH_MODEL_CONFIG_TAB to XSH_MOD_CFG_TAB" test-xsh_data_spectralformat.c
                 "changed ARC_LINE_LIST_CLEAN to ARC_LINE_LIST, XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_2dmap.c
                 "changed ARC_LINE_LIST_CLEAN to ARC_LINE_LIST" xsh_flexcomp.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_geom_ifu.c
                 "changed  XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_model_anneal.c
                 "changed  XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_model_anneal.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG, XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_model_compute.c
                 "changed ARC_LINE_LIST_CLEAN to ARC_LINE_LIST, XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_predict.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_respon_stare.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_respon_visnir.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_respon_uvbvis.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_scired_ifu_offset.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_scired_ifu_stare.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_scired_slit_nod.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_scired_slit_offset.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_scired_slit_stare.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG, XSH_MODEL_WAVE_LIST to XSH_ARC_LINE_LIST" xsh_startup.c
                 "XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_util_genconfig.c
                 "changed XSH_MODEL_CONFIG to XSH_MOD_CFG" xsh_wavecal.c
                 "changed XSH_MODEL_WAVE_LIST to XSH_ARC_LINE_LIST XSH_CALPRO_MODEL_CONFIG to XSH_MOD_CFG" xsh_util_physmod.c

0.8.5
Laurent-29-09-09:
	xsh/xsh_calibrate_flux.c: New module, not tested yet
	xsh/xsh_drl.h: Added prototype of xsh_clibrate_flux
	xsh/xsh_dfs.h: Added tag for calibrated spectra
	 'PHYS_SPECTRUM_1D/2D'
	xsh/xsh_data_instrument.h: Added definition of IFU slit width
	 (needed by calibrate flux)
	xsh/xsh_data_atmos_ext.c/h: added functions to retrieve lambda and
	 K arrays.
	xsh/xsh_data_soecrtum.c/h: Added function to duplicate a spectrum
	 and a function to save a calibrated spectrum (with the good tag)
	xsh/xsh_data_star_flux.c/h: Added function to retrieve lambda and
	 flux arrays.
	xsh/xsh_pfits.c/h: added functions to retrieve seeing.
	xsh/Makefile.am: Added xsh_calibrate_flux.c
	
Andrea-27-09-09:
        Removed $Log entry from source files that is not need as already given i
        by CVS and possibble source of CVS conflics. i
        Revised recipes man page and verbosity.
Laurent-24-09-09:
	xsh/xsh_compute_response.c: Replaced usage of SPLINE by
	 integration of the flux on the same interval used by the star
	 table.
	 Suppressed unused argument resp_step' (was used for spline
	 computation)
	xsh/xsh_drl.h: Modified prototype of xsh_compte_response
	recipes/xsh_respon_stare.c: Suppressed reference to parameter
	 "xsh_compute_response_param"
	
0.8.5
       Fixed flow on scired_slit_stare (release for SV2)
0.8.0
Andrea-04-09-09:
        Several changes in order to fix AI-67. 
        Essentially removed the mixed tab+image products from the final 
        list of recipe products (kept them as temporary ones), added to 
        them the suffix DRL in the PRO.CATG and a similar prefix in the 
        filename. Removed the suffix EXT from the previous products with 
        multi extention images and changed accordingly their filename.
Laurent-04-09-09:
	xsh/xsh_compute_response.c: Fixed a bug (bus error if no atmos ext
	 frame). Fixed bug in EXPIME usage.

Laurent-03-09-09:
	xsh/xsh_compute_response.c: Added correction by Atmospheric
	 extinction (to be verified)
	xsh/xsh_drl.h: Changed prototype of xsh_compute_response (added
	 Atmos Ext frame)
	recipes/xsh_respon_stare.c: Added usage of atmos ext frame. Fixed
	 missing check on disp table.
	recipes/xsh_respon_uvbvis.c: Same thing.
	recipes/xsh_respon_visnir.c: Same thing.

Laurent-02-09-09:
	xsh/xsh_data_atmos_ext.c/h: New module handling the atmospheric
	 extinction table FITS files.
	xsh/dfs.h: Added Tag for Atmos Ext: ATMOS_EXT_arm
	xsh/Makefile.am: Added xsh_data_atmos_ext compilation
	xsh/tests: Added unitary test: test_xsh_data_atmos_ext (just read
	 and dump table content for the moment)
	Dont forget to bootstrap, configure, etc.

Andrea-21-08-09 Fixed single frame sky subtraction quality problem with 
                flat model normalization in case of bad column
                In case h_scired_slit_nod put frame is odd the last of the list is removed.
0.7.5
Andrea-04-08-09
	         "there is no need to tell what is a parameter default. That is done by esores" xsh_parameters.c
                 "fixed typo" xsh_subtract.c
                 "fixed API call to xsh_subtract_sky_single()" test-xsh_subtract_sky_single.c
                 "fixed API call to xsh_subtract_sky_single()" test-xsh_subtract_sky_single.c
                 "updated"
                 "allow to have different PRO.CATG according to the recipe that requires to anneal the model cfg" xsh_model_kernel.h
                 "allow to have different PRO.CATG according to the recipe that requires to anneal the model cfg" xsh_model_kernel.c
                 "allowed additional MODEL_CONFIG_OPT tags" xsh_model_io.c
                 "define XSH_MODEL_CONFIG_OPT_REC|FMT|2D tags" xsh_dfs.h
                 "removed unused xsh_find_model_config_opt function" xsh_dfs.c
                 "set recipe specific tag in case of annealing" xsh_follow_arclines.c
                 "fix typo in doc" xsh_model_kernel.c
                 "load model cfg frame with proper recipe specific tag, or usual default model cfg"  xsh_2dmap.c xsh_geom_ifu.c xsh_predict.c xsh_respon_stare.c xsh_respon_uvbvis.c xsh_respon_visnir.c xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c xsh_wavecal.c
                 "set recipe specific tag in case of annealing" xsh_startup.c

Andrea-03-08-09:
                 "added QC" xsh_2dmap.c
                 "fixed typo short recipe description" xsh_lingain.c
                 "added QC to monitor flux" xsh_mflat.c
                 "added QC to monitor flux" xsh_orderpos.c
                 "added QC to monitor line position and defined MODEL_CONF_OPT as final product" xsh_predict.c
                 "fixed typos man page" xsh_startup.c
                 "clarified short description" xsh_wavecal.c
                 "change default for map generation" xsh_util_physmod.c
                 "sky subtraction now requires master flat as input (to better model spatial distribution of sky line)" xsh_respon_stare.c xsh_respon_uvbvis.c xsh_scired_slit_stare.c
                 "sky subtraction now requires master flat as input (to better model spatial distribution of sky line)" test-xsh_subtract_sky_single.c
                 "added xsh_wavemap_qc and xsh_wavetab_qc" xsh_create_wavemap.c
                 "now XSH_QC_MODEL_FMTCHK_DIFFYAVG are called like XSH_QC_FMTCHK_POLY_DIFFYAVG and logged only if solution is of type poly" xsh_data_resid_tab.c
                 "fixed compiler error" xsh_utils_image.c
                 "added xsh_update_pheader_in_image_multi()" xsh_utils.h
                 "added xsh_update_pheader_in_image_multi() and xsh_monitor_flux()" xsh_utils.h
                 "added xsh_update_pheader_in_image_multi() and xsh_monitor_flux()" xsh_utils.c
                 "added QC params" xsh_qc_definition.h
                 "added xsh_wavemap_qc() xsh_wavetab_qc() and added mflat_frame as input of sky subtraction function" xsh_drl.h
                 "Rename QC MODEL RESXMED like QC MODEL RESX_MED" xsh_model_kernel.c
                 "added XSH_QC_LINE_DIF* and renamed XSH_QC_MODEL_FMTCHK_* like XSH_QC_FMTCHK_POLY_*" xsh_pfits_qc.h
                 "new single frame sky subtraction with breaks point order dependent (default values being refined)" xsh_subtract_sky_single.c
Andrea-30-06-09:
       Changed default number of break points to safe value 2000
Andrea-29-06-09:
        Added check input is binned on predict, 2dmap, orderpos
Andrea-27-06-09:
        Changed default sky subtraction to BSPLINE and default number of break points to 2000
Laurent-23-06-09:
	xsh/tests/test-xsh_slitmap.c: Computes the slitlet position from
	 an order tabe and a slit map.
	xsh/rectify.c: Added function specific to test-xsh_slitmap.
	xsh/xsh_drl.h: idem

Laurent-19-06-09:
	recipes/xsh_scired_slit_stare.c: Suppressed some warnings.
	xsh/xsh_detect_order.c: Fixed bug.

Laurent-17-06-09:
	xsh/xsh_rectify.c: Take into account the orientation of the slit
	 versus the arm.
	xsh/xsh_compute_slice_dist.c: Idem

Laurent-15-06-09:
	xsh/xsh_compute_slice_dist.c: Fixed sign problem.
	xsh/xsh_drl.h: Suppressed usage of USE_SLITMAP define (it's the
	 default now)
	xsh/xsh_localize_bj.c: Added concatenation of all the rectified
	 frames into a single one. Driven by parameter
	 "--geom-ifu-localize-single=TRUE/FALSE". Default is TRUE.
	 Modified API of xsh_localize_obj_ifu (passed this parameter)
	xsh/xsh_parameters.c/h: Added parameter
	 --geom-ifu-localize-single.
	xsh/xsh_rectify.c: Suppressed usage of USE_SLITMAP define.
	xsh/xsh_utils.c/h: Added functions xsh_reindex_float and
	 xsh_reindex_int.
	recipes/xsh_geom_ifu.c: Added parameter
	 --geom-ifu-localize-single. Added usage of slitmap frame.
	recipes/xsh_scired_ifu_stare.c: Adapted to xsh_localize_obj new
	 API.
	recipes/xsh_scired_ifu_offset.c: Adapted to xsh_localize_obj new
	 API.
	

Laurent-10-06-09:
        Set default bkg method for scired recipes to poly
Laurent-08-06-09:
	xsh/xsh_rectify.c: Fixed potential problem: the math function
	'signbit' seems not to be available on any system.

Laurent-05-06-09:
	xsh/xsh_dfs.h: Added tags 'XSH_IFU_MAP' defined as 'IFU_MAP_arm'.
	 this tag is used for the Slit Map file, when running an IFU
	 science reduction recipe
	xsh/xsh_dfs.c: Adapted function xsh_find_slitmap to new tag.
	 Changed xsh_rectify_ifu API (added slit map frame)
	xsh/xsh_rectify.c: Added possibiity to use the slit map to detect
	 actual slitlet position. If the Slit Map frame is present in the
	 sof, otherwise use default standard positions.
	xsh/xsh_drl.h: Changed xsh_rectify_ifu prototype.
	xsh/tests/test-xsh_rectify.c: Adapted to new xsh_rectify_ifu API.
	recipes/xsh_scired_ifu_stare.c: Adapted to new Tag (see above) and
	 new xsh_rectify_ifu API.
	recipes/xsh_scired_ifu_offset.c: Adapted to new Tag (see above) and
	 new xsh_rectify_ifu API.
	

Laurent-04-06-09:
	xsh/xsh_data_instrument.h: Added default official SLIT positions.
	xsh/xsh_parameters.c/h: Added parameter "--rectify-slit-offset" an
	 offset to the slit positions in arc-seconds. The slit position is
	 [-6+slit_offset,6+slit_offset].
	xsh/xsh_rectify.c: Added usage of parameter slit_offset (IFU only)
	recipes/xsh_scired_ifu_stare.c: Added usage of parameter slit_offset.

Andrea-03-06-09:
                More robust detmon functionality (for lingain)
Andrea-01-06-09:
                 "change xsh_compute_ron API" xsh_util_ronbias.c
                 "compute RON in 2 regions" xsh_mbias.c
                 "remove xsh_util_ronbias.la xsh_util_efficiency.la" Makefile.am
                 "computes bias and structure in 2 regions" xsh_create_master.c
                 "allow support of poly method in bkg evaluation (take median of window sampling points)" xsh_data_pre.c
                 "add xsh_parameters_ref2_create" xsh_parameters.c
                 "funcrtions to set qc param values for ron & struct in 2 regions" xsh_pfits_qc.c xsh_pfits_qc.h
                 "add support of ron and structure params in 2 regions" xsh_qc_definition.h
                 "add support for ron computation in 2 regions, add xsh_image_get_stdev_clean" xsh_utils_image.c
                 "add support for ron computation in 2 regions, add xsh_image_get_stdev_clean" xsh_utils_image.h
                 "added xsh_parameters_ref1_create xsh_parameters_ref2_create" xsh_parameters.h
                 "added back xsh_pfits_get_qc_ron xsh_pfits_get_qc_structy/x (needed by unit tests)" xsh_pfits_qc.c
                 "added back UVES based poly bkg subtraction" xsh_subtract.c
                 "fixed typo in assure"  xsh_utils_image.c

Laurent-25-05-09:
	xsh/xsh_rectify.c: Fixed a bug: the slice offset table was never
	 used, it is now. In addition, the slice offset is calculated as
	 the average of the slice offsets per order taken from the slice
	 offset table.

Andrea-22-05-09:
        Flag NL bad pixels as crox:xsh_badpixelmap.h,c xsh_lingain.c
Laurent-06-05-09:
	xsh/xsh_data_image3d.c: Increased the number of decimals for
	 double and float properties (in case ...)
	xsh/xsh_data_pre.c/h: In xsh_pre_data_window_sample_flux_pa,
	 replaced an XSH_ASSURE_NOT_ILLEGAL on the fraction of good pixels
	 to calculate the median in the window by 1) a WARNING message, 2)
	 set the median value at 0.. Necessary for NIR where there are
	 many bad pixels - and xsh_subtract can handle this.
	 Also added a parameter "background-min-grid-frac" instead of the
	 hard coded XSH_WINDOW_MEDIAN_FRAC.
	xsh/xsh_parameters.c/h: Added handling of parameter
	 "background-min-grid-frac". Defaut value is 0.3333 as it is hard
	 coded by Andrea.
	xsh/xsh_subtract.c: In xsh_subtract_background, use the parameter
	 "background-min-grid-frac" passed to
	 xsh_pre_data_window_sample_flux_pa function.
	xsh/xsh_pfits.h: Added prototype of "xsh_pfits_get_crval3".
	
Andrea-06-05-09:
                 "pass file tag (not filename) to xsh_remove_crh_multi" xsh_linear.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_mbias.c
                 "coadd input bad pix map (if provided) to master bp map" xsh_mdark.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_mflat.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_geom_ifu.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_scired_ifu_offset.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_scired_ifu_stare.c
                 "pass file tag (not filename) to xsh_remove_crh_multiple" xsh_scired_slit_stare.c

                 "set default kappa to 5 for UVB" xsh_lingain.c
                 "removed recipe log" xsh_orderpos.c
                 "removed recipe log" xsh_predict.c
                 "implement and use UVES based algorithm for STRUCTX/Y computation" xsh_create_master.c
                 "pass result_tag in place of filename to xsh_remove_cosmics and define name as tag.fits" xsh_remove_crh_multi.c

Laurent-05-05-09:
	xsh/xsh_dfs.h: Suppressed include of xsh_ifu_defs.h (unused)
	xsh/xsh_drl.h: Added prototype of xsh_rectify_and_shift function.
	xsh/xsh_parameters.c/h: Added parameter 'rectify-fast=TRUE/FALSE'
	 used in xsh_scired_slit_nod.
	xsh/xsh_rectify.c: Added function xsh_rectify_and_shift and other
	 related static functions to calculate the shift. This function
	 makes in one step rectification and shift. Used in
	 xsh_scired_slit_nod.
	xsh/xsh_data_rec.c/h: Added function to invert a rectified frame
	 (used in scired_slit_nod in FAST mode)
	recipes/xsh_scired_slit_nod.c: Added parameter rectify-fast for
	 FAST mode (implies use KW not LOCALIZATION): fast mode uses
	 Rect(B-A) = -Rect(A-B) thus no rectification for B-A; 2 times
	 faster than slow mode (slow is default).
	 Replaced rectify then shift by rectify_and_shift in one single
	 step.
	 Various cleanups.
	
	 

Andrea-28-04-09:
                 "added ronbias computation as ESO detector department does (only log message)" xsh_mbias.c
                 "removed static from xsh_parameters_get_int"  xsh_parameters.c
                 "added xsh_parameters_get_int" xsh_parameters.c
                 "added xsh_parameters_get_int" xsh_parameters.h

Andrea-27-04-09:
                 "added support of input bad pixel map" xsh_lingain.c
                 "cleaned and now coadded BP map is called BADPIXEL_MAP_arm. Hot/Cold pixels has proper values" xsh_mbias.c
                 "cleaned. Switch off default for hot/cold bad pixels cleaning" xsh_mflat.c
                 "remove log from recipe" xsh_scired_slit_stare.c
                 "removed xsh_image_clean_badpixel xsh_image_get_hot_cold_pixs xsh_image_local_cold_pixs xsh_image_local_hot_pixs xsh_image_clean_mask_pixs"  xsh_utils_image.h
                 "removed xsh_image_clean_badpixel xsh_image_get_hot_cold_pixs xsh_image_local_cold_pixs xsh_image_local_hot_pixs xsh_image_clean_mask_pixs"  xsh_utils_image.c
                 "added xsh_image_clean_badpixel xsh_image_get_hot_cold_pixs xsh_image_local_cold_pixs xsh_image_local_hot_pixs xsh_image_clean_mask_pixs"  xsh_badpixelmap.h xsh_badpixelmap.c
                 "removed CVS log from recipe implementation" xsh_parameters.h
                 "removed CVS log from recipe implementation" xsh_dfs.c
                 "removed CVS log from recipe implementation" xsh_merge_ord.c
                 "added UVES-like poly bkg subtraction (work in progress)" xsh_subtract.c
                 "updated pipe id" configure.ac

Andrea-23-04-09:
          "added check statements" xsh_badpixelmap.c
          "added possibility to coadd static and current recipe bp map" xsh_lingain.c xsh_mdark.c

Andrea-21-04-09:
                 "now raw data are converted in PRE format" xsh_lingain.c
                 "added xsh_frameset_extract_pre, xsh_file_exists" xsh_dfs.h
                 "fixed compiler warning" xsh_utils_image.c
                 "added xsh_frameset_extract_pre, xsh_file_exists" xsh_dfs.c

Laurent-14-04-09:
	recipes/xsh_geom_ifu.c: Fixed bug in case of
	 --localize-method=AUTO.
	xsh/tests/test-xsh_divide_flat.c: Fixed bug (bad count of nb of
	 arguments)
	xsh/tests/test-xsh_star_flux.c: Adapted to data format (double vs
	 float)
	xsh/xsh_compute_response.c: Added usage of parameter
	 "compute-response-lambda-step".
	xsh/xsh_drl.h: Changed prototype of xsh_compute_response (added
	 parameter compute_response_param)
	xsh/xsh_parameters.c/h: Added parameter
	 "compute-response-lambda-step" and associated functions (small
	 lambda step used to interpolate in xsh_compute_response)
	xsh/xsh_substract_sky_nod.c: Cleanup (comments)
	recipes/xsh_respon_uvbvis.c: Changed default values for lambda and
	 slit bin rectification (use large binning to rectify, then
	 smaller one to compute response by interpolation).
	 Added usage of parameter --compute-response-lambda-step"
	recipes/xsh_respon_visnir.c: Changed default values for lambda and
	 slit bin rectification (use large binning to rectify, then
	 smaller one to compute response by interpolation).
	 Added usage of parameter --compute-response-lambda-step"

Andrea-14-04-09:
                 "rename HOT_PIXEL_MAP to PICKUP_NOISE_HOT_PIXEL_MAP" test-xsh_compute_noise_map.c
                 "added xsh_badpixelmap_coadd()" xsh_badpixelmap.h xsh_badpixelmap.c
                 "rename set_noisy_pixels_qc set_pickup_noise_pixels_qc for clarity and HOT_PIXEL_MAP to PICKUP_NOISE_HOT_PIXEL_MAP. Now we have only 'OPTMIZED_VERSION' of code" xsh_compute_noise_map.c
                  "renamed HOT_PIXEL_MAP PICKUP_NOISE_HOT_PIXEL_MAP" xsh_drl.h
                 "fix bug on filename declaration"  xsh_model_kernel.c
                 "rename XSH_QC_BP_MAP_NOISYPIX XSH_QC_BP_MAP_PICKUP_NOISE_PIX" xsh_pfits_qc.h
                 "rename 'ESO QC BP-MAP NOISYPIX' to 'ESO QC BP-MAP PICKUP NOISEPIX'" xsh_qc_definition.h
                 "Set proper 4th argument to calls to xsh_bpmap_collapse_median and xsh_collapse_errs" xsh_remove_crh_multi.c
                 "add xsh_image_clean_badpixel" xsh_utils_image.c
                 "add xsh_image_clean_badpixel" xsh_utils_image.h
                 "rename HOT_PIXEL_MAP PICKUP_NOISE_HOT_PIXEL_MAP and make proper computation to have sinfoni based noisy pixels computed and coadded in master bp map, flagged as QFLAG_HOT_PIXEL" xsh_mdark.c

Andrea-09-04-09:
                 "change xsh_linetilt_list_save API" xsh_data_linetilt.h
                 "change xsh_linetilt_list_save API to add a ks clip of spctres values" xsh_data_linetilt.c
                 "ks-clip spcres values for QC params computation" xsh_follow_arclines.c

                 "use optimized configuration to compute wave and slit maps" xsh_2dmap.c
                 "Update man page, now optimized model is hold in a proper frame, saved as product, and used for wave and slit maps" xsh_2dmap.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_respon_uvbvis.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_respon_visnir.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_scired_ifu_offset.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_scired_ifu_stare.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_scired_slit_nod.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_scired_slit_nod_fast.c
                 "replace 'DIVIDED' by 'FLATFIELDED'" xsh_scired_slit_offset.c
                 "pass wave and slit map tags to xsh_create_model_map to reflect API change" xsh_scired_slit_stare.c
                 "remplace 'DIVIDED' by 'FLATFIELDED' and save that product as final one. Update man page." xsh_wavecal.c
                 "pass wave and slit map tags to xsh_create_model_map to reflect API change" xsh_util_physmod.c
                 "change to reflect xsh_pre_save API change" xsh_compute_linearity.c
                 "change to reflect xsh_pre_save API change" xsh_create_master.c
                 "change to reflect xsh_pre_save API change" xsh_create_wavemap.c
                 "change to reflect xsh_pre_save API change" xsh_divide.c
                 "change to reflect xsh_pre_save API change" xsh_flat_merge.c
                 "change to reflect xsh_pre_save API change" xsh_follow_arclines.c
                 "change to reflect xsh_pre_save API change" xsh_remove_crh_multi.c
                 "change to reflect xsh_pre_save API change" xsh_remove_crh_single.c
                 "change to reflect xsh_pre_save API change" xsh_subtract_sky_nod.c
                 "change to reflect xsh_pre_save API change" xsh_subtract_sky_single.c
                 "change to reflect xsh_pre_save API change" xsh_subtract.c
                 "change to reflect xsh_pre_save API change" xsh_prepare.c
                 "set pro.catg on wave and slit map products" xsh_model_kernel.c
                 "set pro.catg model cfg table" xsh_model_kernel.c
                 "set pro.catg model cfg table" xsh_detect_arclines.c
                 "change to reflect xsh_pre_save API change" xsh_data_pre.c
                 "change xsh_pre_save to have pro.catg in saved file and filename matching it" xsh_data_pre.h
                 "changed xsh_create_model_map, xsh_create_model_map, xsh_pre_save API" xsh_drl.h
                 "change to reflect xsh_pre_save API change" xsh_opt_extract.c
                 "added XSH_MODEL_SLIT_MAP" xsh_dfs.h
                 "change to reflect xsh_pre_save API change" xsh_dfs.c
                 "change to reflect xsh_pre_save API change" test-xsh_compute_noise_map.c test-xsh_data_pre.c test-xsh_detect_continuum.c test-xsh_flux_conservation.c

Andrea-06-04-09:
                "updated id" configure.ac
                 "updated id" XSH.prefs
                SET new tag 
                 "use xsh_get_basename and not basename()" xsh_util_ima_rebin.c
                 "add xsh_pfits_get_cdelt3" xsh_pfits.h
                 "add XSH_SLIT_MAP on list of allowed input calibs" xsh_dfs.h
                 "removed seg fault for CPL5" xsh_dfs.c
                 "updated to CPL5 (and latest version)" xsh_detmon.c xsh_detmon.h xsh_detmon_body.h xsh_detmon_lg.c xsh_detmon_lg.h
                 "updated to CPL5" install_lapack
Laurent-02-04-09:
	xsh/xsh_subtract_sky_single.c: added suffix '.fits' to
	 SKY_ORDER_1D_arm_EXT frame filename
	recipes/xsh_mflat.c: suppressed some warnings
	recipes/xsh_wavecal.c: suppressed some warnings.
	

Laurent-01-04-09:
	xsh/xsh_compute_response.c: Now interpolates both std star and
	 input. The 1D spectrum is made with a rather large lambda
	 binning. The response is computed using a much smaller binning
	 (should be a parameter). Needs verification.
	xsh/xsh_data_star_flux.c/h: Fixed problems of data size (float vs
	 double)
	xsh/xsh_dfs.c: Suppressed warnings (duplicate variable name)
	xsh/xsh_dfs.h: Changed the tag for STD Flux to STD_FLUX_STARE.
	xsh/xsh_opt_extract.c: Replaced some xsh_msg by xsh_msg_dbg_medium
	 to avoid too many messages.
	xsh/xsh_pfits.h: introduced prototype of xsh_pfits_get_cdelt3
	 (suppressing a warning)
	recipes/xsh_respon_uvbvis.c: Replaced optimal extraction by basic
	 extraction. Several modifications/bug fixes. Seems to work now
	 (to be verifid !)
	recipes/xsh_scired_slit_stare.c: Added usage of SLIT_MAP frame if
	 --compute-map=FALSE
	
Regis : 23-03-09:
Functions updates :

a) subtract_sky_single
 * add parameter --sky-method (BSPLINE) MEDIAN or BSPLINE
 * add parameter --sky-median-hsize (7)
 * add parameter --sky-slit-edges-mask (0.5) in arcsec
 *  The function includes now the sky subtraction under the object,
    the mask of the object is used.
b) localize_obj
  * add a parameter --localize-method=MANUAL or AUTO
  * add a parameter --localize-slit-position(0.0) in arcsec
  * add a parameter --localize-slit-hheight(0.5) in arcsec
  * The manual mode create a localization from given parameters
c) xsh_extract
  * remove from parameter --extract-method NANUAL
  * remove parameter --extract-slit-position
  * remove parameter --extract-slit-height
  * We remove the manual extraction because we have manual
    localization !!

Recipe updates :

xsh_scired_slit_stare
  * add parameter --compute-map
  * change the recipe code to be complient with new DRL
		 document !!
  * The new parameter introduce the compute of the slit_map
		  and the wavemap from the dispersion solution


Andrea-12-03-18: Fixed crash of offset recipes
Andrea-12-03-09:
                 "fixed mem leaks" xsh_mflat.c xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_stare.c 
                 "removed call to frameset free, creating a seg fault in case of wrong input raws in xsh_dfs_split_offset()" xsh_dfs.c
                 "fixed typo in DISP_TAB frame tag and filename" xsh_data_dispersol.c
                 "added check on nb_sub_frames value and stop if 0 that means that input raw frames is improper. In that case a call xsh_free_frameset( &raw_object) creates problems==>commented out"
                 "added check on nb_sub_frames value and stop if 0 that means that input raw frames is improper. In that case a call xsh_free_frameset( &raw_object) creates problems==>commented out" xsh_scired_slit_offset.c
Andrea-11-03-09:
                 Renamed xsh_util_genTHEtab to xsh_util_physmod
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header)" xsh_scired_ifu_offset.c
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header), rescale on the fly nbkpts1/2 by ybin" xsh_scired_ifu_offset.c
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header), rescale on the fly nbkpts1/2 by ybin" xsh_scired_ifu_stare.c
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header)" xsh_scired_slit_nod.c
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header)" xsh_scired_slit_o
                 "change extraction method default to FULL_METHOD, gain,ron defaults to -1 (automatic setting from input frame FITS header), rescale on the fly nbkpts1/2 by ybin" xsh_scired_slit_stare.c
                 "changed extraction-method default to 'full'" xsh_parameters.c

Andrea-10-03-09:
                 "add check on do-flatfield value to decide if flat fielded frame need to be dumped" xsh_scired_slit_stare.c
                 "now gain and airmass are read from FITS header and introduced a check for too small or too large eff values" xsh_util_efficiency2d.c
                 "use frame tags to recognize input frames" xsh_util_efficiency2d.c
                 "fixed man-page" xsh_util_efficiency2d.c
                 "added to CVS" xsh_util_afc.c
                 "added xsh_util_afc.c" Makefile.am
                 "added support for AFC tags" xsh_dfs.h


Andrea-09-03-09:
                 "added XSH_WAVE and XSH_SLIT_MAP and XSH_DISP_TAB defines" xsh_dfs.h
                 "used define XSH_ORDER_TAB_EDGES to build file name" xsh_detect_order.c
                 "changed API xsh_dispersol_list_save" xsh_data_wavemap.c
                 "cleaned. changed API xsh_dispersol_list_to_wavemap xsh_dispersol_list_to_slitmap" xsh_data_dispersol.h
                 "cleaned. changed API xsh_dispersol_list_to_wavemap xsh_dispersol_list_to_slitmap" xsh_data_dispersol.c
                 "changed call to \\
                 "changed call to xsh_dispersol_list_to_wavemap due to API change" test-xsh_data_dispersol.c

                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_respon_uvbvis.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_respon_visnir.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_scired_ifu_offset.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_scired_ifu_stare.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_scired_slit_nod.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_scired_slit_offset.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_scired_slit_stare.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_util_crh_single.c
                 "changes to have proper PRO.CATG and promote tmp products to final ones" xsh_wavecal.c
                 "Added tag in call to xsh_rec_list_save and always call also xsh_rec_list_save2 to have corresponding file in new format-image extensions" xsh_combine_nod.c
                 "Added tag in call to xsh_rec_list_save and always call also xsh_rec_list_save2 to have corresponding file in new format-image extensions. Added this product to list of returned by function" xsh_extract.c
                 "pass tag to xsh_divide function in place of filename. filename='tag.fits' set pro.catg=tag" xsh_divide.c
                 "Added tag in call to xsh_rec_list_save and always call also xsh_rec_list_save2 to have corresponding file in new format-image extensions." xsh_opt_extract.c
                 "added xsh_frameset_ext_table_frames()" xsh_dfs.h
                 "added xsh_frameset_ext_table_frames()" xsh_dfs.c
                 "cleaned." xsh_drl.h
                 "Pass frame tag in place of filename for xsh_rec_list_save2" xsh_data_rec.h
                 "uniform xsh_rec_list_save2 to xsh_rec_list_save" xsh_data_rec.c
                 "added xsh_pfits_get_gain" xsh_pfits.c xsh_pfits.h
                 "changes to calls to xsh_rec_list_save to reflect API change (pass tag in place of filename). Added calls to xsh_rec_list_save2" xsh_rectify.c
                 "pass tag and not filename in  xsh_remove_crh_single() and set pro.catg properly" xsh_remove_crh_single.c
                 "More readable filename: SUBTRACT_BACKGROUND. Set pro.catg explicitly and accordingly" xsh_subtract.c
                 "set ron-gain from FITS header values if their user-defined values is < 0. "\
                 "set ron-gain from FITS header values if their user-defined values is < 0. Add call to xsh_rec_list_save2() to have readable file format" xsh_subtract_sky_single.c
                 "changes to reflect xsh_rec_list_save API change. Added xsh_free statements to remove mem leaks" test-xsh_combine_nod.c
                 "changes to reflect xsh_rec_list_save API change. Added xsh_free statements to remove mem leaks" test-xsh_extract.c test-xsh_opt_extract.c test-xsh_rectify.c
                 "change call to xsh_rec_list_save to reflect API change" tests.c

Laurent-04-03-09:
	xsh/xsh_compute_slice_dist.c: Introduced FLIP of Down and Up
	 slices. Looks better now.
	xsh/xsh_data_image_3d: Suppressed spurious messages.
	xsh/xsh_format.c: Suppressed spurious messages.
	xsh/xsh_data_slice_offset.c/h: Added function to create the
	 structure by passing the size (ie nb of orders)
	xsh/xsh_dfs.h: Added Slice Offset Tags in macro XSH_IS_CALIB.
	xsh/xsh_drl.h: Modified prototype of xsh_rectify_ifu (added slice
	 offset frame)
	xsh/xsh_rectify.c: Introduced usage of slice offset table. Added
	argument slice offset frame in function xsh_rectify_ifu.
	xsh/xsh_extract.c: Added test if index out of rectified image.
	recipes/xsh_geom_ifu.c: Made workink without master dark. Adapted
	 to new xsh_rectity_ifu API. Set the default value of
	 localize_deg_lambda to 0.
	recipes/xsh_respon_uvbvis.c: Set the default value of 
	 localize_deg_lambda to 0.
	recipes/xsh_respon_visnir.c: Set the default value of 
	 localize_deg_lambda to 0.
	recipes/xsh_scired_slit_nod.c: Set the default value of 
	 localize_deg_lambda to 0.
	recipes/xsh_scired_slit_offset.c: Set the default value of 
	 localize_deg_lambda to 0.
	recipes/xsh_scired_slit_stare.c: Set the default value of 
	 localize_deg_lambda to 0.
	recipes/xsh_scired_ifu_offset.c: Introduced usage of slice offset
	 table. Set the default value of localize_deg_lambda to 0.
	recipes/xsh_scired_ifu_stare.c: Introduced usage of slice offset
	 table. Set the default value of localize_deg_lambda to 0.
	

Andrea-02-03-09:
                 "added xsh_util_efficiency2d.c" Makefile.am
                 "added to CVS (very preliminarcvs add xsh_util_efficiency2d.c)" xsh_util_efficiency2d.c
                 "added bias removed frame to recipe products" xsh_2dmap.c
                 "changes due to changed xsh_subtract_function API" xsh_geom_ifu.c
                 "removed binning from BIAS_REMOVE_CRH, XSH_CPIX_MAP, XSH_HPIX_MAP product filenames" xsh_mbias.c
                 "added background removed frame, and grid table to recipe products" xsh_mflat.c
                 "changes due to changed xsh_detect_continuum API and added residual table and bias removed frame to recipe products" xsh_orderpos.c
                 "added bias removed frame to products" xsh_predict.c
                 "changes due to xsh_subtract_background API change" xsh_respon_uvbvis.c
                 "changes due to xsh_subtract_background API change" xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c
                 "added bias removed frame to list of products" xsh_wavecal.c
                 "changes due to xsh_detect_continuum API change. Added residual table to recipe products" xsh_startup.c
                 "removed binning from file names" xsh_create_master.c
                 "changed calculate_qc_parameters create_resid_tab "\
                 "changed calculate_qc_parameters create_resid_tab  and xsh_detect_continuum API to have resid_tab as product" xsh_detect_continuum.c xsh_detect_continuum.h
                 "changed calculate_qc_parameters create_resid_tab  and xsh_detect_continuum API to have resid_tab as product" xsh_detect_continuum.c
                 "changed xsh_subtract_background API to have grid table and background frame as products. Removed binning from file names" xsh_subtract.c
                 "added XSH_ORDERPOS_RESID_TAB and XSH_ORDERPOS_RESID_TAB_arm defines" xsh_dfs.h
                 "changed xsh_detect_continuum, xsh_subtract_background function API" xsh_drl.h
                 "moved detmon functions at list end (in case one need to temporally comment them out)" Makefile.am
                 "changes due xsh_detect_continuum API change" test-xsh_detect_continuum.c
                 "changes due xsh_detect_continuum API change" test-xsh_flux_conservation.c
                 "changes due xsh_subtract_background API change" test-xsh_subtract_background.c

Andrea-27-02-09:
                 "correct typo in man page" xsh_2dmap.c
                 "now input if the LINE_LIST_arm (not cleaned)" xsh_wavecal.c

Andrea-24-02-09:
                 "updated pipe id" configure.ac
                 "changed crpix1/2 from 0.5 to 1.0 to match DICB picture at page 27 DICD" xsh_data_rec.c
                 "added CD matrix to 2D spectra" xsh_data_spectrum.c
                 "added CD matrix to cube" xsh_format.c
                 "added xsh_set_cd_matrix xsh_set_cd_matrix1d xsh_set_cd_matrix2d xsh_set_cd_matrix3d" xsh_utils.h
                 "added xsh_set_cd_matrix xsh_set_cd_matrix1d xsh_set_cd_matrix2d xsh_set_cd_matrix3d" xsh_utils.c
                 "added functions to set crpix, crva, cdelt, ctype on 3rd axis" xsh_pfits.h xsh_pfits.c

Laurent-24-02-09:
	xsh/xsh_data_pre.c/h: Changed creation of PRE frame for NIR (takes
	 into account the fact that NIR raw frame are now 2048x1100). Not
	 Tested YET.
	xsh/xsh_parameters.h: Added missing function
	 "xsh_parameters_subract_sky_single_get_niter"
	xsh/xsh_pfits.c: Use CUMOFF DEC and CUMOFF RA to calculate
	 Cumulative offset. Same for Relative Offset.
	xsh/xsh_pfits.h: Added Keywords 'CUMOFF DEC', 'CUMOFF RA', 'RELOFF
	 DEC' and 'RELOFF RA'
	xsh/xsh_rectify.c: Cleanup.
	xsh/xsh_subtract_sky_nod.c: Modified to handle an odd number of AB
	 pairs.
	xsh/xsh_format.c: Added retrieval of lambda min, max and step to
	 calculate Leywords CDELT3, CRVAL3, etc.

Andrea-23-02-09:
                "search for XSH_ARC_LINE_LIST instead of XSH_ARC_LINE_LIST_CLEAN_PREDICT and verify the user has indeed provided it" xsh_2dmap.c
                 "changed to allow niter,kappa,ron,gain to be set by user" xsh_geom_ifu.c
                 "changed to allow niter,kappa,ron,gain to be set by user" xsh_respon_uvbvis.c xsh_respon_visnir.c xsh_scired_ifu_offset.c xsh_scired_ifu_stare.c xsh_scired_slit_nod.c xsh_scired_slit_offset.c xsh_scired_slit_stare.c
                 "changed file names for lines_xyg and measure_xy_pos" xsh_startup.c
                 "changed API fit_spline and xsh_subtract_sky_single to allow setting of niter,kappa,ron,gain" xsh_subtract_sky_single.c
                 "added xsh_subtract_sky_single_param structure and xsh_parameters_subtract_sky_single_get_kappa xsh_parameters_subtract_sky_single_get_ron xsh_parameters_subtract_sky_single_get_gain functions" xsh_parameters.h
                 "added xsh_subtract_sky_single_param structure and xsh_parameters_subtract_sky_single_get_kappa xsh_parameters_subtract_sky_single_get_ron xsh_parameters_subtract_sky_single_get_gain functions" xsh_parameters.c
                 "uses XSH_CALPRO_MODEL_CONFIG_arm and XSH_MODEL_CONFIG_TAB_arm defines instead that their value" xsh_model_io.c
                 "added XSH_MEASURE_LINE_POS_XY+arm defines" xsh_dfs.h
                 "changed xsh_subtract_sky_single API" xsh_drl.h

Laurent-20-02-09:
	xsh/xsh_compute_response.c: File added. NOT tested (but compiling)
	xsh/xsh_data_star_flux.c/h: Handling of the standard star flux
	 frames (used in recipes xsh_respon_xx). Very preliminary !
	xsh/xsh_dfc.c: Added function xsh_find_std_star_flux.
	xsh/xsh_dfs.h: Added macro XSH_STD_STAR_FLUX.
	xsh/tests/test-xsh_data_star_flux.c: New unitary test.
	xsh/tests/Makefile.am
	xsh/xsh_combine_nod.c: Now makes the sum of the flux, not the
	 average.
	xsh/xsh_data_instrument.h: Changed the limits of the Slit taking
	 into account the fact that it's not centered at 0: -5.3,+5.7
	xsh/xsh_localize_obj.c: Usage of the 2 new parameters (min-slit,
	 max-slit to avoid localization problems at the edges of the
	 rectified frames).
	xsh/xsh_drl.h: Changed API to xsh_localize_obj and
	 xsh_localize_obj_ifu (additional parameter min-slit/max-slit)
	xsh/xsh_parameters.c: Added handling of new parameter
	 min_slit/max_slit.
	 Inserted parameter "kappa" into optimal extraction parameters
	 (though this parameter is not used yet !)
	xsh/tests/test-xsh_combine_nod.c: Adapted to localize new API.
	xsh/tests/test-xsh_localize_obj.c: Adapted to localize new API.
	xsh/xsh_pfits.c/h: added function xsh_pfits_get_arm (from a fits
	 header).
	xsh/xsh_subtract_sky_nod.c: Now can handle only one pair of
	 nodding frames.
	xsh/Makefile: Added new modules.
	recipes/xsh_geom_ifu.c: Fixed bug in call to subtract_background.
	 Adapted to localize new API.
	recipes/xsh_respon_uvbvis.c: Cleanup and bug fixes. Still NOT
	TESTED YET.
	recipes/xsh_respon_visnir: Freshly added. Very very preliminary.
	recipes/xsh_scired_ifu_offset.c: Suppressed re binning of some
	 parameters in case of NIR (no binning, no keyword BINX/BINY in NIR)
	recipes/xsh_scired_ifu_stare.c: Suppressed re binning of some
	 parameters in case of NIR (no binning, no keyword BINX/BINY in
	 NIR)
	recipes/xsh_scired_slit_nod.c: Added new parameter
	 min_slit/max_slit. Adapted to localize new API.
	recipes/xsh_scired_slit_offset.c: Suppressed re binning of some
	 parameters in case of NIR (no binning, no keyword BINX/BINY in
	 NIR). Adapted to localize new API.
	recipes/xsh_scired_slit_stare.c: Suppressed re binning of some
	 parameters in case of NIR (no binning, no keyword BINX/BINY in
	 NIR). Adapted to localize new API.
	recipes/xsh_wavecal.c: Suppressed re binning of some
	 parameters in case of NIR (no binning, no keyword BINX/BINY in
	 NIR).
	recipes/xsh_util_crh_single.c: Added Doxygen comments.
	recipes/xsh_util_efficiency.c: Added Doxygen comments.
	recipes/xsh_util_ima_arith.c: Added Doxygen comments.
	recipes/xsh_util_ima_getextno.c: Added Doxygen comments.
	recipes/xsh_util_ima_oversample.c: Added Doxygen comments.
	recipes/xsh_util_ima_rebin.c: Added Doxygen comments.
	recipes/xsh_util_ima_shift.c: Added Doxygen comments.
	recipes/xsh_util_subsample.c: Added Doxygen comments.
	recipes/xsh_util_ronbias.c: Added Doxygen comments.
	recipes/Makefile: Added new recipe (xsh_respon_visnir).

Regis-16-02-09:
	xsh/xsh_format.c: Replaced ratation by a flip.
	xsh/xsh_data_pre.c: Added xsh_pre_flip fucntion.

Laurent-13-02-09:
	xsh/xsh_format.c: Added rotation of UP and DOWN slitlets by 180
	 degres before building the data cube.
	xsh/xsh_data_pre.c/h: Added function xsh_pre_turn (rotate a pre by
	multiple of 90 degres, uses cpl_image_turn)

Andrea-13-02-12:
                "changed api xsh_subtract_bias to pass prefix of bias subtracted frame" xsh_drl.h xsh_subtract.c
                "changed to reflect xsh_subtract_bias api changes" test-xsh_subtract_bias.c test-xsh_subtract_dark.c
                 "changed to reflect xsh_subtract_bias api changes" test-xsh_subtract_bias.c test-xsh_subtract_dark.c
                 "changed to reflect xsh_subtract_bias api changes"
                 "changed to reflect xsh_subtract_bias api changes" xsh_2dmap.c xsh_geom_ifu.c xsh_mdark.c xsh_mflat.c xsh_orderpos.c xsh_predict.c xsh_respon_uvbvis.c xsh_scired_ifu_stare.c xsh_scired_slit_stare.c xsh_startup.c xsh_wavecal.c

Andrea-10-02-12:
                 "added parameter to control col/hot pix kappa and niter" xsh_parameters.h
                 "added parameter to control col/hot pix kappa and niter" xsh_parameters.c
                 "proper name for BIAS_PAIR_DIFF.fits" xsh_utils_image.c
                 "added parameters for hot/cold pix kappa and niter and to switch search that off" xsh_mbias.c

Andrea-10-02-09:
                 "put back xsh_find_disp_tab" xsh_dfs.h xsh_dfs.c
                 "uniform THE filename to its PRO.CATG" xsh_util_genTHEtab.c
                 "added tag on pre product and fixed typo getting ref_ury" xsh_create_master.c
                 "set function io provided tag to frame product" xsh_data_dispersol.c
                 "added tag in xsh_linetilt_list_save api" xsh_data_linetilt.c
                 "added tag in xsh_linetilt_list_save api" xsh_data_linetilt.h
                 "added tag in xsh_resid_order_save api" xsh_data_order_resid_tab.h
                 "added tag in xsh_resid_order_save api" xsh_data_order_resid_tab.c
                 "added precompiler check to deal with CPL4.8 and later" xsh_data_pre.c
                 "removed LAMBDA and SLIT extensions from IMA_ products and removed table product" xsh_data_rec.c
                 "added tag in xsh_resid_tab_save api" xsh_data_resid_tab.h
                 "added tag in xsh_resid_tab_save api" xsh_data_resid_tab.c
                 "added proper PRO.CATG to DISPER_SOL product" xsh_data_wavemap.c
                 "changes due to changed xsh_wavesol_save api"  xsh_data_wavesol.h
                 "changes due to changed xsh_wavesol_save api"  xsh_data_wavesol.c
                 "added proper PRO.CATG to RESID tables temporary products" xsh_detect_arclines.c
                 "added proper PRO.CATG to ORDERPOS_RESID_TAB_arm and EDGES_ORDER_TABLE_DETECTED_arm tables temporary products" xsh_detect_continuum.c
                 "added pro.catg to XSH_WAVE_MAP product" xsh_model_kernel.c
                 "fixed typo getting im_ly" xsh_utils_image.c
                 "added DPR.TYPE dependent prefix to BIAS_SUBTRACT temporary product and set corresponding PRO.CATG" xsh_subtract.c
                 "added XSH_DISP_TAB_arm and included '_' in XSH_PRODUCT_PREFIX definition" xsh_dfs.h
                 "added xsh_find_disp_tab, adjusted places where XSH_PRODUCT_PREFIX was used, added check on CPL version" xsh_dfs.c
                 "added PRO.CATG to INTERMEDIATE_WAVESOL_arm RESID_TAB_GOOD_LINES_arm FOLLOW_LINETILT_arm INTERMEDIATE_WAVESOL_arm temporary products"  xsh_follow_arclines.c
                 "added xsh_pfits_get_dpr_type xsh_pfits_get_dpr_catg xsh_pfits_get_dpr_tech" xsh_pfits.c xsh_pfits.h


Laurent-05-02-09:
	xsh/xsh_rectify.c: Fixed a bug in shifting with nodding keywords
	 (conversion from arc seconds to slits was wrong - typo error,
	 multiply instead of divide).
	recipes/xsh_scired_slit_nod.c: Suppressed the background
	 subtraction.
	

Laurent-23-01-09:
	xsh/xsh_data_dispersol.c: Fixed trailing bug: there was still
	 a cpl_polynomial_eval instead of xsh_order_list_eval (in function
	 xsh_dispersol_list_to_slitmap).
	xsh/xsh_rectify.c: Added transformation of model calculated x,y
	 into binned x,y.

Andrea-22-01-09:
                "added units to some parms to clarify" xsh_parameters.c
                 "added function to rescale parameters for bin size" xsh_mflat.c
                 "changed default of detectarclines-search-window-hsize from 3 to 2" xsh_predict.c
                 "added function to rescale parameters for bin size" xsh_wavecal.c
                 "added function to rescale parameters for bin size"
                 "added function to rescale parameters for bin size" xsh_scired_ifu_offset.c
                 "added function to rescale parameters for bin size" xsh_scired_ifu_stare.c
                 "added function to rescale parameters for bin size" xsh_scired_slit_nod.c
                 "added function to rescale parameters for bin size" xsh_scired_slit_offset.c
                 "added function to rescale parameters for bin size"
                 "added function to rescale parameters for bin size" xsh_scired_slit_stare.c
                 "updated version" configure.ac

Laurent-22-01-09:
	xsh/xsh_create_wavemap.c: The file name of the saved file was
	 hard coded. Now uses the argument to xsh_create_poly_wavemap.
	xsh/xsh_data_dispersol.c: Fixed bug in
	 xsh_dispersol_list_to_wavemap (used cpl_polynomial_eval instead
	 of xsh_order_list_eval, needed to take into account the binning).
	xsh/xsh_follow_arclines.c: Fixed bug in
	 find_tilt (used cpl_polynomial_eval instead
	 of xsh_order_list_eval, needed to take into account the binning).
	xsh/xsh_subtract_sky_single.c: Changed handling the binning of the
	 wavemap versus binning of the input frame:
	  If wavemap binning == input binning Then use the wavemap as it is
	  Else If wavemap binning == 1x1 Then rebin the wavemap according
	   to input binning
	  Else issue an error message and stop the recipe.
	recipes/xsh_wavecal.c: Added parameter "compute-wavesol". If
	 FALSE, a new wave solution is NOT computed and the wavemap is
	 computed using the input wave solution. In this case no residual
	 table product.
	xsh/xsh_parameters.c,h: Added function to create and get new
	 parameter "compute_wavesol" (used in xsh_wavecal)

Laurent-21-01-09:
	xsh/xsh_subtract_sky_single.c: Oops ! Had introduced a bug while
	 suppressing warnings.
	recipes/xsh_scired_slit_offset.c: Preliminary, not fully tested
	 but running version.

Laurent-19-01-09:
	xsh/xsh_subtract_sky_single.c: Introduced a re-binning of the
	 wave map. Note that the re-binning is made in a quite crude and
	 trivial way which implies problems at the edges of the orders.
	 Replaced cpl_polynomial_eval by xsh_order_list_eval to take into
	 account the binning.
	 Suppressed many warnings.
	recipes/xsh_scired_slit_stare.c: Updated messages.

Laurent-14-01-09:
	xsh/xsh_rectify.c: Fixed a bug in the calculation of slit limits
	 (function get_slit_min_max_nb): was 1/2 bin too large.

Laurent-13-01-09:
	xsh/xsh_localize_obj.c: Added some check (in function
	 xsh_localize_obj)
	xsh/xsh_rectify.c: Fixed bug in case of non 1x1 binning: one MUST
	 use functions "xsh_order_list_eval" instead of direct
	 cpl_polynomial_eval to do the conversion for binning.
	xsh/xsh_subtract_sky_single.c: Same bug fix. In addition one MUST
	 use the function "xsh_order_list_get_starty/endy" to do the
	 conversion for binning.

Laurent-12-01-09:
	xsh/xsh_subtract_sky_offset.c: Cleanup (suppressed unused static
	 function).
	xsh/xsh_subtract_sky_single.c: Suppressed check on unused
	 wave tab frame
	xsh/xsh_drl.h: Changed order of arguents in prototype of
	 xsh_subtract_sky_single
	recipes/xsh_scired_ifu_offset.c: Fixed bug (background subtraction
	 was done but the resulting frame was not used)
	

Laurent-09-01-09:
	xsh/xsh_data_rec.c: Something strange occurs (under Linux, not MacOs):
         the recipe xsh_scired_slit_nod crashs by segmentation fault -
	 for UVB not for VIS, in the function xsh_rec_list_free,
	 during one of the cpl_free calls.
         In order to allow continuation of tests, freeing of the rec_list
         is - temporarily - disabled until the problem is understood and
         fixed. The consequence is that there are some memory leaks in
	 all the recipes that use rectified frames (xsh_scired_... recipes).

Laurent-08-01-09:
	xsh/xsh_pfits.c/h: Changed definition of nodding keywords:
	 NODTHROW --> 'NOD THROW'
	 RELOFFSETX --> 'RELOFF DEC'
	 CUMOFFSETX --> 'CUMOFF DEC'
	xsh/xsh_data_rec.c: Changed function xsh_rec_get_nod_kw (nodding
	 data are double, not int)
	xsh/xsh_extract.c: Suppressed check on loc_table_frame; the
	 localization table is not used (yet) and in the case of IFU,
	 if used, we need a frameset of 3 localization table.
	xsh/xsh_data_wavemap.c: Cleanup (comments)
	xsh/xsh_badpixelmap.c/h: Added function xsh_bpmap_collapse_mean
	 used in xsh_combine_offset (if less than 3 sci frames)
	xsh/xsh_dfs.c/h: Added function xsh_dfs_split_offset (as there
	 are 2 different tags in the case of offset: OBJECT and SKY).
	 Modified function xsh_find_wave_tab_ifu: if only one wave tab,
	 it is "triplicated" (in standard we should have 3 different wave
	 tabs)
	xsh/drl.h: Added prototypes for xsh_subtract_sky_offset and
	 xsh_combine_offset
	xsh/xsh_remove_crh_multi.c: Added function xsh_combine_nod
	 (similar to xsh_remove_multiple). Introduced static function
	 xsh_remove_cosmics, used by functions xsh_remove_crh_multiple and
	 xsh_combine_nod (with a flag to make the fifference).
	xsh/xsh_remove_crh_single.c: Suppressed check on loc_table_frame,
	 not used yet and if we want to use it, needs a frameset in the
	 case of IFU.
	xsh/xsh_subtract_sky_offset.c: New source file containing function
	 xsh_subtract_sky_offset
	xsh/Makefile.am: Added xsh_subtract_sky_offset.c to the list of
	 source files.
	recipes/xsh_scired_ifu_offset.c: Completed version. Not yet fully
	 tested, but at least it compiles :)
	recipes/xsh_scired_ifu_stare.c: Added check on presence of Model
	 or wave tab.
	recipes/xsh_scired_slit_node.c: Cleanup (updated some comments)

Andrea-07-01-09:
                 "added functions to smooth an image" xsh_utils_image.h xsh_utils_image.c
                 "added image background smoothing" xsh_subtract.c
                 "added 2 products, a tab and an ima, to have the same information as in XSH_SPECTRUM_ORDER_2D, but in a more readable format" xsh_rectify.c
                 "added QC parameters for xsh_predict" xsh_qc_definition.h
                 "added smooth_x to background parameters definition structure" xsh_parameters.h
                 "added background-smooth-x/y" xsh_parameters.c
                 "WAVE_MAP is now saved as a FLOAT, with a PRO.CATG" xsh_model_kernel.c
                 "added IMA,TAB temporary products holding same infor as SPECTRUM_ORDER_1D_arm but in a more readable format" xsh_extract.c
                 "now IFU slices are computed on the frame if sobel/scharr tracing method is used" xsh_detect_order.c
                 "added QC-residuals on xsh_predict poly mode results" xsh_data_resid_tab.c
                 "added xsh_rec_list_save2 to generate sci product in more readable format"  xsh_data_rec.c
                 "added xsh_rec_list_save2 to generate sci product in more readable format"  xsh_data_rec.h
                 "generate also 2Dmap" xsh_util_genTHEtab.c
                 "use xsh_add_product_table_multi in place of xsh_add_product_table to allow extensions" xsh_predict.c

Andrea-22-12-08:
                 "added spectral format table as additional product" xsh_util_genTHEtab.c
                 "removed goto cleanup call" xsh_util_genTHEtab.c
                  added basic verifications on input frames" xsh_2dmap.c
                 "Renamed on-off product to fix action DecDryRun-AI-11" xsh_orderpos.c
                 "Renamed on-off product to fix action DecDryRun-AI-11" xsh_startup.c
                 "added checks on input frames to ensure that either a THEO table or a instrument model configuration table are provided in input, and not both of them. This to fix DecDryRun AI-30" xsh_2dmap.c
                 "added method to detect order structure" xsh_parameters.h
                 "added method to detect order structure" xsh_parameters.c
                 "added fit of slices/edges and sobel tracing method"  xsh_detect_order.c
                 "added some message if nb_pinhole is not found" xsh_detect_arclines.c
                 "added some message if nb_pinhole is not found" xsh_detect_arclines.c

Laurent-12-12-08:
	xsh/xsh_pfits.c,h: Added function and definition to retrieve
	 Keyword DATE-OBS.
	xsh/xsh_dfs.h: Added Tags for ifu offset recipe.
	xsh/xsh_utils.c,h: Added function xsh_order_frameset_by_date (used
	 in nodding and offset recipes to make sure that frames are in
	 correct order)
	xsh/xsh_subtract_sky_nod.c: Added call to
	xsh_order_frameset_by_date.
	recipes/xsh_scired_ifu_stare.c: Fixed bug relative to number of
	 orders.
	recipes/xsh_scired_ifu_offset.c: VERY VERY PRELIMINARY. Don't even
	think to run it !

Laurent-05-12-08:
	xsh/xsh_ifu_defs.h: Fixed bug in IFU SLITLET sizes (used the slit
	 size instead of good IFU size).
	xsh/xsh_format.c: Made more robust (added "check" here and there)
	xsh/xsh_merge_ord.c: Cleanup (an INFO message was misleading)
	xsh/xsh_rectify.c: Bug fixes and cleanup.

Laurent-03-12-08:
	xsh/xsh_follow_arclines.c: Suppressed call to
	 xsh_nodel_pipe_anneal, now done in sh_wavceal.c

Laurent-02-12-08:
	xsh/xsh_rectify.c: Fixed a bug in case of 1x2 or 2x2 bining (the
	 conversion from wavesol data to binned data was missing).
	xsh/xsh_localize_obj.c: Added some check for robustness.

Laurent-01-12-08:
	xsh/xsh_follow_arclines.c: Fixed an error: in IFU mode,
	 the wave solution is not used !

Laurent-25-11-08:
	xsh/xsh_follow_arclines.c: Cleanup. Fixed a small default (too
	 many '.fits'  suffixes in wave map file names !)
	xsh/xsh_data_wavesol.c: Added check on nb of points vs nb of coeff
	 before gsl_multifit_linear.
	xsh/xsh_data_wavemap.c: Added check on nb of points vs nb of coeff
	 before gsl_multifit_linear.
	xsh/xsh_dfs.c: cleanup.
	xsh/xsh_data_instrument.h: Set the Slit length (in SLIT mode) to
	 the proper value: 11"
	recipes/xsh_wavecal.c: Added messages (debug-level>=low) when
	 saving products. Fixed a small default (too many '.fits' 
	 suffixes in wave map file names !)

Laurent-24-11-08:
	xsh/xsh_create_wavemap.c: Fixed a bug (bad XSH_FREE) in
	 xsh_create_poly_wavemap function.
	xsh/xsh_follow_arclines.c: Suppressed suffix '.fits' to filename
	 passed to function xsh_create_poly_wavemap (already done in this
	 function). Note that the suffix must be set in the call to
	 xsh_create_model_wavemap.

Laurent-21-11-08:
	xsh/xsh_data_instrument.c/h: Suppressed binning from config. Adapted
	 function to retrieve binning.
	xsh/xsh_create_wavemap.c: Added the file name to arguments of
	 xsh_create_poly and xsh_create_model functions (necessary for 
	 IFU, where we have 1 wave map per slitlet)
	 Changed call to xsh_wavesol_load (added instrument to retrieve
	 binning from instrument).
	xsh/xsh_drl.h: Changed prototypes for xsh_create_poly_wavemap and
	 xsh_create_model_wavemap and xsh_follow_arcliens_ifu.
	xsh/xsh_data_order.c: Now gets binning from instrument.
	xsh/xsh_data_wavesol.c: �
	xsh/xsh_detect_arclines.c: Adapted to xsh_wavesol_load binning
	 handling.
	xsh/xsh_detect_order.c:  Adapted to xsh_wavesol_load binning
	 handling.
	xsh/xsh_dfs.c: Suppressed saving of image in xsh_dfs_check_nan
	 (till we understand why e get such a cryptic CPL error !)
	xsh/xsh_follow_arclines.c: Save twice the wavesol frame (one
	 before wave map creation and one after, because computation of
	 the spectral resolution needs the wave map).
	 Added creation of wave maps in IFU mode (one per slitlet) and
	 computation of spectral resolution per slitlet.
	xsh/xsh_opt_extract.c: Adapted to xsh_wavesol_load binning
	 handling.
	xsh/xsh_rectify.c: Adapted to xsh_wavesol_load binning
	 handling.
	xsh/tests/test-xsh_data_wave_tab2d.c: Adapted to xsh_wavesol_load 
	 binning handling.
	xsh/tests/test-xsh_data_wavemap.c: Adapted to xsh_wavesol_load 
	 binning handling.
	recipes/xsh_2dmap.c: Adapted to new API for xsh_create_poly or
	 model wave maps.
	recipes/xsh_wavecal.c: Now creates products for wave maps in IFU
	 mode.

Laurent-10-11-08:
	xsh/xsh_data_instrument.c/h: Added functions to retrieve binning,
	 xsh_instrument_get_binx/biny.
	xsh/xsh_data_wavesol.c/h: Added binning to the structure.
	 Added pixel position conversion with binning.
	 Works with binning 1x1, NOT tested for other binnings.
	xsh/xsh_detect_arclines.c: Added setting binning when wavesol
	 loaded.
	xsh/xsh_follow_arclines.c: Added setting binning when wavesol
	 loaded.
	 Added usage of Model or Theoretical table (for slit and Ifu).
	 Added usage of parameter "model-wavemap-compute" (no wavemap
	 if == flase, the default)
	xsh/xsh_opt_extract.c: Added setting binning when wavesol
	 loaded.
	xsh/xsh_parameters.c/h: Added handling of parameter
	 "model-wavemap-compute" used by xsh_wavecal (in
	 xsh_follow_arclines)
	xsh/xsh_rectify.c: Added setting binning when wavesol
	 loaded.
	xsh/xsh_create_wavemap.c: Added setting binning when wavesol
	 loaded.
	 Fixed a problem specific to MacOSX Intel (pb of float to integer
	 conversion in function xsh_create_poly_wavemap).
	recipes/xsh_wavecal.c: Added handling of parameter
	 "model-wavemap-compute". Default is 'false' ==> no wave map.

Laurent-31-10-08:
	xsh/xsh_data_wavesol.c: Cleanup.
	xsh/xsh_drl.h: Modified prototypes of xsh_follow_arclines: added
	 model config frame (not yet Implemented)
	recipes/xsh_wavecal.c: Added possibility to use of model config.
	xsh/xsh_follow_arclines.c: Fixed (hopefully) the 1 pixel shift.
	 Prepare for usage of model config (not yet implemented)
	 Added possibility to use polynomials degrees for wave sol
	  computation different from the original wave sol (set in
	  parameters 'order-poly-degree' and 'lambda-poly-degree'
	xsh/xsh_parameters.c/h: Added wavecal parameters
	 'order-poly-degree' and 'lambda-poly-degree' used in
	 xsh_follow_arclines.
	xsh/xsh_order_table_from_fmtchk.c: Fixed (hopefully) the 1 pixel shift.
	
Laurent-29-10-08:
	xsh_scired_slit_stare.c: the recipe no longer crashes if master
	 dark is missing.
	
Andrea-27-10-08:
                 "temporally removed xshp/recipes/tests" configure.ac
                 "source the already existing  xsh_irplib_utils.h" irplib_plugin.h
                 "added keys required by DFS" xsh_paf_save.c
                 "remove xsh_subtract_sky_single.c|.h not to have problems with DFS ipip installation"  Makefile.am
                "added to cvs (to run tests on recipes)" irplib_plugin.h  irplib_test.h  irplib_utils.h irplib_plugin.c  irplib_test.c  irplib_utils.c
                 "fix mem leak" xsh_mbias.c
                 "fix compiler warnings" xsh_model_compute.c
                 "fix compiler warnings" xsh_startup.c
                 "fix compiler warnings" xsh_util_genTHEtab.c
                 "fix mem leak" xsh_create_master.c
                 "fixed mem leaks" xsh_data_rec.c
                 "fix mem leaks" xsh_data_wavemap.c
                 "fix mem leaks" xsh_detect_arclines.c
                 "fix mem leaks" xsh_detect_continuum.c
                 "fix mem leaks" xsh_follow_arclines.c
                 "added xsh_image_crop" xsh_utils_image.h
                 "fixed mem leaks" xsh_rectify.c
                 "fixed mem leaks" xsh_utils_image.c
                 "fixed mem leaks" xsh_remove_crh_single.c
                 "fixed mem leaks" xsh_subtract.c

Andrea-21-10-08:
                 "added image correction term" test-xsh_flux_conservation.c
                 "added XSH_QC_NORMRON XSH_QC_NORMRON_ERR XSH_QC_NORMFPN XSH_QC_NORMFPN_ERR" xsh_create_master.c
                 "added XSH_QC_NORMRON XSH_QC_NORMRON_ERR XSH_QC_NORMFPN XSH_QC_NORMFPN_ERR" xsh_pfits_qc.h
                 "added XSH_QC_NORMRON XSH_QC_NORMRON_ERR XSH_QC_NORMFPN XSH_QC_NORMFPN_ERR" xsh_qc_definition.h

Andrea-20-10-08:
                 "uses xsh_image_warp" test-xsh_flux_conservation.c
                 "added function to test image warp & corresponding flux conservation" xsh_utils_image.c xsh_utils_image.h
                 "set a reange on binx/y params" xsh_util_ima_rebin.c
                 "added xsh_util_ima_oversample.c" Makefile.am
                 "added to repository" xsh_util_ima_oversample.c
                 "simplified" test-xsh_pix_convention.c
                 "updated release no" configure.ac
Andrea-13-10-08:
                Fixes to xsh_startup. Updated pipe ID to 0.3.0
Andrea-10-10-08:
                "Fix problems methods 'gfit','peaks','pm'. Suppressed 'pbrfit'.                  'peaks' and 'pm' require ORDER_TAB_CENTR_arm'" xsh_startup.c
                 "fixed typo on file product to be cleaned"  xsh_mbias.c
                 "removed unused mbias parameters" xsh_create_master.c
                 "removed unused mbias parameters" xsh_parameters.c

Andrea-06-10-08:
          "update to take into acciount of pre-overscans" xsh_util_ima_rebin.c
                 "fixed a recipe robustness problem" xsh_startup.c
                 "added UVB qualifier on D2 and QTH products to have unifor naming conventions with other arm data" xsh_data_order.c
                 "renamed CONF_OPT XSH_MODEL_CONFIG_OPT, ARC_ with ARC"  xsh_dfs.h
                 "fixed param name typo in displayed message" xsh_order_table_from_fmtchk.c
                 "replace xsh_add_product_table by xsh_add_product_table_multi to have additional extension required for QC, to close corresponding DRL0.2 action, added '_' on some product names to make them clearer"  xsh_mflat.c
                 "replace xsh_add_product_table by xsh_add_product_table_multi to have additional extension required for QC, to close corresponding DRL0.2 action"  xsh_orderpos.c

Laurent-26-09-08:
	xsh/xsh_data_image_3d.c/h: New module for handling Data
	 Cubes. Similar to CPL image structure and functions but not as
	 complete and general.
	xsh/xsh_data_pre_3d.c/h: New module, similar to xsh_pre structure
	 and functions, with data cubes instead of cpl images.
	xsh/xsh_format.c: New function xsh_format. create spectrum 3d
	(data cube) from 2D spectras in IFU mode.
	xsh/xsh_dfs.c: Added function xsh_add_product_pre_3d (create a
	 product from an xsh_pre_3d structure).
	xsh/xsh_dfs.h: Added also definition for PRO.CATG for 3D spectrum.
	xsh/xsh_drl.h: Added prototype for xsh_format
	xsh/xsh_pfits.c/h: Added function to get NAXIS3 Keyword (for
	 image_3d)
	xsh/Makefile.am: Included new modules (xsh_data_image_3d, 
	 xsh_data_pre_3d, xsh_format)
	xsh/tests/test-xsh_data_image_3d.c: Unit test for data cubes
	 functions.
	recipes/xsh_scired_ifu_stare.c: Added spectrum 3D creation and
	 product.
	

Andrea-18-09-08:
                 "added xsh_image_compute_geom_corr()" xsh_utils_image.h
                 "added xsh_image_compute_geom_corr(), xsh_compute_geom_corr" xsh_utils_image.c
Andrea-17-09-08:
                "added useful message to better understand user recipe mis-usage" xsh_model_kernel.c
                 "Fixed some bugs" test-xsh_ima_resampl_with_flux_conserved.c
                 "man-page" xsh_startup.c
Andrea-15-09-08:
                 "added required include xsh_data_pre.h" xsh_badpixelmap.h
                 "added xsh_detmon_ronbias_histo_reduce xsh_flux_get_bias_window" xsh_detmon.h
                 "removed declarations xsh_detmon_ronbias_histo_reduce xsh_flux_get_bias_window" xsh_detmon.c
                 "added xsh_detmon_build_synthetic from src file" xsh_detmon.h
                 "moved declaration xsh_detmon_build_synthetic to header file" xsh_detmon.c

                 "Flag bad pixels as in DRL0.2 doc" xsh_lingain.c
                 "added XSH_BP_MAP_NL" xsh_dfs.h
                 "aligned to detmon" xsh_detmon.h xsh_detmon_lg.c xsh_detmon_lg.h xsh_detmon.c
                 "add xsh_bpmap_bitwise_to_flag()" xsh_badpixelmap.h
                 "add xsh_bpmap_bitwise_to_flag()" xsh_badpixelmap.c

Andrea-12-09-08:
                "added to CVS" test-xsh_ima_resampl_with_flux_conserved.c
                 "added test-xsh_ima_resampl_with_flux_conserved" Makefile.am
                "Added CRH_MAP_arm and changed convention of QUAL in mdark: CRHs are never flagged" xsh_remove_crh_multi.c
                 "fixed compiler warnings" xsh_linear.c xsh_lingain.c xsh_mbias.c xsh_mdark.c xsh_model_compute.c xsh_util_ima_shift.c
                 "fixed compiler warnings" xsh_create_master.c
                 "Fix problem with DFS compliance, fixed compiler warnings" xsh_model_kernel.c
                 "fixed compiler warnings" xsh_follow_arclines.c
                 "added xsh_dfs_extract_calib_frames xsh_dfs_extract_raw_frames" xsh_dfs.h xsh_dfs.c

Andrea-11-09-08:
                "changed API (pass also xsh_instrument to properly set the product tag)" xsh_model_kernel.h
                 "changed API (pass also xsh_instrument to properly set the product tag)" xsh_model_kernel.c
                 "added XSH_CALPRO_MODEL_MEASCOORD_arm to XSH_IS_CALIB section" xsh_dfs.h

                " fixed typo on x-y coordinate, added proper return if function fails" xsh_model_kernel.c
                 "added xsh_frame_config" xsh_dfs.h
                 "use xsh_frame_config" xsh_dfs.c
                 "use xsh_frame_config" xsh_util_genTHEtab.c
                 "added several checks statements and use xsh_frame_config" xsh_startup.c

Laurent-11-09-08:
	recipes/xsh_wavecal.c: Added a message (subract NIR ON-OFF)
	xsh/xsh_follow_arclines: Fixed calculation of Spectral Resolutio.
	 Added QC parameters QC.RESOLMED and QC.RESOLRMS.
	 Fixed 'slit_index' in residual table (was completely crazy !)
	xsh/xsh_qc_definition.h: Enabled QC parameters: QC.RESOLMED and 
	 QC.RESOLRMS
	xsh/xsh_pfits_qc.h: Enabled QC parameters: QC.RESOLMED and 
	 QC.RESOLRMS
	xsh/xsh_data_linetilt.c/.h: Added slit_index.

Laurent-10-09-08:
	xsh/xsh_follow_arclines.c: Implemented Paolo's idea to compute the
	 wavemap: instead of using only the center of the lines which
	 leads to problems if there are not enough lines we use now ALL 
	 the points that ar used to compte the line tilt, thus we
	 certainly always have enough data to compte the wave map (except 
	 perhaps in some pathological cases).
	
Laurent-09-09-08:
	xsh/xsh_data_wavemap.c/h: Suppressed spurious #if. Added check on nb
	 of coefs vs polynomial degrees.
	xsh/xsh_drl.h: Modified prototypes of xsh_follow_arclines and
	 xsh_follow_arclines_ifu (stuff for creation of the wave map)
	xsh/xsh_follow_arclines.c: Added creation of Wave Map (when
	 possible). Modified function arguments (added wavemap_frame)
	recipes/xsh_wavecal.c: Added parameter for wave map. Added creation
	 of Wave map product. NB: only in SLIT mode for the moment
	recipes/xsh_scired_ifu_stare.c: Added initialization of parameter
	 "optextract" (FALSE by default)

Laurent-04-09-08:
	xsh/xsh_dfs.h: Added Tags for SPECTRUM_ORDER... and MERGE_ORDER...
	 for IFU.
	xsh/xsh_data_spectrum: Suppressed frame_set_tag in ..._save (was a
	 problem with IFU). Now done in the caller.
	xsh/xsh_drl.h: Added prototypes for 'xsh_extract_ifu' and
	 'xsh_merge_ord_ifu'.
	xsh/xsh_extract.c: Added function xsh_extract_ifu. Split the former
	 xsh_extract into xsh_extract and xsh_extract_with_tag (used by
	 both xsh_extract and xsh_extract_ifu, both function managing the
	 relevant tags)
	xsh_merge_ord.c: Added xsh_merge_ord_ifu. Same changes as in
	 xsh_extract.c
	xsh/xsh_parameters.h,c: Added entry 'rectify_full_slit' to the
	 rectify_param structure: Default is TRUE; if FALSE, calculates the
	 actual Slit size based on the ordee edges.
	xsh/xsh_rectify,c: Added usage of parameter rectify_full_slit.
	 NOT YET FULLY TESTED.
	recipes/xsh_geom_ifu.c: changed initialisation of rectify_param.
	recipes/xsh_respon_uvbvis.c: idem
	recipes/xsh_scired_slit_nod.c: idem
	recipes/xsh_scired_slit_stare.c: idem
	recipes/xsh_scired_ifu_stare.c: Added generation of 1D and 2D
	 products (one per slitlet ==> 12 products right now !!!)

Andrea-03-09-08:
                 "added XSH_RESID_TAB_TABLE_COLNAME_RESX XSH_RESID_TAB_TABLE_COLNAME_RESY" xsh_data_resid_tab.h
                 "added XSH_RESID_TAB_TABLE_COLNAME_RESX XSH_RESID_TAB_TABLE_COLNAME_RESY" xsh_data_resid_tab.c
Andrea-02-09-08:
                 "updated xy_centr table with paul fit solutions" xsh_startup.c
                 "changed crh_clip_param defaults" xsh_mbias.c
                 "changed crh_clip_param and noise_clip_param defaults" xsh_mdark.c
                 "changed xsh_parameters_clipping_noise_create API" xsh_parameters.h
                 "changed xsh_parameters_clipping_noise_create API and implementation" xsh_parameters.c
Andrea-29-08-08:
                 "updated man page" xsh_util_ima_rebin.c
                 "added and used xsh_wavesol_trace()" xsh_data_wavesol.c
                 "added xsh_wavesol_trace(), changed xsh_wavesol_save() API" xsh_data_wavesol.h
                 "reflect changes API xsh_wavesol_save() and uses xsh_wavesol_trace()" xsh_detect_arclines.c
                 "reflect changes API xsh_wavesol_save() and uses xsh_wavesol_trace()" xsh_follow_arclines.c
                 "removed already commented out code" xsh_dfs.c
                 "uses xsh_add_product_table_multi in place of xsh_add_product_table" xsh_2dmap.c
                 "uses xsh_add_product_table_multi in place of xsh_add_product_table" xsh_predict.c
                 "added arm value in filename product" xsh_wavecal.c

Andrea-27-08-08:
                "moved xsh_model_first_anneal_save and xsh_model_first_anneal to xsh_model_kernel to be shared with xsh_startup" xsh_model_first_anneal.c
                 "added call to first_anneal" xsh_startup.c
                 "added xsh_model_first_anneal xsh_model_first_anneal_save" xsh_model_kernel.h xsh_model_kernel.c
                 "aligned to latest detmon release (faster)" xsh_detmon.h xsh_detmon.c xsh_detmon_lg.c xsh_detmon_lg.h
Andrea-26-08-08:
               "added setting of res_max" test-xsh_remove_crh_multiple.c
              "commented out call to xsh_imagelist_collapse_sigclip_iter_create to fix unit test failure" xsh_remove_crh_multi.c
Laurent-25-08-08:
	recipes/xsh_geom_ifu.c: First version of this recipe. Seems to
	 work. Needs more tests.
	xsh/xsh_rectify.c: Changed the calculation of the slit length for
	 IFU (taking into account the actual size of the orders if
	 rectify_radius != 0)
	xsh/xsh_compute_slice_dits.c: New, usd by xsh_geom_ifu
	xsh/xsh_data_slice_offset.c/.h: Handling of SLICE OFFSET tables
	xsh/dfs.h: Added definitions for SLICE_OFFSET Tables.
	
Andrea-25-08-08
                 "changes to reflect xsh_order_list_save API change" test-xsh_detect_continuum.c
                 "changes to reflect xsh_order_list_save API change" xsh_create_order_table.c
                 "changes to reflect xsh_order_list_save API change" xsh_detect_continuum.c
                 "changes to reflect xsh_order_list_save API change" xsh_flat_merge.c
                 "changes to reflect xsh_order_list_save API change" xsh_order_table_from_fmtchk.c
                 "made more robust bias subtraction in case input bias is NULL" xsh_prepare.c
                 "added noise-clip-res-max retrieval" xsh_parameters.c
                 "changes to reflect xsh_order_list_save API change" xsh_detect_order.c
                 "added XSH_RESID_TAB_TABLE_COLNAME_XGAUSS XSH_RESID_TAB_TABLE_UNIT_XGAUSS XSH_RESID_TAB_TABLE_COLNAME_YGAUSS XSH_RESID_TAB_TABLE_UNIT_YGAUSS XSH_RESID_TAB_TABLE_COLNAME_XPOLY XSH_RESID_TAB_TABLE_UNIT_XPOLY XSH_RESID_TAB_TABLE_COLNAME_YPOLY XSH_RESID_TAB_TABLE_UNIT_YPOLY" xsh_data_resid_tab.h
                 "added residual info in residual table extension" xsh_data_resid_tab.c
                 "changed API xsh_order_list_save" xsh_data_order.h
                 "changed API xsh_order_list_save" xsh_data_order.c
                 "deal with cases where master bias and master dark are missing, fixed compilation warning"  xsh_2dmap.c
                 "deal with cases where master bias and master dark are missing, fixed compilation warning"  xsh_predict.c
                 "deal with cases where master bias and master dark are missing"  xsh_wavecal.c
                 "deal with cases where master bias and master dark are missing"  xsh_orderpos.c
                 "deal with cases where master bias and master dark are missing, fixed compilation warning"  xsh_scired_slit_nod.c
                 "deal with cases where master bias and master dark are missing"  xsh_scired_ifu_stare.c
                 "deal with cases where master dark is missing,fixed compiler warning"  xsh_mflat.c
                 "temporarily commented out xsh_add_product_image of crh frame to fix a robustness problem" xsh_mdark.c
Andrea-22-08-08
        "updated id" configure.ac
        "added proper value of res_max top make pass the test" test-xsh_detect_continuum.c
        "added some checks to trace possible errors" xsh_detect_continuum.c
        "added arm specifier to product filename" xsh_2dmap.c
        "added arm specifier to product filename" xsh_predict.c
        "added arm specifier to product filename" xsh_startup.c
        "added xsh_pre_data_window_sample_flux_pa" xsh_data_pre.c
        "added xsh_pre_data_window_sample_flux_pa" xsh_data_pre.h
        "added arm specifier to product filename" xsh_detect_arclines.c
        "added pre-clip of residuals beyond a fixed threshold"  xsh_detect_continuum.c
        "added arm specifier to product filename" xsh_follow_arclines.c
        "uses the more general xsh_pre_data_window_sample_flux_pa in place of xsh_pre_data_window_median_flux_pa and dump grid table if requested" xsh_subtract.c
        "added method debug to
        "added method debug' to xsh_background_param structure"

Laurent-21-08-08
	xsh/xsh_localize_obj.c: Added function 'xsh_localize_obj_ifu',
	 taking as input a frameset of the 3 rectified frames - one per
	 slitlet. Output is a frameset with the 3 localize tables.
	xsh/xsh_dfs.h: Adde prototype for 'xsh_localize_obj_ifu'.
	 recipes/xsh_scired_ifu_stare.c: Added the localization. Works
	 apparently with VIS. To be tested more deeply.

Laurent-20-08-08
	recipes/xsh_scired_ifu_strae: updated up to the first
	  rectification.
	xsh/xsh_rectify.c: updated xsh_rectify_ifu. Seems to work at
	 least rectifies the 3 slitlets.
	 Suppressed parameter 'slice_offset' in xsh_rectify and
	 xsh_rectify_ifu.
	xsh/xsh_ifu_defs.h: Added definitions for IFU slitlets.
	xsh/xsh_drl.h: Updated prototypes for xsh_retify and
	 xsh_rectify_ifu (see above)
	xsh/xsh_data_instrument.h: Added slit definitions as #include
	xsh/xsh_dfs.c and xsh_dfs.h: Added function xsh_find_wave_tab_ifu
	 to retrieve a frameset with the 3 wave tabs (1 per slitlet)
	xsh/xsh_subtract.c: Changed some xsh_msg into xsh_msg_dbg_high.
	recipes/xsh_respon_uvb_vis: adapted new call to xsh_rectify.
	recipes/xsh_scired_slit_stare.c: idem
	recips/xsh_scired_slit_nod.c: idem

Laurent-19-08-08
	Created xsh_scired_ifu_stare recipe (preliminary)
	recipes/Makefile.am: added xsh_scired_ifu_stare
	xsh/xsh_dfs.h: added tag 'OBJECT_IFU_STARE' for
	 xsh_scired_slit_stare recipe

Andrea-19-08-08:
        Fix AI26 and "provide proper message (but only in debug mode)" xsh_data_order.c
        "fix compilation warning" xsh_dfs.c
        "added xsh_frame_force_pro_catg()" xsh_pfits.h xsh_pfits.c

Andrea-18-08-08:
        "cleaned unnecessary commented code (replaced by xsh_frame_product)" xsh_compute_linearity.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_compute_noise_map.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_create_master.c
        "Product filename is now arm dependent" xsh_create_master.c xsh_create_order_table.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_arclist.c
        "added xsh_grid2table" xsh_data_grid.c xsh_data_grid.h
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_linetilt.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_the_map.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_wavesol.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_model_kernel.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_wavemap.c
        "added xsh_pre_data_window_min_flux_pa" xsh_data_pre.c
        "added xsh_pre_data_window_min_flux_pa" xsh_data_pre.h
        "added tag to xsh_order_list_save API" xsh_order_table_from_fmtchk.c
        "changes to reflect xsh_order_list_save API changes" xsh_flat_merge.c
        "added arm qualifier in BACKGROUND_ and SUBTRACTED_ product filenames" xsh_subtract.c
        "added tag to xsh_arclist_save API" xsh_data_arclist.h
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_localization.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_spectrum.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_spectrum1D.c
        "removed code to save frame (replaced by xsh_frame_product) and changes to reflect xsh_arclist_save API change" xsh_detect_arclines.c
        "changed API xsh_detect_arclines" xsh_drl.h
        "added XSH_GUESS_LINES_POS_arm XSH_MASTER_FLAT_arm xsh_add_product" xsh_dfs.h
        "added tag to xsh_order_list_save API" xsh_data_order.h
        "removed code to save frame (replaced by xsh_frame_product) and changes to reflect xsh_order_list_save API change" xsh_data_order.c
        "changes to reflect xsh_order_list_save API change" xsh_detect_order.c
        "changes to reflect API changes" xsh_detect_continuum.c
        "changes to reflect API changes" xsh_detect_continuum.c
        "removed code to save frame (replaced by xsh_frame_product)" xsh_data_resid_tab.c
        "changed API xsh_resid_order_save, added xsh_resid_order_2tab" xsh_data_order_resid_tab.h
        "changed API xsh_resid_order_save, added xsh_resid_order_2tab" xsh_data_order_resid_tab.c
        "added RESELMIN|MAX|AVG|RMS" xsh_qc_definition.h
        "added QC_ORD_ORDERPOS_RESIDMIN_SEL and similar for MAX AVG RMS" xsh_pfits_qc.h
        "maded changes to reflect xsh_detect_arclines API change" test-xsh_detect_arclines.c
        "maded changes to reflect xsh_order_list_save API change" test-xsh_detect_continuum.c
        "maded changes to reflect xsh_detect_arclines API change" xsh_2dmap.c  xsh_predict.c
        "added arm setting in file name products" xsh_mflat.c
        "added xsh_find_usr_lines_guess_tab" xsh_dfs.h
        "added xsh_find_usr_lines_guess_tab and initial version of xsh_add_product (not yet used)" xsh_dfs.c
        "added res_max to resid_clipping_param structure" xsh_parameters.c
        "added res_max to resid_clipping_param structure" xsh_parameters.h

        "Add arm id on ARC_LINE_LIST_CLEAN product" xsh_detect_arclines.c
        "added QC params for ARC_LINE_LIST_CLEAN_2DMAP and ARC_LINE_LIST_CLEAN_PREDICT to fix AI25/7" xsh_qc_definition.h
        "added XSH_ARC_LINE_LIST_CLEAN_PREDICT_arm and XSH_ARC_LINE_LIST_CLEAN_2DMAP_arm" xsh_dfs.h
        "added xsh_get_tag_from_arm xsh_find_frame_with_tag" xsh_dfs.h
        "added xsh_get_tag_from_arm xsh_find_frame_with_tag" xsh_dfs.c
        "use xsh_find_frame_with_tag" xsh_mdark.c xsh_mflat.c xsh_orderpos.c xsh_predict.c xsh_startup.c

Regis-13-08-08:
	recipes/xsh_2dmap.c:
	xsh/xsh_create_wavemap.c:
	xsh/xsh_dfs.c:
	xsh/xsh_parameters.c:
	xsh/xsh_drl.h:
	Added the use of physical model in 2dmap recipe
	Added a parameter to choose the possibility of compute the wavemap in physcal model
	xsh/xsh_detect_order.c:
	xsh/xsh_mflat.c:
	Change the default of S/N and min_order_size_x to o avoid that edge up and low crossed.

Laurent-25-07-08:
	xsh_utils.h: Fixed a bug in macro XSH_REALLOC.
	xsh_detect_continuum.c: Completely modified the QC parameters
	 calculation, according to Andrea reuirements.
	 Added creation of residual table frame
	    "ORDERPOS_RESID_TAB_arm.fits
	xsh_data_order_resid_tab.c/h: New function created to handle this
	 kind of residual table (see above)
	xsh_dfs.h: added a tag for this kind of table
	 'XSH_RESID_ORDER_TAB'
	Makefile.am: introduced new modules xsh_data_order_resid_tab.c/h
	xsh_drl.h: Added definition of SLIT_PRECISION_IFU, used in wavecal
	 IFU.
	cdh_dfs.c/h: cleanup

Andrea-24-07-08:
       "updated to fix problem on gain table null columns" xsh_detmon.c xsh_detmon_lg.c
       "updated to fix problem on gain table null columns" xsh_detmon_lg.h
       "added IRPLIB_GAIN_NIR|OPT to support new changes in detmon_gain"  xsh_linear.c

Laurent-24-07-08:
	xsh_detect_continuum.c: Calculates the QC parameters (Residuals)
	 with all the pixels (was with 10 pixels per order). Also fixed a
	bug (the RMS QC was actually the MIN)
	xsh_follow_arclines.c: fixed a -small- bug in
	xsh_follow_arclines_ifu (still preliminary)

Andrea-22-07-08:
      "updated module to latest detmon version" xsh_detmon_lg.c xsh_detmon_lg.h
      "replaced irplib_ by xsh_" xsh_detmon.h
      "replaced irplib_ by xsh_" xsh_detmon.c
      "replaced irplib_ by xsh_" xsh_create_master.c
      "replaced irplib_ by xsh_" xsh_detmon_lg.c
      "udates to reflect detmon lingain recent API changes" xsh_lingain.c
      "udates to reflect detmon lingain recent API changes" xsh_linear.c

      "added xsh_create_master_bias2 to implement clean-mean bias computation method" xsh_drl.h
      "added xsh_create_master_bias2 to implement clean-mean bias computation method" xsh_remove_crh_multi.c
      "fixed typo" xsh_create_master.c
      "added call to xsh_create_master_bias2 to implement clean-mean bias computation method" xsh_mbias.c
Andrea-21-07-08:
     "commented call to xsh_imagelist_collapse_sigclip_iter_create" xsh_remove_crh_multi.c
      "some code clean" xsh_mdark.c
      "fix typos ron params names" xsh_create_master.c
      "fix typo ron parms names" xsh_parameters.c
      "moved several functions to xsh_create_master.c module" xsh_mbias.c
      "added several functions from xsh_mbias.c to have proper QC" xsh_create_master.c
      "added several functions from xsh_mbias.c to have proper QC" xsh_create_master.c
      "changed interface xsh_create_master_bias" xsh_drl.h

Laurent-21-07-08:
	xsh_create_master.c: xsh_create_master_dark/bias, suppressed
	 generation of QC in the case of unitary tests (no parameterlist)
	xsh_follow_arclines.c: introduced PRELIMINARY handling of the IFU
	 case (function xsh_follow_arclines_ifu).
	xsh_drl.h: prototype of xsh_follow_arclines_ifu.
	xsh/tests/Makefile.am: suppressed duplicate 'test_xsh_opt_extract'
	
Andrea-18-07-08:
      "fixed bugs" test-xsh_create_master_dark.c test-xsh_create_master_bias.c
      "fixed bug computation mean med std in window" xsh_data_pre.c

      "changes to reflex xsh_create_master_bias API change" test-xsh_create_master_bias.c test-xsh_create_master_dark.c
      "added xsh_parameters_ron_dark_create xsh_parameters_prescan_create xsh_parameters_overscan_create xsh_parameters_ref_create xsh_parameters_ron_create xsh_parameters_fpn_create xsh_parameters_hot_cold_pix_create  and corresponding parameters structures"  xsh_parameters.h xsh_parameters.c
      "using create function for params definitions" xsh_mbias.c xsh_mdark.c

Andrea-17-07-08:
       "separate master creation from qc generation functionality for dark and bias frames" xsh_create_master.c
       "added xsh_pre_median_mean_stdev_window" xsh_data_pre.h
       "added xsh_pre_median_mean_stdev_window" xsh_data_pre.c
       "change API" xsh_create_master_bias xsh_create_master_dark" xsh_drl.h
       "change API xsh_create_master_bias xsh_create_master_dark" xsh_drl.h
       "change API xsh_create_master_bias xsh_create_master_dark" xsh_drl.h
       "change API xsh_create_master_bias xsh_create_master_dark" xsh_drl.h
       "added XSH_QC_RON_ERR XSH_QC_FPN XSH_QC_FPN_ERR" xsh_pfits_qc.h
       "added ESO QC RON & ESO QC CRRATE" xsh_qc_definition.h
       "Making a clean mean instead of a median" xsh_remove_crh_multi.c
       "added xsh_utils_image.h xsh_utils_image.c" xsh_utils_image.h xsh_utils_image.c Makefile.am
       "added RON & FPN computation" xsh_mbias.c
       "added RON & FPN computation" xsh_mdark.c


Laurent-17-07-08:
	xsh_remove_crh_single.c: Added output frame file name as argument.
	 Now creates a frame (type XSH_PRE) after "replacement of CRH by
	 the median of surrounding pixels.
	 Added QC parameters NCRH, CRRATE (and CRH.AVG = NCRH !)
	xsh_drl.h: modified prototype of xsh_remove_crh_single.
	xsh_respon_uvb_vis.c: changed call to xsh_remove_crh_single.
	xsh_scired_slit_stare.c: idem
	xsh_scired_slit_nod.c: idem
	test-xsh_rmove_crh_single.c: idem. Added two parameters:
	   --iter=<nb-of-iteration>
	   --arm=NIR/UVB/VIS
	
Laurent-16-07-08:
	xsh_parameters.c/h: Added 'number of iteration' to remove_crh
	  parameter structure.
	recipes/xsh_scired_slit_nod.c: Fixed error (xsh_remove_crh_single
	  was never executed)
	xsh_rectify.c: Fixed a bug (typo)

Laurent-15-07-08:
	xsh_ired_slit_nod.c: Added creation of products (1D and 2)
	xsh_localize.c: Fixed a bug

Andrea-15-07-08:
        "added xsh_imagelist_collapse_sigclip_iter_create() to do a clean mean with ks clip on a list of frames" xsh_utils.c
        "added xsh_imagelist_collapse_sigclip_iter_create() to do a clean mean with ks clip on a list of frames" xsh_utils.h
Laurent-11-07-08:
	xsh_badpixelmap.h: Added QFLAG_OUT_OF_NOD (pixels that are not in
	 the rectified image after shifting)
	xsh_data_instrument.c: Added function "xsh_instruent_duplicate"
	xsh_data_instrument.h: Added #define for arc seconds per pixel
	 (one per arm) XSH_ARCSEC_arm. Values taken from the design report.
	xsh_data_pre.c[xsh_pre_create]: added a test on the 'value' of 
	 Bias data image pointer. If == (cpl_image *)-1, then dont use
	 bias data (instead of former "XSH_ASSURE_NOT_NULL")
	xsh_prepare.c: if mbias == (cpl_frame *)-1 then see above.
	xsh_data_rec.c/h: added 2 functions: xsh_data_rec_list_duplicate and
	 xsh_rec_get_nod_kw [retrieve the expected keywords relative to
	 the nodding shifts]
	xsh_drl.h: Modified prototype for xsh_rectify,
	 xsh_shift_rectified. Added prototype xsh_combine_nod.
	xsh_localization.c: Added usage of parameter "localize_nod_step"
	 to avoid searching to localize too far around the
	 position. Should use the Nodding KW.
	xsh_parameters.c/h: added parameters
	 'combine-nod-use-localization', 'localize-nod-step'
	xsh_pfits.c/h: Added functions to retrieve Keywords relative to
	 nodding: 'xsh_pfits_get_nod_jitterwidth',
	 'xsh_pfits_get_nod_nodthrow', 'xsh_pfits_get_nod_reloffset' and
	 'xsh_pfits_get_nod_cumoffset'
	xsh_rectify.c: Added shifting functions "xsh_shift_rectify",
	"shift_with_localization" and "shift_with_kw".
	xsh_subtract.c[xsh_subtract_background]: Added the file name to
	 the arguments of the function.
	xsh_subtract_sky_nod.c: updated (running version)
	tests/Makefile.am: added test_xsh_combine_nod (preliminary)
	tests/test-xsh_localize_obj.c: Added a test on hand made frames if
	 no parameters passed.
	tests/test-xsh_rectify.c: updated call to xsh_rectify function
	tests/test-xsh_subtract_background.c: idem
	tests/test-xsh_subtract_sky_nod.c: added/suppressed messages
	recipes/xsh_mflat.c: adapted call to xsh_subtract_background, etc
	recipes/xsh_respon_uvbvis.c: idem
	recipes/xsh_scired_slit_stare.c: idem
	recipes/xsh_scired_slit_nod.c: new version, including
	 rectification, shifting and combine
	xsh_combine_nod.c: New module, including xsh_combine_nod function.
	xsh/Makefile.am: Added xsh_combine_nod.
	
Andrea-08-07-08:
"added XSH_MATH_SQRT_2 to fix compiler error" xsh_opt_extract.c
"fixed seg fault using test-xsh_subtract_sky_single" xsh_subtract_sky_single.c
"provide more useful messages in case of failure" xsh_startup.c

Laurent-03-07-08:
	xsh_follow_arclines.c: Added the calculation of COR_Y as
	difference between THEoretical map position and Wave solution
	position of each line
	
Laurent-02-07-08:
	xsh_data_arclist.c: Fixed a bug in xsh_arclist_clean_from_list
	that minimises dramatically the produced clean arc line list 
	(abd the QC parameter QC.NLINECTA_CLEAN). Looks more reasonnable now.
	
Andrea-30-06-08:
"Added new distortion coeffs and redefined central pinhole" xsh_model_metric.c
"Added new distortion coeffs" xsh_model_io.c
"Added new distortion coeffs and redefined central pinhole" xsh_model_kernel.c
"Added new distortion coeffs" xsh_model_kernel.h
"Added new distortion coeffs" xsh_model_kernel.h
"redefined central pinhole" xsh_model_anneal.c
"code for generating line lists" xsh_model_compute.c

Andrea-30-06-08:
"added QC RON to mbias section" xsh_qc_definition.h
"made public irplib_flux_get_bias_window xsh_detmon_build_synthetic xsh_detmon_ronbias_histo_reduce" xsh_detmon.h xsh_detmon.c
xsh_detmon_lg.ccvs ci -m "added debugging info"  xsh_detmon_lg.c
"added debugging info"  xsh_detmon_lg.c
"added detmon RON compuation" xsh_mbias.c

Andrea-11-06-08:
"added check on fpn range" xsh_mbias.c
"we need now just one input cfg frame" xsh_startup.c
Andrea-10-06-08:
"added XSH_MODEL_GUESS_XY_arm" xsh_dfs.h
"renamed factor->peack_factor and made XSH_MODEL_GUESS_XY product arm dependent" xsh_startup.c

"Fixed bug UVB-VIS data reduction", xsh_lingain.c
added xsh_lingain recipe
updated configure.ac to 0.2.0
"added check on poly dimension for robustness, in case the line guess table cover more orders than the order table" xsh_startup.c
"added to CVS" xsh_lingain.c
"added xsh_lingain.c" Makefile.am
"added xsh_parameterlist_duplicate()" xsh_utils.c
"added xsh_parameterlist_duplicate()" xsh_utils.h
"added defines for lingain recipe" xsh_dfs.h
"updated module to latest version" xsh_detmon_lg.h
"updated module to latest version" xsh_detmon_lg.c
"updated" xsh_detmon.h xsh_detmon.c

Laurent-06-06-08:
	xsh_mdark.c  Inserted include file "xsh_pfits.h" (suppresses some
	  wanings)

Andrea -06-06-08:
"products filenames, except in NIR, get the binning" xsh_compute_noise_map.c
"products filenames, except in NIR, get the binning" xsh_create_master.c
"BIAS_SUBTRACT filename get the binning" xsh_subtract.c
"added binning in filename products except in NIR" xsh_mdark.c
Andrea -05-06-08:
"removed crh_list from products and added binning in filenames" xsh_mbias.c
"updated bin values in FITS header of product" xsh_util_ima_rebin.c

"demoted to xsh_msg_debug warning on improperly expected QC parameter possibly missing" xsh_paf_save.c

Laurent-05-06-08:
	xsh_detect_continuum.c  Collapsed the 2 ASCII files (orderpos.dat
	  and ordertbl.dat) into one single 'orderpos.dat' housing a 5th
	  column: X position calculated from the computed order table
	xsh_data_wavemap.c:  Fixed a bug inducing a crash of xsh_2dmap
	  recipe in case of not enough data to make the fit.
	  Adapted to new format of wave map frame: single image (type
	  DOUBLE), in PRE coordinates
	xsh_subtract_sky_single.c  Same comment
	xsh_date_pre.c   Suppressed obsolete function
	 'xsh_pre_wavemap_create'
	
Andrea-04-06-08:
"shorten lines and removed temporary file crh_list.fits if keep-temp='no'" xsh_linear.c
"clarified input params and removed temporary products if keep-temp='no'" xsh_mbias.c
"clean temporary producs if keep-temp='no'" xsh_mdark.c
"reduced static checks warning report" xsh_model_compute.c
"cleaned" xsh_startup.c
"reduced static checks warnings" xsh_util_genTHEtab.c
"reduced static checks warnings" xsh_util_genconfig.c
"reduced static checks warnings" xsh_util_ima_arith.c
"reduced static checks warnings" xsh_util_ima_getextno.c
"reduced static checks warnings" xsh_util_ima_rebin.c
"using xsh_frame_product() and set bpmapFname as product to be removed if keep-tem='no'" xsh_compute_linearity.c
"make noisy_name arm dependent and set that product to be cleaned if keep-temp='no'" xsh_compute_noise_map.c

Andrea-03-06-08:
"made PRO.CATG arm dependent for XSH_BP_MAP_HP and NOISY_PIXEL_MAP" xsh_compute_noise_map.c
"added XSH_NOISY_MAP_arm" xsh_dfs.h
"added fixed pattern noise computation" xsh_mbias.c
"fixed product file names setting proper arm extension" xsh_mdark.c

Andrea-02-06-08:
"fixed mem leaks" xsh_linear.c
"fixed mem leaks, added xsh_mbias_get_hot_cold_pixs" xsh_mbias.c
"fixed mem leaks, use xsh_frame_product" xsh_mdark.c
"fixed mem leaks" xsh_startup.c
"added and used xsh_frame_product" xsh_dfs.c
"added xsh_frame_product() xsh_add_product_imagelist() XSH_CRH_LIST_arm" xsh_dfs.h
"fixed mem leaks" xsh_remove_crh_multi.c
"added QC keys for mbias" xsh_qc_definition.h
"fixed mem leaks" xsh_model_io.c
"fixed mem leaks" xsh_model_kernel.c
"fixed mem leaks" xsh_model_metric.c


Andrea-30-05-08:
"fixed typo saving hpix_frm and allow data reduction of less than 3 frames" xsh_mbias.c
Laurent-29-05-08:
	xsh/xsh_detect_continuum.c Fixed a bug: the polynomial degree used
	 in the final order table computation was the degree of the input
	 guess order table, not the one passed as parameter to the recipe
	 xsh_orderpos.
	
Andrea-29-05-08: 
diff -r1.51 xsh_mbias.c "added hot/cold pix map"
diff -r1.64 xsh_mdark.c "put back my comments to remind why we do not compute noise map on UVB/VIS"
diff -r1.36 xsh_model_compute.c "put back function prefix naming conventions (fixed static checks warnings)"
diff -r1.17 xsh_startup.c "fixed compiler warnings"
diff -r1.54 Makefile.am "added xsh_fdetmon_body.h"
diff -r1.38 xsh_compute_linearity.c "lamp status value is a boolean, not a string"
diff -r1.95 xsh_data_pre.c "cleaned output"
diff -r1.68 xsh_dfs.h "added XSH_CPIX_MAP* and XSH_HPIX_MAP*"
diff -r1.45 xsh_model_kernel.c "fixed compiler warnings"
diff -r1.17 xsh_model_metric.c "fixed compiler warnings"
diff -r1.50 xsh_pfits.c "redefined XSH_LAMP_ON_OFF to work on SINFONI data"
diff -r1.53 xsh_pfits.h "redefined XSH_LAMP_ON_OFF to work on SINFONI data"
diff -r1.2 xsh_ppm.c "fixed compiler warnings"

Laurent-28-05-08:
	xsh/xsh_compute_noise_map Creates a frame (single image) as a Bad
	 pixel map containing only Hot Pixels
	recipes/xsh_mdark.c Same comment. If NIR AND bp_output=true, then
	 the hot pixel map is saved as a product (tag=BP_HP_MAP_NIR)
	xsh/xsh_drl.h Modified prototype of xsh_compute_noise_map function
	xsh/xsh_paf_save.c  Implemented usage of PRO.CATG to check if QC
	 should or not be written to the propertylist
	xsh/xsh_qc_definition.h  Updated some PRO.CATG entries (still many
	 to do)
	recipes/xsh_scired_slit_stare.c  Added a test on
	extract-method. If
	 extract-methode=localization, make localize-object, dont make
	 if 'full' or 'manual'.
	

Andrea-27-05-08:
added xsh_util_ima_getextno.c

diff -r1.25 ChangeLog
diff -r1.27 Makefile.am
diff -r1.43 xsh_linear.c
diff -r1.50 xsh_mbias.c
diff -r1.60 xsh_mdark.c
diff -r1.55 xsh_mflat.c
diff -r1.14 xsh_model_anneal.c
diff -r1.34 xsh_model_compute.c
diff -r1.4 xsh_scired_slit_nod.c
diff -r1.29 xsh_scired_slit_stare.c
diff -r1.16 xsh_startup.c
diff -r1.66 xsh_dfs.h
diff -r1.81 xsh_drl.h
diff -r1.3 xsh_model_arm_constants.h
diff -r1.17 xsh_model_io.c
diff -r1.42 xsh_model_kernel.c
diff -r1.3 xsh_model_ref_ind.h
diff -r1.27 xsh_qc_definition.h
diff -r1.83 xsh_remove_crh_multi.c
diff -r1.70 xsh_utils.c
diff -r1.49 xsh_utils.h

Laurent-25-05-08:
	Added test for xsh_subtract_sky_nod (and changed
	  xshp/xsh/tests/Makefile.am accordingly)
	Fixed pb in xshp/xsh/tests/test-xsh_detect_continuum.c: was no
	  longer compatible with UVB frames, cahnged to VIS frame.
	Fixed bug in xshp/xsh/xsh_data_wavemap.c
	Added 2 output ascii files in xshp/xsh/xsh_detect_continuum.c
	xsh/xsh_data_pre.c Changed cuts in NIR preparation

Andrea-23-05-08:
Fixing several warnings from static checks, compiler. 
Changed name of "Multiple of sigma in kappa-sigma clip" from 'sigma' to 'kappa'.

diff -r1.42 xsh_linear.c
diff -r1.60 xsh_mdark.c
diff -r1.13 xsh_model_anneal.c
diff -r1.33 xsh_model_compute.c
diff -r1.29 xsh_orderpos.c
diff -r1.11 xsh_respon_uvbvis.c
diff -r1.3 xsh_scired_slit_nod.c
diff -r1.28 xsh_scired_slit_stare.c
diff -r1.14 xsh_startup.c
diff -r1.1 xsh_util_ima_arith.c
diff -r1.33 xsh_wavecal.c
diff -r1.1 xsh_detmon.h
diff -r1.1 xsh_detmon_lg.h
diff -r1.3 xsh_fit_body.h
diff -r1.1 xsh_hist.c
diff -r1.1 xsh_hist.h
diff -r1.1 xsh_irplib_utils.h
diff -r1.13 xsh_model_anneal.c
diff -r1.2 xsh_model_cputime.c
diff -r1.2 xsh_model_cputime.h
diff -r1.41 xsh_model_kernel.c
diff -r1.19 xsh_model_kernel.h
diff -r1.15 xsh_model_metric.c
diff -r1.5 xsh_model_metric.h
diff -r1.4 xsh_model_r250.c
diff -r1.2 xsh_model_r250.h
diff -r1.4 xsh_model_randlcg.c
diff -r1.5 xsh_model_randlcg.h
diff -r1.5 xsh_model_sa.c
diff -r1.3 xsh_model_sa.h
diff -r1.67 xsh_parameters.c
diff -r1.1 xsh_ppm.c
diff -r1.1 xsh_ppm.h
diff -r1.1 xsh_spectrum.h


Andrea-21-05-08:
cvs ci -m "changes to extract proper portion of NIR detector" xsh_data_pre.c
Andrea-20-05-08:
       added xsh/xsh_ppm.c|h (to remove dependency from CPL head)
       updated accordingly xsh_startup.c
Andrea-19-05-08:
xsh_startup.c: "changed default sep_ph to use cfg file for THE map predictions"
xsh_startup.c:   "a bit more robust pattern matching (for VIS). Input parameters renaming (to clarify domain)" 
xsh_dfs.c:       "added xsh_find_model_config_opt" 
xsh_dfs.h:       "added xsh_find_model_config_opt" 
xsh_model_io.c:  "Support XSH_MODEL_CONFIG_OPT_arm" 
xsh_model_kernel.c: "Support XSH_MODEL_CONFIG_OPT_arm, added RESIDX/Y in residual table from annealing" 
xsh_utils_table.h|c     "added xsh_sort_table_1/2" 
xsh_remove_crh_multi.c: "added some comments on possible changes to do" 

Laurent-18-05-08:
	xsh/xsh_order_table_from_fmtchk.c Cleanup (suppressed obsolete
	  #if)
	  Now seems to run correctly.
	 I JUST FORGOT TO COMMIT THIS FILE THE 16/05 !!!!!
	 Explaining the problems of Andrea, and the reason of the commits
	 below
	xsh/xsh_drl.h  Cleanup (suppressed obsolete #if)
	xsh/xsh_detect_continuum.c Cleanup (suppressed obsolete #if)
	 The "#if defined(COMPUTE_ABS_ORDER)" have been reintroduced
	 because the new version of the function
	 "xsh_order_table_from_fmtchk" had not been commited.
	My apologies (specially to Andrea)
	
Laurent-16/05/08:
	xsh/xsh_data_instrument.h Added definitions of nb of orders, min
	 and max for each ARM and  added same entries in XSH_INSTRCONFIG
	 structure
	xsh/xsh_data_instrument.c Added filling of above entries in function
	 xsh_instrument_get_config
	xsh/xsh_data_spectralformat.h Added stuff to read DIST_PIXEL, LAMP and
	 position of center of orders (XDISP_CEN) columns from spectral format
	 table frame
	xsh/xsh_data_spectralformat.c Same as above + function to retrieve
	 XDISP_CEN array and LAMP value
	xsh/xsh_detect_continuum.c Cleanup (suppressed obsolete #if)
	xsh/xsh_dfs.c  Added xsh_instrument_get_config systematically in
	 function xsh_dfs_set_groups
	xsh/xsh_drl.h  Cleanup (suppressed obsolete #if)
	xsh/xsh_parameters.h   Added entry 'dist_order' in
	 xsh_detect_continuum_param structure
	xsh/xsh_parameters.c   Changed parameter names:
	    detect_continuum_fmtchk_window ==>
	      recoverformat_center_search_window_half_size
	    detect_continuum_fmtchk_step ==>
	      recoverformat_center_search_disp_step
	    detect_continuum_fmtchk_search_sn ==>
	      recoverformat_center_search_min_sn
	    detect_continuum_fmtchk_follow_sn ==>
	      recoverformat_center_search_min_contrast
          Added parameter ' recoverformat_center_search_dist_order'
	   (If 0, use the value in the header of spectral format
	   table frame, otherwise use this value. Default = 0 )
	xsh/xsh_pfits.h   Fixed name of keyword 'ESO PRO DIST PIXEL' (was
	  'ESO DIST PIXEL'
	recipes/xsh_orderpos.c Cleanup (suppressed obsolete #if)
	xsh/tests/test-xsh_detect_continuum.c Cleanup (suppressed obsolete
	 #if)

Laurent-15/05/08:
	xsh/xsh_data_wavemap.c Fixed bug when saving wavemap for NIR
	xsh/xsh_compute-noise_map.c Addes an ascii file "noisy_pixels.dat"
	 containing the list of noisy pixels (with
	 --debug-level=low/medium/debug)
	recipes/xsh_mdark.c  Fixed bug (no longer subtraction of ON/OFF
	 NIR frames)
	
Andrea-13/05/08:
       xsh/recipes/xsh_util_ima_rebin: to rebin data. usage 
       xsh_util_ima_rebin --binx=2 --biny=2 sof 
       where sof contains
       ORIGNAME.fits   (no tag)
       the recipe generates rebx2_reby2_ORIGNAME.fits 

Laurent-13/05/08:
	xsh/tests/test-xsh_rectify.c "Fixed segmentation fault"
	xsh/xsh_data_order.c: "Fixed bug in list_save when no slitlet
	polynomials"
	
Andrea-13/05/08:
      recipes/xsh_startup.c "added XM YM columns to resid table to log best annealing solution"  
      xsh/xsh_model_kernel.c: "added XM YM columns to resid table to log best annealing solution" (I dit it finally there as that is the core function for annealing)
Andrea-09/05/08:
      xsh/tests/Makefile.am :added xsh_startup
      recipes/xsh_linear.c: comment paf saving which gave error
      recipes/xsh_mbias.c: added xsh_ksigma_clip,
                                 xsh_ksigma_clip_double|float|int,
                                 xsh_imagelist_collapse_stdev_create,
                                 xsh_ronbias_master as derived by detmon
      recipes/xsh_mdark.c: added generation of noise map also in VIS-UVB
                           activated NIR. Removed duplicated bpmap saving.
                           Added check on bpmap existence before saving it.
      recipes/xsh_model_anneal.c: simplified handling recipe description
      recipes/xsh_predict.c: commented out XSH_ASSURE_NOT_ILLEGAL 
      recipes/xsh_startup.c: fixed several bugs which where preventing proper
                             correction of model line prediction to actual 
                             frame positioons. Now should work fine.

      recipes/xsh_utl_ima_arith.c: added to repository.
      xsh/xsh_data_pre.c: "added handling of XSH_RAW_IMA_SLIT_VIS|UVB and indicated lines of code where changes are needed (temporally commented out)"
      xsh/xsh_dfs.h: added handling of: 
          XSH_DARK_NIR_ON|OFF, 
          XSH_RAW_IMA_SLIT_VIS|UVB|NIR 
          XSH_RAW_IMA_IFU_VIS|UVB|VIS 
          XSH_MASTER_BP_MAP_VIS|UVB|NIR
          XSH_BP_MAP_HP_VIS|UVB|VIS
      xsh/xsh_crh_multi.c: "indicated place where CRHs are not properly stored: a new tempirary image is generated collecting all CRHs (mainly found at 1st iteration)"
      xsh/xsh_utils.c|h: added xsh_frameset_dump()

Andrea-30/04/08:
      Added pattern matching (to be tested)
Andrea-29/04/08:
       Fixed compilation warnings:
 xsh_model_anneal.c
 xsh_model_compute.c
 xsh_scired_slit_nod.c
 xsh_startup.c
 xsh_detect_arclines.c
 xsh_model_anneal.c
 xsh_model_kernel.c
 xsh_model_metric.c
 xsh_plot.c
 xsh_plot.h
 xsh_spectrum.c

added line match based on a 2D Gaussian fit" xsh_startup.c

Andrea-28/04/08:
       Added cpl_image_fit_gaussian n xsh_fit.h|c (ported by CPL4.0)
Andrea-25/04/08:
       Updated xsh_startup (line matching still not working)
Andrea-24/04/08:
	Fixed a few compilation warnings (mainly on *model*)
Andrea-15/04/08:
       Modified acinclude.m4 configure.ac recipes/Makefile.am and added m4macros/fftw.m4 to link to FFTW.
Andrea-14/04/08:
       Fixed problems on autocorrelation for xsh_linearity
Andrea-12/04/08:
       recipes: xsh_startup-fixed NULL in tables
       xsh: xsh_model_metric.c: aligned final anneal results and added info
Andrea-11/04/08:
       xsh:xsh_hist.h xsh_spectrum.h xsh_plot.h xsh_hist.c xsh_spectrum.c xsh_plot.c
       recipes: xsh_startup.c (extracted spectrum, search line peack, anneal model cfg)
                xsh_linear (added detmon-gain).

Corresponding recipes sof examples looks like:
amodigli@pc014007$ cat xsh_startup.sof
xs_vis_def.fits.raw XSH_CALPRO_MODEL_CONFIG_VIS
xs_vis_def_dc_fix.fits XSH_MODEL_CONFIG_OPEN_VIS
xs_vis_ThAr_Ar_w50_exp0.fits XSH_MODEL_COMPUTE_WAVE_LIST_VIS
ORDER_TAB_CENTR_VIS.fits ORDER_TAB_CENTR_VIS
/data3/xsh/xsh_demo/data/vis/drl015/071205_VIS_ThAr_05pin_RM1_30s.fits   FMTCHK_VIS
/data3/xsh/xsh_demo/data/vis/drl015/MASTER_BIAS_VIS_1x1.fits             MASTER_BIAS_VIS
/data3/xsh/xsh_demo/data/vis/drl015/MASTER_DARK_VIS_1x1.fits             MASTER_DARK_VIS

This is not yet completed (the line position measure on the frame need still to be improved) neither tested

amodigli@pc014007$ cat xsh_linear.sof
UVES_BLUE_bs1.fits  BIAS_UVB
UVES_BLUE_bs2.fits  BIAS_UVB
UVES_BLUE_bs3.fits  BIAS_UVB
UVES_BLUE_bs4.fits  BIAS_UVB
UVES_BLUE_bs5.fits  BIAS_UVB
UVES_BLUE_ff10.fits LINEARITY_UVB
UVES_BLUE_ff11.fits LINEARITY_UVB
UVES_BLUE_ff12.fits LINEARITY_UVB
UVES_BLUE_ff13.fits LINEARITY_UVB
UVES_BLUE_ff14.fits LINEARITY_UVB
UVES_BLUE_ff15.fits LINEARITY_UVB
UVES_BLUE_ff16.fits LINEARITY_UVB
UVES_BLUE_ff17.fits LINEARITY_UVB
UVES_BLUE_ff18.fits LINEARITY_UVB
UVES_BLUE_ff3.fits LINEARITY_UVB
UVES_BLUE_ff4.fits LINEARITY_UVB
UVES_BLUE_ff5.fits LINEARITY_UVB
UVES_BLUE_ff6.fits LINEARITY_UVB
UVES_BLUE_ff7.fits LINEARITY_UVB
UVES_BLUE_ff8.fits LINEARITY_UVB
UVES_BLUE_ff9.fits LINEARITY_UVB

This may fail (linear part) on UVES-RED and SINFONI data (due to FITS extension)
Andrea-09/04/08:
       xsh: (library)
       xsh_dfs.c|h
       Added: xsh_print_rec_status, xsh_frameset_extract
       xsh_error.h
       Added: cknull, cknull_nomsg
       xsh_model_anneal.h.c
       changed interface xsh_model_anneal_reduce
	xsh_model_io.h|c
	Support of XSH_CALPRO_MODEL_CONFIG_arm
	xsh_model_kernel.c: reflect change interface on call 
	  of xsh_model_anneal_reduce
        added:
        xsh_hist.c xsh_irplib_utils.c xsh_detmon_lg.c xsh_detmon.c 
        xsh_hist.h xsh_irplib_utils.h xsh_detmon_lg.h xsh_detmon.h

	recipes:
	xsh_model_anneal.c, xsh_model_compute.c: use of XSH_CALPRO_MODEL_CONFIG_arm
        NB: remember to set proper value of --arm parameter at the c9ommand line using this recipes
Andrea-04/04/08:
	Fixed seg fault xsh_mflat
	
	For cleaness changed XSH_CALPRO_MODEL_CONFIG, XSH_MODEL_WAVE_LIST 
	to include _arm prefix and be consistent with other recipes.

	added xsh_startup (first version)
	Input is:
	/data3/xsh/physmod/InputData/ModelParameterConfigurationFiles/xs_vis_def.fits.raw XSH_CALPRO_MODEL_CONFIG_VIS
/data3/xsh/physmod/line_lists/xs_vis_ThAr_Ar_w50_exp0.fits XSH_MODEL_COMPUTE_WAVE_LIST_VIS
ORDER_TAB_CENTR_VIS.fits ORDER_TAB_CENTR_VIS
/data3/xsh/xsh_demo/data/vis/drl015/071205_VIS_ThAr_05pin_RM1_30s.fits   FMTCHK_VIS
/data3/xsh/xsh_demo/data/vis/drl015/MASTER_BIAS_VIS_1x1.fits             MASTER_BIAS_VIS
/data3/xsh/xsh_demo/data/vis/drl015/MASTER_DARK_VIS_1x1.fits             MASTER_DARK_VIS




Andrea-20/03/08
Performed a number of minor fixes reported in the comments to DRL 0.15: 
-all calib recipes: 
	fix small typos (mainly related to order table TAG 
	changes recently defined but not always reflected
        in man-page, fixed some static check warnings) 
	1s indiated in DRL0.15 report

Changed:
diff -r1.7 xsh_data_resid_tab.h
diff -r1.19 xsh_data_the_map.c
diff -r1.10 xsh_data_the_map.h
diff -r1.26 xsh_model_kernel.c
With the following purpose:
-when a column name is of kind 'prefix suffix' it is preferrable to have 'prefix_suffix' (as some data analysis software, like MIDAS, otherwhise have problems). Example 'Slit position'-->'Slit_position' in RESID_TAB_SLIT_arm
same for 'detector x'-->'detector_x' and 'detector y'-->'detector_y' (FITS file involved is THE map)


Changed:
diff -r1.67 xsh_utils.c
diff -r1.46 xsh_utils.h
-Added xsh_free_table



	
	
